unit burgertime_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     main_engine,controls_engine,ay_8910,gfx_engine,rom_engine,
     pal_engine,sound_engine,misc_functions,m6502;

procedure Cargar_btime;
procedure principal_btime;
function iniciar_btime:boolean;
procedure cerrar_btime;
procedure reset_btime;
//Main CPU
function getbyte_btime(direccion:word):byte;
procedure putbyte_btime(direccion:word;valor:byte);
//Sound CPU
function getbyte_snd_btime(direccion:word):byte;
procedure putbyte_snd_btime(direccion:word;valor:byte);
procedure btime_sound_update;

const
        btime_rom:array[0..4] of tipo_roms=(
        (n:'aa04.9b';l:$1000;p:$c000;crc:$368a25b5),(n:'aa06.13b';l:$1000;p:$d000;crc:$b4ba400d),
        (n:'aa05.10b';l:$1000;p:$e000;crc:$8005bffa),(n:'aa07.15b';l:$1000;p:$f000;crc:$086440ad),());
        btime_char:array[0..6] of tipo_roms=(
        (n:'aa12.7k';l:$1000;p:$0000;crc:$c4617243),(n:'ab13.9k';l:$1000;p:$1000;crc:$ac01042f),
        (n:'ab10.10k';l:$1000;p:$2000;crc:$854a872a),(n:'ab11.12k';l:$1000;p:$3000;crc:$d4848014),
        (n:'aa8.13k';l:$1000;p:$4000;crc:$8650c788),(n:'ab9.15k';l:$1000;p:$5000;crc:$8dec15e6),());
        btime_tiles:array[0..3] of tipo_roms=(
        (n:'ab00.1b';l:$800;p:$0000;crc:$c7a14485),(n:'ab01.3b';l:$800;p:$800;crc:$25b49078),
        (n:'ab02.4b';l:$800;p:$1000;crc:$b8ef56c3),());
        btime_snd:tipo_roms=(n:'ab14.12h';l:$1000;p:$e000;crc:$f55e5211);
        btime_tiles_mem:tipo_roms=(n:'ab03.6b';l:$800;p:$0;crc:$d26bc1f3);

implementation

var
  memoria_dec:array[0..$ffff] of byte;
  haz_nmi,bg_cambiado:boolean;
  sound_latch,haz_vb,scroll_bg:byte;
  video_ram,color_ram:array[0..$3ff] of byte;
  mem_tiles:array[0..$7ff] of byte;

procedure Cargar_btime;
begin
llamadas_maquina.iniciar:=iniciar_btime;
llamadas_maquina.bucle_general:=principal_btime;
llamadas_maquina.cerrar:=cerrar_btime;
llamadas_maquina.reset:=reset_btime;
llamadas_maquina.fps_max:=57.444853;
end;

function iniciar_btime:boolean;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..15] of dword=(16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7,
			0, 1, 2, 3, 4, 5, 6, 7);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
var
    memoria_temp:array[0..$5fff] of byte;
begin
iniciar_btime:=false;
iniciar_audio(false);
//Principal
p_final[0].x:=240;
p_final[0].y:=240;
//Fondo
p_final[1].x:=256;
p_final[1].y:=256;
//Chars
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].trans:=true;
//Final
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].final_mix:=true;
iniciar_video;
//Main CPU
main_m6502:=cpu_m6502.create(1500000,272,TCPU_M6502);
main_m6502.change_ram_calls(getbyte_btime,putbyte_btime);
//Sound CPU
snd_m6502:=cpu_m6502.create(500000,272,TCPU_M6502);
snd_m6502.change_ram_calls(getbyte_snd_btime,putbyte_snd_btime);
snd_m6502.init_sound(btime_sound_update);
//Sound Chip
AY8910_0:=ay8910_chip.create(1500000,1);
AY8910_1:=ay8910_chip.create(1500000,1);
//cargar roms
if not(cargar_roms(@memoria[0],@btime_rom[0],'btime.zip',0)) then exit;
copymemory(@memoria_dec[0],@memoria[0],$10000);
//cargar roms audio
if not(cargar_roms(@mem_snd[0],@btime_snd,'btime.zip',1)) then exit;
//Cargar chars
if not(cargar_roms(@memoria_temp[0],@btime_char[0],'btime.zip',0)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=2*1024*8*8;
des_gfx.pos_planos[1]:=1024*8*8;
des_gfx.pos_planos[2]:=0;
des_gfx.bit_pixel:=3;
des_gfx.banks:=0;
des_gfx.long_sprites:=8*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,true);
//sprites
init_gfx(1,16,16,256);
gfx[1].trans[0]:=true;
des_gfx.pos_planos[0]:=2*256*16*16;
des_gfx.pos_planos[1]:=256*16*16;
des_gfx.pos_planos[2]:=0;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//Cargar tiles
if not(cargar_roms(@memoria_temp[0],@btime_tiles[0],'btime.zip',0)) then exit;
init_gfx(2,16,16,64);
des_gfx.pos_planos[0]:=2*64*16*16;
des_gfx.pos_planos[1]:=64*16*16;
des_gfx.pos_planos[2]:=0;
convert_gfx(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
if not(cargar_roms(@mem_tiles[0],@btime_tiles_mem,'btime.zip',1)) then exit;
//final
reset_btime;
iniciar_btime:=true;
end;

procedure cerrar_btime;
begin
main_m6502.destroy;
snd_m6502.destroy;
AY8910_0.Free;
AY8910_1.Free;
close_audio;
close_video;
end;

procedure reset_btime;
begin
main_m6502.reset;
snd_m6502.reset;
AY8910_0.reset;
AY8910_1.reset;
in0:=$ff;
in1:=$ff;
in2:=$3f;
haz_vb:=$3f;
sound_latch:=0;
haz_nmi:=false;
bg_cambiado:=true;
scroll_bg:=$10;
end;

procedure update_video_btime;inline;
const
  pant_pos:array[0..7] of byte=(1,2,3,0,5,6,7,4);
var
  f,nchar:word;
  x,y:word;
  atrib:byte;
begin
if bg_cambiado then begin
 if (scroll_bg and $10)<>0 then begin
  for f:=0 to $ff do begin
    x:=f and $f;
    y:=f shr 4;
    nchar:=mem_tiles[pant_pos[scroll_bg and $7]*$100+f];
    put_gfx(x*16,y*16,nchar,8,1,2);
  end;
 end;
 bg_cambiado:=false;
end;
actualiza_trozo(0,0,256,256,1,0,0,256,256,3);
for f:=0 to $3ff do begin
 if gfx[0].buffer[f] then begin
    x:=f and $1f;
    y:=f shr 5;
    nchar:=video_ram[f]+((color_ram[f] and $3) shl 8);
    put_gfx_trans(x*8,y*8,nchar,0,2,0);
    gfx[0].buffer[f]:=false;
 end;
end;
actualiza_trozo(0,0,256,256,2,0,0,256,256,3);
//Sprites
for f:=0 to 7 do begin
  atrib:=video_ram[f*$80];
  if (atrib and 1)<>0 then begin
    x:=240-video_ram[$40+(f*$80)];
    y:=video_ram[$60+(f*$80)]-1;
    nchar:=video_ram[$20+(f*$80)];
    put_gfx_sprite(nchar,0,(atrib and 2)<>0,(atrib and 4)<>0,1);
    actualiza_gfx_sprite(x,y,3,1);
  end;
end;
actualiza_trozo_final(8,8,240,240,3);
end;

procedure eventos_btime;
begin
if event.arcade then begin
  if arcade_input.right[0] then in0:=in0 and $fe else in0:=in0 or 1;
  if arcade_input.left[0] then in0:=in0 and $fd else in0:=in0 or 2;
  if arcade_input.up[0] then in0:=in0 and $fb else in0:=in0 or 4;
  if arcade_input.down[0] then in0:=in0 and $f7 else in0:=in0 or 8;
  if arcade_input.but0[0] then in0:=in0 and $ef else in0:=in0 or $10;
  if arcade_input.coin[0] then begin
      in2:=(in2 or $40);
      main_m6502.pedir_nmi:=PULSE_LINE;
  end else in2:=(in2 and $bf);
  if arcade_input.coin[1] then begin
      in2:=(in2 or $80);
      main_m6502.pedir_nmi:=PULSE_LINE;
  end else in2:=(in2 and $7f);
  if arcade_input.start[0] then in2:=in2 and $fe else in2:=in2 or $1;
  if arcade_input.start[1] then in2:=in2 and $fd else in2:=in2 or $2;
end;
end;

procedure principal_btime;
var
  f:word;
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_m6502.tframes;
frame_s:=snd_m6502.tframes;
while EmuStatus=EsRuning do begin
 for f:=0 to 271 do begin
  //Main CPU
  main_m6502.run(trunc(frame_m));
  frame_m:=frame_m+main_m6502.tframes-main_m6502.contador;
  //Sound CPU
  snd_m6502.run(trunc(frame_s));
  frame_s:=frame_s+snd_m6502.tframes-snd_m6502.contador;
  if ((f and 8)<>0) then if haz_nmi then snd_m6502.pedir_nmi:=ASSERT_LINE;
  if (((f+1) and 8)<>0) then if haz_nmi then snd_m6502.clear_nmi;
  case f of
    247:begin
          haz_vb:=haz_vb or $80;
          update_video_btime;
        end;
    271:haz_vb:=haz_vb and $7f;
  end;
 end;
 eventos_btime;
 video_sync;
end;
end;

procedure desencriptar_btime;inline;
var
  act_pc,old_pc:word;
  temp_r:preg_m6502;
begin
//Para desencriptar la ROM hay que tener en cuenta dos cosas, la primera
//solo despues de un opcode de escritura y si el opcode esta en la direccion
//cuya mascara es $0104 se debe desencriptar. Hay que tener cuidado con el
//salto a subrutina (opcode $20) que tambien puede ir encriptado.
temp_r:=main_m6502.get_internal_r;
act_pc:=temp_r.pc;
old_pc:=temp_r.old_pc;
if memoria_dec[old_pc]=$20 then act_pc:=memoria[old_pc+1]+256*memoria[old_pc+2];
if ((act_pc and $0104)=$0104) then memoria_dec[act_pc]:=bitswap8(memoria[act_pc],6,5,3,4,2,7,1,0);
end;

function getbyte_btime(direccion:word):byte;
begin
case direccion of
  0..$7ff,$1000..$1fff,$b000..$ffff:getbyte_btime:=memoria_dec[direccion];
  $4000:getbyte_btime:=in0;
  $4001:getbyte_btime:=in1;
  $4002:getbyte_btime:=in2;
  $4003:getbyte_btime:=haz_vb;
  $4004:getbyte_btime:=$1f;
end;
end;

procedure cambiar_paleta(ncolor:byte);inline;
var
  color:tcolor;
  valor:byte;
begin
valor:=not(buffer_paleta[ncolor]);
color.r:=$21*(valor and 1)+$47*((valor shr 1) and 1)+$97*((valor shr 2) and 1);
color.g:=$21*((valor shr 3) and 1)+$47*((valor shr 4) and 1)+$97*((valor shr 5) and 1);
color.b:=0+$47*((valor shr 6) and 1)+$97*((valor shr 7) and 1);
set_pal_color(color,addr(paleta[ncolor]));
if ncolor<8 then fillchar(gfx[0].buffer[0],$400,1);
end;

procedure putbyte_btime(direccion:word;valor:byte);
var
  x,y,pos:word;
begin
memoria[direccion]:=valor;
memoria_dec[direccion]:=valor;
case direccion of
  $c00..$c0f:if buffer_paleta[direccion and $f]<>valor then begin
                  buffer_paleta[direccion and $f]:=valor;
                  cambiar_paleta(direccion and $f);
               end;
  $1000..$13ff:if video_ram[direccion and $3ff]<>valor then begin
                  video_ram[direccion and $3ff]:=valor;
                  gfx[0].buffer[direccion and $3ff]:=true;
               end;
  $1400..$17ff:if color_ram[direccion and $3ff]<>valor then begin
                  color_ram[direccion and $3ff]:=valor;
                  gfx[0].buffer[direccion and $3ff]:=true;
               end;
  //Hay un mirror del video y atributos, pero con las coordenadas
  //invertidas  ?????
  $1800..$1bff:begin
                  x:=(direccion and $3ff) shr 5;
                  y:=(direccion and $3ff) and $1f;
                  pos:=(y shl 5)+x;
                  if video_ram[pos]<>valor then begin
                    video_ram[pos]:=valor;
                    gfx[0].buffer[pos]:=true;
                  end;
               end;
  $1c00..$1fff:begin
                  x:=(direccion and $3ff) shr 5;
                  y:=(direccion and $3ff) and $1f;
                  pos:=(y shl 5)+x;
                  if color_ram[pos]<>valor then begin
                    color_ram[pos]:=valor;
                    gfx[0].buffer[pos]:=true;
                  end;
               end;
  $4003:begin
          sound_latch:=valor;
          snd_m6502.pedir_irq:=ASSERT_LINE;
        end;
  $4004:if scroll_bg<>valor then begin
          scroll_bg:=valor;
          //Si el fondo no esta activo, lo pinto de negro
          if (scroll_bg shr 2 and $10)=0 then fill_full_screen(1,0);
          bg_cambiado:=true;
        end;
end;
desencriptar_btime;
end;

function getbyte_snd_btime(direccion:word):byte;
begin
case direccion of
  0..$1fff:getbyte_snd_btime:=mem_snd[direccion and $3ff];
  $a000..$bfff:begin
                  getbyte_snd_btime:=sound_latch;
                  snd_m6502.pedir_irq:=CLEAR_LINE;
               end;
   $e000..$ffff:getbyte_snd_btime:=mem_snd[$e000+(direccion and $fff)];
end;
end;

procedure putbyte_snd_btime(direccion:word;valor:byte);
begin
if direccion>$dfff then exit;
case direccion of
    0..$1fff:mem_snd[direccion and $3ff]:=valor;
    $2000..$3fff:ay8910_0.Write(valor);
    $4000..$5fff:ay8910_0.Control(valor);
    $6000..$7fff:ay8910_1.Write(valor);
    $8000..$9fff:ay8910_1.Control(valor);
    $c000..$dfff:haz_nmi:=valor<>0;
end;
end;

procedure btime_sound_update;
begin
  ay8910_0.update;
  ay8910_1.update;
end;

end.
