unit cityconnection_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6809,ay_8910,ym_2203,main_engine,controls_engine,gfx_engine,
     rom_engine,pal_engine,sound_engine,qsnapshot;

function iniciar_citycon:boolean;
procedure Cargar_citycon;
procedure citycon_principal;
procedure reset_citycon;
procedure cerrar_citycon;
//Main CPU
function citycon_getbyte(direccion:word):byte;
procedure citycon_putbyte(direccion:word;valor:byte);
function citycon_porta:byte;
function citycon_portb:byte;
//SND CPU
function scitycon_getbyte(direccion:word):byte;
procedure scitycon_putbyte(direccion:word;valor:byte);
procedure citycon_sound_update;
//Save/load
procedure citycon_qsave(nombre:string);
procedure citycon_qload(nombre:string);

const
        citycon_rom:array[0..2] of tipo_roms=(
        (n:'c10';l:$4000;p:$4000;crc:$ae88b53c),(n:'c11';l:$8000;p:$8000;crc:$139eb1aa),());
        citycon_sonido:tipo_roms=(n:'c1';l:$8000;p:$8000;crc:$1fad7589);
        citycon_char:tipo_roms=(n:'c4';l:$2000;p:0;crc:$a6b32fc6);
        citycon_sprites:array[0..2] of tipo_roms=(
        (n:'c12';l:$2000;p:0;crc:$08eaaccd),(n:'c13';l:$2000;p:$2000;crc:$1819aafb),());
        citycon_tiles:array[0..4] of tipo_roms=(
        (n:'c9';l:$8000;p:0;crc:$8aeb47e6),(n:'c8';l:$4000;p:$8000;crc:$0d7a1eeb),
        (n:'c6';l:$8000;p:$c000;crc:$2246fe9d),(n:'c7';l:$4000;p:$14000;crc:$e8b97de9),());
        citycon_fondo:array[0..3] of tipo_roms=(
        (n:'c2';l:$8000;p:0;crc:$f2da4f23),(n:'c3';l:$4000;p:$8000;crc:$7ef3ac1b),
        (n:'c5';l:$2000;p:$c000;crc:$c03d8b1b),());

var
 fondo,soundlatch,soundlatch2:byte;
 scroll_x:word;
 lines_color_look:array[0..$ff] of byte;
 memoria_fondo:array[0..$dfff] of byte;
 cambia_fondo:boolean;

implementation

procedure Cargar_citycon;
begin
llamadas_maquina.iniciar:=iniciar_citycon;
llamadas_maquina.bucle_general:=citycon_principal;
llamadas_maquina.cerrar:=cerrar_citycon;
llamadas_maquina.reset:=reset_citycon;
llamadas_maquina.save_qsnap:=citycon_qsave;
llamadas_maquina.load_qsnap:=citycon_qload;
end;

function iniciar_citycon:boolean;
var
      f:word;
      memoria_temp:array[0..$17fff] of byte;
const
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 256*8*8+0, 256*8*8+1, 256*8*8+2, 256*8*8+3 );
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
  ps_x:array[0..7] of dword=(0, 1, 2, 3, 128*16*8+0, 128*16*8+1, 128*16*8+2, 128*16*8+3);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
            8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_citycon:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=240;
p_final[0].y:=224;
p_final[1].x:=1024;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[1].scroll.long_x:=1024;
p_final[1].scroll.max_x:=256;
p_final[1].scroll.mask_x:=1023;
p_final[2].x:=1024;
p_final[2].y:=256;
p_final[2].scroll:=p_final[1].scroll;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].final_mix:=true;
iniciar_video;
//Main CPU
main_m6809:=cpu_m6809.Create(2048000,1);
main_m6809.change_ram_calls(citycon_getbyte,citycon_putbyte);
//Sound CPU
snd_m6809:=cpu_m6809.Create(640000,1);
snd_m6809.change_ram_calls(scitycon_getbyte,scitycon_putbyte);
snd_m6809.init_sound(citycon_sound_update);
//Sound Chip
ym2203_0:=ym2203_chip.create(0,1250000,snd_m6809.numero_cpu,snd_m6809.clock,2);
ym2203_0.change_io_calls(citycon_porta,citycon_portb,nil,nil);
AY8910_0:=ay8910_chip.create(1250000,2);
//cargar roms
if not(cargar_roms(@memoria[0],@citycon_rom[0],'citycon.zip',0)) then exit;
//Cargar Sound
if not(cargar_roms(@mem_snd[0],@citycon_sonido,'citycon.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@citycon_char,'citycon.zip',1)) then exit;
init_gfx(0,8,8,256);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=4;
des_gfx.pos_planos[1]:=0;
des_gfx.bit_pixel:=2;
des_gfx.banks:=0;
des_gfx.long_sprites:=8*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@citycon_tiles[0],'citycon.zip',0)) then exit;
init_gfx(1,8,8,3072);
des_gfx.banks:=12;
des_gfx.bit_pixel:=4;
for f:=0 to $b do begin
  des_gfx.pos_planos[0]:=4+($1000*f*8);
  des_gfx.pos_planos[1]:=0+($1000*f*8);
  des_gfx.pos_planos[2]:=($c000+($1000*f))*8+4;
  des_gfx.pos_planos[3]:=($c000+($1000*f))*8+0;
  convert_gfx(@gfx[1],$100*8*8*f,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
end;
if not(cargar_roms(@memoria_fondo[0],@citycon_fondo[0],'citycon.zip',0)) then exit;
//sprites
if not(cargar_roms(@memoria_temp[0],@citycon_sprites[0],'citycon.zip',0)) then exit;
init_gfx(2,8,16,256);
gfx[2].trans[0]:=true;
des_gfx.long_sprites:=16*8;
des_gfx.banks:=2;
for f:=0 to 1 do begin
  des_gfx.pos_planos[0]:=($1000*f*8)+4;
  des_gfx.pos_planos[1]:=($1000*f*8)+0;
  des_gfx.pos_planos[2]:=($2000+$1000*f)*8+4;
  des_gfx.pos_planos[3]:=($2000+$1000*f)*8+0;
  convert_gfx(@gfx[2],$80*16*8*f,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
end;
//final
reset_citycon;
iniciar_citycon:=true;
end;

procedure cerrar_citycon; 
begin
main_m6809.Free;
snd_m6809.Free;
YM2203_0.Free;
ay8910_0.Free;
close_audio;
close_video;
end;

procedure reset_citycon;
begin
 main_m6809.reset;
 snd_m6809.reset;
 YM2203_0.Reset;
 ay8910_0.reset;
 reset_audio;
 fillchar(lines_color_look[0],$100,0);
 in0:=$FF;
 in1:=$80;
 fondo:=0;
 soundlatch:=0;
 soundlatch2:=0;
 scroll_x:=0;
end;

procedure cambiar_fondo;inline;
var
  f,x,y,nchar,color:word;
begin
for f:=$fff downto 0 do begin
    y:=f shr 5;
    x:=((f and $1f)+(y and $60)) shl 3;
    y:=(y and $1f) shl 3;
    nchar:=memoria_fondo[$1000*fondo+f]+(fondo shl 8);
    color:=memoria_fondo[$c000+nchar];
    put_gfx(x,y,nchar,(color shl 4)+256,2,1);
end;
cambia_fondo:=false;
end;

procedure update_video_citycon;inline;
var
  f,x,y:word;
  y2,x2,atrib:byte;
  color,nchar:word;
  temp:pword;
  pos:pbyte;
begin
if cambia_fondo then cambiar_fondo;
scroll__x(2,3,scroll_x);
for f:=$fff downto 0 do begin
 if gfx[0].buffer[f] then begin
    y:=f shr 5;
    x:=(f and $1f)+(y and $60);
    y:=y and $1f;
    nchar:=memoria[$1000+f];
    pos:=gfx[0].datos;
    inc(pos,nchar shl 6);
    for y2:=0 to 7 do begin
      temp:=punbuf;
      color:=(lines_color_look[y2+(y shl 3)] shl 2)+512;
      for x2:=0 to 7 do begin
        if not(gfx[0].trans[pos^]) then temp^:=paleta[pos^+color]
          else temp^:=paleta[max_colores];
        inc(temp);
        inc(pos);
      end;
      putpixel(x shl 3,(y shl 3)+y2,8,punbuf,1);
    end;
 gfx[0].buffer[f]:=false;
 end;
end;
actualiza_trozo(0,0,256,48,1,0,0,256,48,3);
scroll__x_part(1,3,scroll_x,0,48,208);
for f:=$3f downto 0 do begin
    x:=memoria[$2803+(f*4)];
    y:=239-memoria[$2800+(f*4)];
    nchar:=memoria[$2801+(f*4)];
    atrib:=memoria[$2802+(f*4)];
    color:=(atrib and $f) shl 4;
    put_gfx_sprite(nchar,color,(atrib and $10)=0,false,2);
    actualiza_gfx_sprite(x,y,3,2);
end;
actualiza_trozo_final(8,16,240,224,3);
end;

procedure eventos_citycon;
begin
if event.arcade then begin
  if arcade_input.up[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.down[0] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.left[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.right[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.but0[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.but1[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.coin[0] then in1:=(in1 and $7f) else in1:=(in1 or $80);
  if arcade_input.start[0] then in0:=(in0 and $bf) else in0:=(in0 or $40);
  if arcade_input.start[1] then in0:=(in0 and $7f) else in0:=(in0 or $80);
end;
end;

procedure citycon_principal; 
var
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_m6809.tframes;
frame_s:=snd_m6809.tframes;
while EmuStatus=EsRuning do begin
  //Main CPU
  main_m6809.run(trunc(frame_m));
  frame_m:=frame_m+main_m6809.tframes-main_m6809.contador;
  main_m6809.pedir_irq:=ASSERT_LINE;
  //Sound CPU
  snd_m6809.run(trunc(frame_s));
  frame_s:=frame_s+snd_m6809.tframes-snd_m6809.contador;
  update_video_citycon;
  eventos_citycon;
  video_sync;
end;
end;

function citycon_getbyte(direccion:word):byte;
begin
  case direccion of
        $3000:citycon_getbyte:=in0;
        $3001:citycon_getbyte:=in1;
        $3002:citycon_getbyte:=$80;
        $3007:main_m6809.pedir_irq:=CLEAR_LINE;
    else citycon_getbyte:=memoria[direccion];
  end;
end;

procedure cambiar_color(dir:word);inline;
var
        tmp_color:byte;
        color:tcolor;
        pos:word;
begin
  tmp_color:=buffer_paleta[dir];
  color.r:=pal4bit(tmp_color shr 4);
  color.g:=pal4bit(tmp_color);
  tmp_color:=buffer_paleta[dir+1];
  color.b:=pal4bit(tmp_color shr 4);
  pos:=dir shr 1;
  set_pal_color(color,addr(paleta[pos]));
  case pos of
    256..511:cambia_fondo:=true;
    512..639:fillchar(gfx[0].buffer[0],$1000,1);
  end;
end;

procedure citycon_putbyte(direccion:word;valor:byte);
begin
if direccion>$3fff then exit;
memoria[direccion]:=valor;
case direccion of
  $1000..$1fff:gfx[0].buffer[direccion and $fff]:=true;
  $2000..$20ff:lines_color_look[direccion and $ff]:=valor;
  $3000:if fondo<>(valor shr 4) then begin
          fondo:=valor shr 4;
          cambia_fondo:=true;
        end;
  $3001:soundlatch:=valor;
  $3002:soundlatch2:=valor;
  $3004:scroll_x:=(scroll_x and $ff) or ((valor and $3) shl 8);
  $3005:scroll_x:=(scroll_x and $300) or valor;
  $3800..$3cff:if buffer_paleta[direccion and $7ff]<>valor then begin
                  buffer_paleta[direccion and $7ff]:=valor;
                  cambiar_color(direccion and $7fe);
               end;
end;
end;

function scitycon_getbyte(direccion:word):byte;
begin
if direccion=$6001 then scitycon_getbyte:=ym2203_0.Read_Reg
  else scitycon_getbyte:=mem_snd[direccion];
end;

procedure scitycon_putbyte(direccion:word;valor:byte);
begin
if direccion>$7fff then exit;
mem_snd[direccion]:=valor;
case direccion of
  $4000:ay8910_0.Control(valor);
  $4001:ay8910_0.Write(valor);
  $6000:ym2203_0.Control(valor);
  $6001:ym2203_0.Write_Reg(valor);
end;
end;

function citycon_porta:byte;
begin
  citycon_porta:=soundlatch;
end;

function citycon_portb:byte;
begin
  citycon_portb:=soundlatch2;
end;

procedure citycon_sound_update;
begin
  ay8910_0.update;
  ym2203_0.Update;
end;

procedure citycon_qsave(nombre:string);
var
  data:pbyte;
  buffer:array[0..5] of byte;
  size:word;
begin
open_qsnapshot_save('cityconn'+nombre);
getmem(data,20000);
//CPU
size:=main_m6809.save_snapshot(data);
savedata_qsnapshot(data,size);
size:=snd_m6809.save_snapshot(data);
savedata_qsnapshot(data,size);
//SND
size:=ym2203_0.save_snapshot(data);
savedata_com_qsnapshot(data,size);
size:=AY8910_0.save_snapshot(data);
savedata_qsnapshot(data,size);
//MEM
savedata_com_qsnapshot(@memoria[0],$4000);
savedata_com_qsnapshot(@mem_snd[0],$8000);
//MISC
buffer[0]:=fondo;
buffer[1]:=soundlatch;
buffer[2]:=soundlatch2;
buffer[3]:=scroll_x and $ff;
buffer[4]:=scroll_x shr 8;
buffer[5]:=byte(cambia_fondo);
savedata_qsnapshot(@buffer[0],6);
savedata_com_qsnapshot(@lines_color_look[0],$100);
savedata_com_qsnapshot(@buffer_paleta[0],$500*2);
freemem(data);
close_qsnapshot;
end;

procedure citycon_qload(nombre:string);
var
  data:pbyte;
  buffer:array[0..5] of byte;
  f:word;
begin
if not(open_qsnapshot_load('cityconn'+nombre)) then exit;
getmem(data,20000);
//CPU
loaddata_qsnapshot(data);
main_m6809.load_snapshot(data);
loaddata_qsnapshot(data);
snd_m6809.load_snapshot(data);
//SND
loaddata_qsnapshot(data);
ym2203_0.load_snapshot(data);
loaddata_qsnapshot(data);
AY8910_0.save_snapshot(data);
//MEM
loaddata_qsnapshot(@memoria[0]);
loaddata_qsnapshot(@mem_snd[0]);
//MISC
loaddata_qsnapshot(@buffer[0]);
fondo:=buffer[0];
soundlatch:=buffer[1];
soundlatch2:=buffer[2];
scroll_x:=buffer[3] or (scroll_x shl 8);
cambia_fondo:=buffer[5]<>0;
loaddata_qsnapshot(@lines_color_look[0]);
loaddata_qsnapshot(@buffer_paleta[0]);
freemem(data);
close_qsnapshot;
//END
for f:=0 to 639 do cambiar_color(f*2);
end;

end.
