unit dietgogo_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m68000,main_engine,controls_engine,gfx_engine,rom_engine,
     pal_engine,oki6295,sound_engine,hu6280,deco16ic,deco_decr,deco_common;

procedure Cargar_dietgo;
function iniciar_dietgo:boolean;
procedure reset_dietgo;
procedure cerrar_dietgo;
procedure dietgo_principal;
//Main CPU
function dietgo_getword(direccion:dword;putbyte:boolean):word;
procedure dietgo_putword(direccion:dword;valor:word);
function dietgo_bank_callback(bank:word):word;
procedure sound_bank_rom(valor:byte);

const
        dietgo_rom:array[0..2] of tipo_roms=(
        (n:'jy00-2.h4';l:$40000;p:1;crc:$014dcf62),(n:'jy01-2.h5';l:$40000;p:$0;crc:$793ebd83),());
        dietgo_sound:tipo_roms=(n:'jy02.m14';l:$10000;p:$0;crc:$4e3492a5);
        dietgo_char:tipo_roms=(n:'may00';l:$100000;p:0;crc:$234d1f8d);
        dietgo_oki:tipo_roms=(n:'may03';l:$80000;p:0;crc:$b6e42bae);
        dietgo_sprites:array[0..2] of tipo_roms=(
        (n:'may01';l:$100000;p:0;crc:$2da57d04),(n:'may02';l:$100000;p:$1;crc:$3a66a713),());

var
 rom_opcode,rom_data:array[0..$3ffff] of word;
 ram:array[0..$7fff] of word;
 oki1_mem:pbyte;

implementation

procedure Cargar_dietgo;
begin
llamadas_maquina.bucle_general:=dietgo_principal;
llamadas_maquina.iniciar:=iniciar_dietgo;
llamadas_maquina.cerrar:=cerrar_dietgo;
llamadas_maquina.reset:=reset_dietgo;
llamadas_maquina.fps_max:=58;
end;

//Inicio Normal
function iniciar_dietgo:boolean;
const
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
  pt_x:array[0..15] of dword=(256,257,258,259,260,261,262,263,
  0, 1, 2, 3, 4, 5, 6, 7);
  pt_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
  8*16,9*16,10*16,11*16,12*16,13*16,14*16,15*16);
  ps_x:array[0..15] of dword=(512,513,514,515,516,517,518,519,
   0, 1, 2, 3, 4, 5, 6, 7);
  ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
	  8*32, 9*32,10*32,11*32,12*32,13*32,14*32,15*32 );
var
  memoria_temp:pbyte;
  memoria_temp_rom:pword;
begin
iniciar_dietgo:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=320;
p_final[0].y:=240;
init_dec16ic(0,1,2,$0,$0,$f,$f,0,1,0,16,dietgo_bank_callback,dietgo_bank_callback);
p_final[3].x:=512;
p_final[3].y:=512;
p_final[3].final_mix:=true;
iniciar_video;
//Main CPU
main_m68000:=cpu_m68000.create(14000000,$100);
main_m68000.change_ram16_calls(dietgo_getword,dietgo_putword);
//Sound CPU
deco16_sprite_color_add:=$200;
deco16_sprite_mask:=$3fff;
deco16_snd_simple_init(32220000 div 12,32220000,sound_bank_rom);
getmem(memoria_temp,$200000);
getmem(memoria_temp_rom,$80000);
//cargar roms
if not(cargar_roms16w(memoria_temp_rom,@dietgo_rom[0],'dietgo.zip',0)) then exit;
deco102_decrypt_cpu(memoria_temp_rom,@rom_opcode[0],@rom_data[0],$e9ba,$01,$19,$80000);
//cargar sonido
if not(cargar_roms(@mem_snd[0],@dietgo_sound,'dietgo.zip',1)) then exit;
//OKI rom
getmem(oki1_mem,$80000);
if not(cargar_roms(oki1_mem,@dietgo_oki,'dietgo.zip',1)) then exit;
//convertir chars
if not(cargar_roms(memoria_temp,@dietgo_char,'dietgo.zip',1)) then exit;
deco56_decrypt_gfx(memoria_temp,$100000);
init_gfx(0,8,8,$8000);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=$8000*16*8+8;
des_gfx.pos_planos[1]:=$8000*16*8+0;
des_gfx.pos_planos[2]:=8;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,memoria_temp,@pc_x[0],@pc_y[0],false,false);
//Tiles
init_gfx(1,16,16,$2000);
gfx[1].trans[0]:=true;
des_gfx.pos_planos[0]:=$2000*32*16+8;
des_gfx.pos_planos[1]:=$2000*32*16+0;
des_gfx.pos_planos[2]:=8;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*16;
convert_gfx(@gfx[1],0,memoria_temp,@pt_x[0],@pt_y[0],false,false);
//Sprites
if not(cargar_roms16b(memoria_temp,@dietgo_sprites[0],'dietgo.zip',0)) then exit;
init_gfx(2,16,16,$4000);
gfx[2].trans[0]:=true;
des_gfx.pos_planos[0]:=24;
des_gfx.pos_planos[1]:=8;
des_gfx.pos_planos[2]:=16;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*32;
convert_gfx(@gfx[2],0,memoria_temp,@ps_x[0],@ps_y[0],false,false);
//final
freemem(memoria_temp);
reset_dietgo;
iniciar_dietgo:=true;
end;

procedure cerrar_dietgo;
begin
main_m68000.free;
close_dec16ic(0);
freemem(oki1_mem);
deco16_snd_simple_close;
close_audio;
close_video;
end;

procedure reset_dietgo;
begin
 main_m68000.reset;
 reset_dec16ic(0);
 copymemory(oki_6295_0.get_rom_addr,oki1_mem,$40000);
 deco16_snd_simple_reset;
 reset_audio;
 in0:=$FF;
 in1:=$7;
 in2:=$FF;
end;

procedure update_video_dietgo;inline;
begin
update_pf_2(0,3,false);
update_pf_1(0,3,true);
deco16_sprites;
actualiza_trozo_final(0,8,320,240,3);
end;

procedure eventos_dietgo;
begin
if event.arcade then begin
  //P1
  if arcade_input.up[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.down[0] then in0:=(in0 and $Fd) else in0:=(in0 or $2);
  if arcade_input.left[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.right[0] then in0:=(in0 and $F7) else in0:=(in0 or $8);
  if arcade_input.but0[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.but1[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.but2[0] then in0:=(in0 and $bf) else in0:=(in0 or $40);
  if arcade_input.start[0] then in0:=(in0 and $7f) else in0:=(in0 or $80);
  //P2
  if arcade_input.up[1] then in2:=(in2 and $fe) else in2:=(in2 or $1);
  if arcade_input.down[1] then in2:=(in2 and $Fd) else in2:=(in2 or $2);
  if arcade_input.left[1] then in2:=(in2 and $fb) else in2:=(in2 or $4);
  if arcade_input.right[1] then in2:=(in2 and $F7) else in2:=(in2 or $8);
  if arcade_input.but0[1] then in2:=(in2 and $ef) else in2:=(in2 or $10);
  if arcade_input.but1[1] then in2:=(in2 and $df) else in2:=(in2 or $20);
  if arcade_input.but2[1] then in2:=(in2 and $bf) else in2:=(in2 or $40);
  if arcade_input.start[1] then in2:=(in2 and $7f) else in2:=(in2 or $80);
  //SYSTEM
  if arcade_input.coin[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.coin[1] then in1:=(in1 and $fd) else in1:=(in1 or $2);
end;
end;

procedure dietgo_principal;
var
  frame_m,frame_s:single;
  f:byte;
begin
init_controls(false,false,false,true);
frame_m:=main_m68000.tframes;
frame_s:=main_h6280.tframes;
while EmuStatus=EsRuning do begin
 for f:=0 to $ff do begin
   main_m68000.run(trunc(frame_m));
   frame_m:=frame_m+main_m68000.tframes-main_m68000.contador;
   main_h6280.run(trunc(frame_s));
   frame_s:=frame_s+main_h6280.tframes-main_h6280.contador;
   case f of
      247:begin
            main_m68000.irq[6]:=HOLD_LINE;
            update_video_dietgo;
            in1:=in1 or $8;
          end;
      255:in1:=in1 and $7;
   end;
 end;
 eventos_dietgo;
 video_sync;
end;
end;

function dietgo_getword(direccion:dword;putbyte:boolean):word;
begin
direccion:=direccion and $fffffe;
case direccion of
  $0..$7ffff:if main_m68000.opcode then dietgo_getword:=rom_opcode[direccion shr 1]
                  else dietgo_getword:=rom_data[direccion shr 1];
  $210000..$210fff:dietgo_getword:=deco16ic_chip[0].dec16ic_pf_data[1,(direccion and $fff)+1] or (deco16ic_chip[0].dec16ic_pf_data[1,direccion and $fff] shl 8);
  $212000..$212fff:dietgo_getword:=deco16ic_chip[0].dec16ic_pf_data[2,(direccion and $fff)+1] or (deco16ic_chip[0].dec16ic_pf_data[2,direccion and $fff] shl 8);
  $280000..$2807ff:dietgo_getword:=deco_sprite_ram[(direccion and $7ff) shr 1];
  $240000:dietgo_getword:=$ffff;
  $300000..$300bff:dietgo_getword:=buffer_paleta[(direccion and $fff) shr 1];
  $340000..$3407ff:case (direccion and $7ff) of
                        $298:dietgo_getword:=in1;
	                      $342:dietgo_getword:=(in2 shl 8)+in0;
	                      $506:dietgo_getword:=$ffff;
                   end;
  $380000..$38ffff:dietgo_getword:=ram[(direccion and $ffff) shr 1];
end;
end;

procedure cambiar_color(numero:word);inline;
var
  color:tcolor;
begin
  color.b:=buffer_paleta[(numero shl 1)] and $ff;
  color.g:=buffer_paleta[(numero shl 1)+1] shr 8;
  color.r:=buffer_paleta[(numero shl 1)+1] and $ff;
  set_pal_color(color,addr(paleta[numero]));
  case numero of
    $000..$0ff:deco16ic_chip[0].dec16ic_buffer_color[1,(numero shr 4) and $f]:=true;
    $100..$1ff:deco16ic_chip[0].dec16ic_buffer_color[2,(numero shr 4) and $f]:=true;
  end;
end;

procedure dietgo_putword(direccion:dword;valor:word);
begin
direccion:=direccion and $fffffe;
if direccion<$80000 then exit;
case direccion of
  $200000..$20000f:dec16ic_pf_control_w(0,(direccion and $f) shr 1,valor);
  $210000..$210fff:begin
                      deco16ic_chip[0].dec16ic_pf_data[1,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[0].dec16ic_pf_data[1,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[0].dec16ic_buffer[1,(direccion and $fff) shr 1]:=true
                   end;
  $212000..$212fff:begin
                      deco16ic_chip[0].dec16ic_pf_data[2,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[0].dec16ic_pf_data[2,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[0].dec16ic_buffer[2,(direccion and $fff) shr 1]:=true
                   end;
  $220000..$2207ff:deco16ic_chip[0].dec16ic_pf_rowscroll[1,(direccion and $7ff) shr 1]:=valor;
  $222000..$2227ff:deco16ic_chip[0].dec16ic_pf_rowscroll[2,(direccion and $7ff) shr 1]:=valor;
  $280000..$2807ff:deco_sprite_ram[(direccion and $7ff) shr 1]:=valor;
  $211000..$211fff,$213000..$213fff,$2c0002,$2c000a,$230000..$2300ff,$240000:;
  $300000..$300bff:if buffer_paleta[(direccion and $fff) shr 1]<>valor then begin
                      buffer_paleta[(direccion and $fff) shr 1]:=valor;
                      cambiar_color((direccion and $fff) shr 2);
                   end;
  $340000..$3407ff:if (direccion and $7ff)=$380 then begin
                      deco16_sound_latch:=valor and $ff;
                      main_h6280.set_irq_line(0,HOLD_LINE);
                   end;
  $380000..$38ffff:ram[(direccion and $ffff) shr 1]:=valor;
end;
end;

function dietgo_bank_callback(bank:word):word;
begin
  	dietgo_bank_callback:=((bank shr 4) and $7)*$1000;
end;

procedure sound_bank_rom(valor:byte);
var
  temp:pbyte;
begin
  temp:=oki1_mem;
  inc(temp,(valor and 1)*$40000);
  copymemory(oki_6295_0.get_rom_addr,temp,$40000);
end;


end.
