unit funkyjet_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m68000,main_engine,controls_engine,gfx_engine,rom_engine,pal_engine,
     oki6295,sound_engine,hu6280,deco16ic,deco_decr,deco_common;

procedure Cargar_funkyjet;
function iniciar_funkyjet:boolean;
procedure reset_funkyjet;
procedure cerrar_funkyjet;
procedure funkyjet_principal;
//Main CPU
function funkyjet_getword(direccion:dword;putbyte:boolean):word;
procedure funkyjet_putword(direccion:dword;valor:word);

const
        funkyjet_rom:array[0..2] of tipo_roms=(
        (n:'jk00.12f';l:$40000;p:0;crc:$712089c1),(n:'jk01.13f';l:$40000;p:$1;crc:$be3920d7),());
        funkyjet_sound:tipo_roms=(n:'jk02.16f';l:$10000;p:$0;crc:$748c0bd8);
        funkyjet_char:tipo_roms=(n:'mat02';l:$80000;p:0;crc:$e4b94c7e);
        funkyjet_oki:tipo_roms=(n:'jk03.15h';l:$20000;p:0;crc:$69a0eaf7);
        funkyjet_sprites:array[0..2] of tipo_roms=(
        (n:'mat01';l:$80000;p:0;crc:$24093a8d),(n:'mat00';l:$80000;p:$80000;crc:$fbda0228),());

var
 rom:array[0..$3ffff] of word;
 ram:array[0..$1fff] of word;
 prot146_ram:array[0..$7ff] of byte;

implementation

procedure Cargar_funkyjet;
begin
llamadas_maquina.bucle_general:=funkyjet_principal;
llamadas_maquina.iniciar:=iniciar_funkyjet;
llamadas_maquina.cerrar:=cerrar_funkyjet;
llamadas_maquina.reset:=reset_funkyjet;
llamadas_maquina.fps_max:=58;
end;

//Inicio Normal
function iniciar_funkyjet:boolean;
const
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
  pt_x:array[0..15] of dword=(32*8+0, 32*8+1, 32*8+2, 32*8+3, 32*8+4, 32*8+5, 32*8+6, 32*8+7,
			0, 1, 2, 3, 4, 5, 6, 7);
  pt_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
			8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16);
var
  memoria_temp:pbyte;
begin
iniciar_funkyjet:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=320;
p_final[0].y:=240;
init_dec16ic(0,1,2,$100,$100,$f,$f,0,1,0,16,nil,nil);
p_final[3].x:=512;
p_final[3].y:=512;
p_final[3].final_mix:=true;
iniciar_video;
//Main CPU
main_m68000:=cpu_m68000.create(14000000,$100);
main_m68000.change_ram16_calls(funkyjet_getword,funkyjet_putword);
//Sound CPU
deco16_sprite_color_add:=0;
deco16_sprite_mask:=$1fff;
deco16_snd_simple_init(32220000 div 4,32220000,nil);
getmem(memoria_temp,$100000);
//cargar roms
if not(cargar_roms16w(@rom[0],@funkyjet_rom[0],'funkyjet.zip',0)) then exit;
//cargar sonido
if not(cargar_roms(@mem_snd[0],@funkyjet_sound,'funkyjet.zip',1)) then exit;
//OKI rom
if not(cargar_roms(oki_6295_0.get_rom_addr,@funkyjet_oki,'funkyjet.zip',1)) then exit;
//convertir chars
if not(cargar_roms(memoria_temp,@funkyjet_char,'funkyjet.zip',1)) then exit;
deco74_decrypt_gfx(memoria_temp,$80000);
init_gfx(0,8,8,$4000);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=$4000*16*8+8;
des_gfx.pos_planos[1]:=$4000*16*8+0;
des_gfx.pos_planos[2]:=8;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,memoria_temp,@pc_x[0],@pc_y[0],false,false);
//Tiles
init_gfx(1,16,16,$1000);
gfx[1].trans[0]:=true;
des_gfx.pos_planos[0]:=$1000*64*8+8;
des_gfx.pos_planos[1]:=$1000*64*8+0;
des_gfx.pos_planos[2]:=8;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[1],0,memoria_temp,@pt_x[0],@pt_y[0],false,false);
//Sprites
if not(cargar_roms(memoria_temp,@funkyjet_sprites[0],'funkyjet.zip',0)) then exit;
init_gfx(2,16,16,$2000);
gfx[2].trans[0]:=true;
des_gfx.pos_planos[0]:=$2000*64*8+8;
des_gfx.pos_planos[1]:=$2000*64*8+0;
convert_gfx(@gfx[2],0,memoria_temp,@pt_x[0],@pt_y[0],false,false);
//final
freemem(memoria_temp);
reset_funkyjet;
iniciar_funkyjet:=true;
end;

procedure cerrar_funkyjet;
begin
main_m68000.free;
close_dec16ic(0);
deco16_snd_simple_close;
close_audio;
close_video;
end;

procedure reset_funkyjet;
begin
 main_m68000.reset;
 reset_dec16ic(0);
 deco16_snd_simple_reset;
 reset_audio;
 in0:=$FF;
 in1:=$F7;
 in2:=$FF;
end;

procedure update_video_funkyjet;inline;
begin
//fill_full_screen(3,$200);
update_pf_2(0,3,false);
update_pf_1(0,3,true);
deco16_sprites;
actualiza_trozo_final(0,8,320,240,3);
end;

procedure eventos_funkyjet;
begin
if event.arcade then begin
  //P1
  if arcade_input.up[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.down[0] then in0:=(in0 and $Fd) else in0:=(in0 or $2);
  if arcade_input.left[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.right[0] then in0:=(in0 and $F7) else in0:=(in0 or $8);
  if arcade_input.but0[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.but1[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.start[0] then in0:=(in0 and $7f) else in0:=(in0 or $80);
  //P2
  if arcade_input.up[1] then in2:=(in2 and $fe) else in2:=(in2 or $1);
  if arcade_input.down[1] then in2:=(in2 and $Fd) else in2:=(in2 or $2);
  if arcade_input.left[1] then in2:=(in2 and $fb) else in2:=(in2 or $4);
  if arcade_input.right[1] then in2:=(in2 and $F7) else in2:=(in2 or $8);
  if arcade_input.but0[1] then in2:=(in2 and $ef) else in2:=(in2 or $10);
  if arcade_input.but1[1] then in2:=(in2 and $df) else in2:=(in2 or $20);
  if arcade_input.start[1] then in2:=(in2 and $7f) else in2:=(in2 or $80);
  //SYSTEM
  if arcade_input.coin[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.coin[1] then in1:=(in1 and $fd) else in1:=(in1 or $2);
end;
end;

procedure funkyjet_principal;
var
  frame_m,frame_s:single;
  f:byte;
begin
init_controls(false,false,false,true);
frame_m:=main_m68000.tframes;
frame_s:=main_h6280.tframes;
while EmuStatus=EsRuning do begin
 for f:=0 to $ff do begin
   main_m68000.run(trunc(frame_m));
   frame_m:=frame_m+main_m68000.tframes-main_m68000.contador;
   main_h6280.run(trunc(frame_s));
   frame_s:=frame_s+main_h6280.tframes-main_h6280.contador;
   case f of
      247:begin
            main_m68000.irq[6]:=HOLD_LINE;
            update_video_funkyjet;
            in1:=in1 and $f7;
          end;
      255:in1:=in1 or $8;
   end;
 end;
 eventos_funkyjet;
 video_sync;
end;
end;

function funkyjet_prot146(direccion:word):word;inline;
var
  temp:word;
begin
	case direccion of
		$0be:funkyjet_prot146:=(prot146_ram[$106] shl 8)+prot146_ram[$107];
		$11e,$3a8:funkyjet_prot146:=(prot146_ram[$500] shl 8)+prot146_ram[$501];
    $148:funkyjet_prot146:=(prot146_ram[$70e] shl 8)+prot146_ram[$70f];
    $1da:funkyjet_prot146:=(prot146_ram[$100] shl 8)+prot146_ram[$101];
		$21c:funkyjet_prot146:=(prot146_ram[$504] shl 8)+prot146_ram[$505];
		$226:funkyjet_prot146:=(prot146_ram[$58c] shl 8)+prot146_ram[$58d];
    $24c:funkyjet_prot146:=(prot146_ram[$78e] shl 8)+prot146_ram[$78f];
    $250:funkyjet_prot146:=(prot146_ram[$304] shl 8)+prot146_ram[$305];
    $2d4:funkyjet_prot146:=(prot146_ram[$102] shl 8)+prot146_ram[$103];
    $2d8:funkyjet_prot146:=(prot146_ram[$502] shl 8)+prot146_ram[$503];
    $3a6:funkyjet_prot146:=(prot146_ram[$104] shl 8)+prot146_ram[$105];
    $56c:funkyjet_prot146:=(prot146_ram[$50c] shl 8)+prot146_ram[$50d];
    $3e8:funkyjet_prot146:=(prot146_ram[$50c]) xor $ffff;
    $4e4:funkyjet_prot146:=(prot146_ram[$702] shl 8)+prot146_ram[$703];
    $562:funkyjet_prot146:=(prot146_ram[$18e] shl 8)+prot146_ram[$18f];
    $688:funkyjet_prot146:=(prot146_ram[$300] shl 8)+prot146_ram[$301];
    $788:funkyjet_prot146:=(prot146_ram[$700] shl 8)+prot146_ram[$701];
    $7d4:funkyjet_prot146:=$10;
    $27c:begin
            temp:=(prot146_ram[$70e] shl 8)+prot146_ram[$70f];
            funkyjet_prot146:=((temp shr 4) and $fff) or ((temp and 1) shl 15) or ((temp and $e) shl 11);
         end;
    $192:funkyjet_prot146:=(prot146_ram[$78e] shl 8) and $f000;
    $5be:begin
            temp:=(prot146_ram[$70e] shl 8)+prot146_ram[$70f];
            funkyjet_prot146:=((temp shl 4) and $ff00) or (temp and $f);
          end;
    $5ca:begin
            temp:=(prot146_ram[$78e] shl 8)+prot146_ram[$78f];
            funkyjet_prot146:=((temp shr 4) and $ff00) or (temp and $f) or ((temp shl 8) and $f000);
         end;
    $00c:funkyjet_prot146:=(in2 shl 8)+in0;
		$778:funkyjet_prot146:=$00+in1;
		$382:funkyjet_prot146:=$ffff;
      else funkyjet_prot146:=0;
  end;
end;

function funkyjet_getword(direccion:dword;putbyte:boolean):word;
begin
direccion:=direccion and $fffffe;
case direccion of
  $0..$7ffff:funkyjet_getword:=rom[direccion shr 1];
  $120000..$1207ff:funkyjet_getword:=buffer_paleta[(direccion and $7ff) shr 1];
  $140000..$143fff:funkyjet_getword:=ram[(direccion and $3fff) shr 1];
  $160000..$1607ff:funkyjet_getword:=deco_sprite_ram[(direccion and $7ff) shr 1];
  $180000..$1807ff:funkyjet_getword:=funkyjet_prot146(direccion and $7ff);
  $320000..$320fff:funkyjet_getword:=deco16ic_chip[0].dec16ic_pf_data[1,(direccion and $fff)+1] or (deco16ic_chip[0].dec16ic_pf_data[1,direccion and $fff] shl 8);
  $322000..$322fff:funkyjet_getword:=deco16ic_chip[0].dec16ic_pf_data[2,(direccion and $fff)+1] or (deco16ic_chip[0].dec16ic_pf_data[2,direccion and $fff] shl 8);
  $340000..$340bff:funkyjet_getword:=deco16ic_chip[0].dec16ic_pf_rowscroll[1,(direccion and $fff) shr 1];
  $342000..$342bff:funkyjet_getword:=deco16ic_chip[0].dec16ic_pf_rowscroll[2,(direccion and $fff) shr 1];
end;
end;

procedure cambiar_color(tmp_color,numero:word);inline;
var
  color:tcolor;
begin
  color.b:=pal4bit(tmp_color shr 8);
  color.g:=pal4bit(tmp_color shr 4);
  color.r:=pal4bit(tmp_color);
  set_pal_color(color,addr(paleta[numero]));
  case numero of
    $100..$1ff:deco16ic_chip[0].dec16ic_buffer_color[1,(numero shr 4) and $f]:=true;
    $200..$2ff:deco16ic_chip[0].dec16ic_buffer_color[2,(numero shr 4) and $f]:=true;
  end;
end;

procedure funkyjet_putword(direccion:dword;valor:word);
begin
direccion:=direccion and $fffffe;
if direccion<$80000 then exit;
case direccion of
  $120000..$1207ff:if (buffer_paleta[(direccion and $7ff) shr 1]<>valor) then begin
                      buffer_paleta[(direccion and $7ff) shr 1]:=valor;
                      cambiar_color(valor,(direccion and $7ff) shr 1);
                   end;
  $140000..$143fff:ram[(direccion and $3fff) shr 1]:=valor;
  $160000..$1607ff:deco_sprite_ram[(direccion and $7ff) shr 1]:=valor;
  $180000..$1807ff:begin
                      prot146_ram[(direccion and $7ff)+1]:=valor and $ff;
                      prot146_ram[direccion and $7ff]:=valor shr 8;
                      if (direccion and $7ff)=$10a then begin
                        deco16_sound_latch:=valor and $ff;
                        main_h6280.set_irq_line(0,HOLD_LINE);
                      end;
                   end;
  $184000,$188000,$1a0002,$1a0400,$1a0402:;
  $300000..$30000f:dec16ic_pf_control_w(0,(direccion and $f) shr 1,valor);
  $320000..$320fff:begin
                      deco16ic_chip[0].dec16ic_pf_data[1,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[0].dec16ic_pf_data[1,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[0].dec16ic_buffer[1,(direccion and $fff) shr 1]:=true
                   end;
  $322000..$322fff:begin
                      deco16ic_chip[0].dec16ic_pf_data[2,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[0].dec16ic_pf_data[2,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[0].dec16ic_buffer[2,(direccion and $fff) shr 1]:=true
                   end;
  $340000..$340bff:deco16ic_chip[0].dec16ic_pf_rowscroll[1,(direccion and $fff) shr 1]:=valor;
  $342000..$342bff:deco16ic_chip[0].dec16ic_pf_rowscroll[2,(direccion and $fff) shr 1]:=valor;
end;
end;

end.
