unit m62_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     nz80,m680x,main_engine,controls_engine,ay_8910,gfx_engine,
     msm5205,rom_engine,pal_engine,sound_engine;

procedure Cargar_irem_m62;
procedure reset_irem_m62; 
procedure cerrar_irem_m62; 
function iniciar_irem_m62:boolean; 
procedure irem_m62_principal; 
//Kung-Fu Master
function kungfum_getbyte(direccion:word):byte;
procedure kungfum_putbyte(direccion:word;valor:byte);
function kungfum_inbyte(puerto:word):byte;
procedure kungfum_outbyte(valor:byte;puerto:word);
//Spelunker
function spl_getbyte(direccion:word):byte;
procedure spl_putbyte(direccion:word;valor:byte);
//Spelunker II
function spl2_getbyte(direccion:word):byte;
procedure spl2_putbyte(direccion:word;valor:byte);
//Lode Runner
function ldrun_getbyte(direccion:word):byte;
procedure ldrun_putbyte(direccion:word;valor:byte); 
//Lode Runner II
function ldrun2_getbyte(direccion:word):byte;
procedure ldrun2_putbyte(direccion:word;valor:byte);
function ldrun2_inbyte(puerto:word):byte;
procedure ldrun2_outbyte(valor:byte;puerto:word);
//sound
function snd_getbyte(direccion:word):byte;
procedure snd_putbyte(direccion:word;valor:byte);
procedure out_port1(valor:byte);
procedure out_port2(valor:byte);
function in_port1:byte;
function in_port2:byte;
function ay0_porta_r:byte;
procedure ay0_portb_w(valor:byte);
procedure irem_m62_sonido;
procedure adpcm_int; 

const
        //Kung-Fu Master
        kungfum_rom:array[0..2] of tipo_roms=(
        (n:'a-4e-c.bin';l:$4000;p:0;crc:$b6e2d083),(n:'a-4d-c.bin';l:$4000;p:$4000;crc:$7532918e),());
        kungfum_pal:array[0..7] of tipo_roms=(
        (n:'g-1j-.bin';l:$100;p:0;crc:$668e6bca),(n:'g-1f-.bin';l:$100;p:$100;crc:$964b6495),
        (n:'g-1h-.bin';l:$100;p:$200;crc:$550563e1),(n:'b-1m-.bin';l:$100;p:$300;crc:$76c05a9c),
        (n:'b-1n-.bin';l:$100;p:$400;crc:$23f06b99),(n:'b-1l-.bin';l:$100;p:$500;crc:$35e45021),
        (n:'b-5f-.bin';l:$20;p:$600;crc:$7a601c3d),());
        kungfum_char:array[0..3] of tipo_roms=(
        (n:'g-4c-a.bin';l:$2000;p:0;crc:$6b2cc9c8),(n:'g-4d-a.bin';l:$2000;p:$2000;crc:$c648f558),
        (n:'g-4e-a.bin';l:$2000;p:$4000;crc:$fbe9276e),());
        kungfum_sound:array[0..3] of tipo_roms=(
        (n:'a-3e-.bin';l:$2000;p:$a000;crc:$58e87ab0),(n:'a-3f-.bin';l:$2000;p:$c000;crc:$c81e31ea),
        (n:'a-3h-.bin';l:$2000;p:$e000;crc:$d99fb995),());
        kungfum_sprites:array[0..12] of tipo_roms=(
        (n:'b-4k-.bin';l:$2000;p:0;crc:$16fb5150),(n:'b-4f-.bin';l:$2000;p:$2000;crc:$67745a33),
        (n:'b-4l-.bin';l:$2000;p:$4000;crc:$bd1c2261),(n:'b-4h-.bin';l:$2000;p:$6000;crc:$8ac5ed3a),
        (n:'b-3n-.bin';l:$2000;p:$8000;crc:$28a213aa),(n:'b-4n-.bin';l:$2000;p:$a000;crc:$d5228df3),
        (n:'b-4m-.bin';l:$2000;p:$c000;crc:$b16de4f2),(n:'b-3m-.bin';l:$2000;p:$e000;crc:$eba0d66b),
        (n:'b-4c-.bin';l:$2000;p:$10000;crc:$01298885),(n:'b-4e-.bin';l:$2000;p:$12000;crc:$c77b87d4),
        (n:'b-4d-.bin';l:$2000;p:$14000;crc:$6a70615f),(n:'b-4a-.bin';l:$2000;p:$16000;crc:$6189d626),());
        //Spelunker
        spl_rom:array[0..4] of tipo_roms=(
        (n:'spra.4e';l:$4000;p:0;crc:$cf811201),(n:'spra.4d';l:$4000;p:$4000;crc:$bb4faa4f),
        (n:'sprm.7c';l:$4000;p:$8000;crc:$fb6197e2),(n:'sprm.7b';l:$4000;p:$c000;crc:$26bb25a4),());
        spl_pal:array[0..7] of tipo_roms=(
        (n:'sprm.2k';l:$100;p:0;crc:$fd8fa991),(n:'sprm.2j';l:$100;p:$100;crc:$0e3890b4),
        (n:'sprm.2h';l:$100;p:$200;crc:$0478082b),(n:'sprb.1m';l:$100;p:$300;crc:$8d8cccad),
        (n:'sprb.1n';l:$100;p:$400;crc:$c40e1cb2),(n:'sprb.1l';l:$100;p:$500;crc:$3ec46248),
        (n:'sprb.5p';l:$20;p:$600;crc:$746c6238),());
        spl_char:array[0..3] of tipo_roms=(
        (n:'sprm.4p';l:$4000;p:0;crc:$4dfe2e63),(n:'sprm.4l';l:$4000;p:$4000;crc:$239f2cd4),
        (n:'sprm.4m';l:$4000;p:$8000;crc:$d6d07d70),());
        spl_sound:array[0..2] of tipo_roms=(
        (n:'spra.3d';l:$4000;p:$8000;crc:$4110363c),(n:'spra.3f';l:$4000;p:$c000;crc:$67a9d2e6),());
        spl_sprites:array[0..6] of tipo_roms=(
        (n:'sprb.4k';l:$4000;p:0;crc:$e7f0e861),(n:'sprb.4f';l:$4000;p:$4000;crc:$32663097),
        (n:'sprb.3p';l:$4000;p:$8000;crc:$8fbaf373),(n:'sprb.4p';l:$4000;p:$c000;crc:$37069b76),
        (n:'sprb.4c';l:$4000;p:$10000;crc:$cfe46a88),(n:'sprb.4e';l:$4000;p:$14000;crc:$11c48979),());
        spl_tiles:array[0..6] of tipo_roms=(
        (n:'sprm.1d';l:$4000;p:0;crc:$4ef7ae89),(n:'sprm.1e';l:$4000;p:$4000;crc:$a3755180),
        (n:'sprm.3c';l:$4000;p:$8000;crc:$b4008e6a),(n:'sprm.3b';l:$4000;p:$c000;crc:$f61cf012),
        (n:'sprm.1c';l:$4000;p:$10000;crc:$58b21c76),(n:'sprm.1b';l:$4000;p:$14000;crc:$a95cb3e5),());
        //Spelunker II
        spl2_rom:array[0..5] of tipo_roms=(
        (n:'sp2-a.4e';l:$4000;p:0;crc:$96c04bbb),(n:'sp2-a.4d';l:$4000;p:$4000;crc:$cb38c2ff),
        (n:'sp2-r.7d';l:$8000;p:$8000;crc:$558837ea),(n:'sp2-r.7c';l:$8000;p:$10000;crc:$4b380162),
        (n:'sp2-r.7b';l:$4000;p:$18000;crc:$7709a1fe),());
        spl2_pal:array[0..7] of tipo_roms=(
        (n:'sp2-r.1k';l:$200;p:0;crc:$31c1bcdc),(n:'sp2-r.2k';l:$100;p:$200;crc:$1cf5987e),
        (n:'sp2-r.2j';l:$100;p:$300;crc:$1acbe2a5),(n:'sp2-b.1m';l:$100;p:$400;crc:$906104c7),
        (n:'sp2-b.1n';l:$100;p:$500;crc:$5a564c06),(n:'sp2-b.1l';l:$100;p:$600;crc:$8f4a2e3c),
        (n:'sp2-b.5p';l:$20;p:$700;crc:$cd126f6a),());
        spl2_char:array[0..3] of tipo_roms=(
        (n:'sp2-r.4l';l:$4000;p:0;crc:$6a4b2d8b),(n:'sp2-r.4m';l:$4000;p:$4000;crc:$e1368b61),
        (n:'sp2-r.4p';l:$4000;p:$8000;crc:$fc138e13),());
        spl2_sound:array[0..2] of tipo_roms=(
        (n:'sp2-a.3d';l:$4000;p:$8000;crc:$839ec7e2),(n:'sp2-a.3f';l:$4000;p:$c000;crc:$ad3ce898),());
        spl2_sprites:array[0..6] of tipo_roms=(
        (n:'sp2-b.4k';l:$4000;p:0;crc:$6cb67a17),(n:'sp2-b.4f';l:$4000;p:$4000;crc:$e4a1166f),
        (n:'sp2-b.3n';l:$4000;p:$8000;crc:$f59e8b76),(n:'sp2-b.4n';l:$4000;p:$c000;crc:$fa65bac9),
        (n:'sp2-b.4c';l:$4000;p:$10000;crc:$1caf7013),(n:'sp2-b.4e';l:$4000;p:$14000;crc:$780a463b),());
        spl2_tiles:array[0..3] of tipo_roms=(
        (n:'sp2-r.1d';l:$8000;p:0;crc:$c19fa4c9),(n:'sp2-r.3b';l:$8000;p:$8000;crc:$366604af),
        (n:'sp2-r.1b';l:$8000;p:$10000;crc:$3a0c4d47),());
        //Lode Runner
        ldrun_rom:array[0..4] of tipo_roms=(
        (n:'lr-a-4e';l:$2000;p:0;crc:$5d7e2a4d),(n:'lr-a-4d';l:$2000;p:$2000;crc:$96f20473),
        (n:'lr-a-4b';l:$2000;p:$4000;crc:$b041c4a9),(n:'lr-a-4a';l:$2000;p:$6000;crc:$645e42aa),());
        ldrun_pal:array[0..7] of tipo_roms=(
        (n:'lr-e-3m';l:$100;p:0;crc:$53040416),(n:'lr-e-3l';l:$100;p:$100;crc:$67786037),
        (n:'lr-e-3n';l:$100;p:$200;crc:$5b716837),(n:'lr-b-1m';l:$100;p:$300;crc:$4bae1c25),
        (n:'lr-b-1n';l:$100;p:$400;crc:$9cd3db94),(n:'lr-b-1l';l:$100;p:$500;crc:$08d8cf9a),
        (n:'lr-b-5p';l:$20;p:$600;crc:$e01f69e2),());
        ldrun_char:array[0..3] of tipo_roms=(
        (n:'lr-e-2d';l:$2000;p:0;crc:$24f9b58d),(n:'lr-e-2j';l:$2000;p:$2000;crc:$43175e08),
        (n:'lr-e-2f';l:$2000;p:$4000;crc:$e0317124),());
        ldrun_sound:array[0..2] of tipo_roms=(
        (n:'lr-a-3f';l:$2000;p:$c000;crc:$7a96accd),(n:'lr-a-3h';l:$2000;p:$e000;crc:$3f7f3939),());
        ldrun_sprites:array[0..3] of tipo_roms=(
        (n:'lr-b-4k';l:$2000;p:0;crc:$8141403e),(n:'lr-b-3n';l:$2000;p:$2000;crc:$55154154),
        (n:'lr-b-4c';l:$2000;p:$4000;crc:$924e34d0),());
        //Lode Runner II
        ldrun2_rom:array[0..6] of tipo_roms=(
        (n:'lr2-a-4e.a';l:$2000;p:0;crc:$22313327),(n:'lr2-a-4d';l:$2000;p:$2000;crc:$ef645179),
        (n:'lr2-a-4a.a';l:$2000;p:$4000;crc:$b11ddf59),(n:'lr2-a-4a';l:$2000;p:$6000;crc:$470cc8a1),
        (n:'lr2-h-1c.a';l:$2000;p:$8000;crc:$7ebcadbc),(n:'lr2-h-1d.a';l:$2000;p:$a000;crc:$64cbb7f9),());
        ldrun2_pal:array[0..7] of tipo_roms=(
        (n:'lr2-h-3m';l:$100;p:0;crc:$2c5d834b),(n:'lr2-h-3l';l:$100;p:$100;crc:$3ae69aca),
        (n:'lr2-h-3n';l:$100;p:$200;crc:$2b28aec5),(n:'lr2-b-1m';l:$100;p:$300;crc:$4ec9bb3d),
        (n:'lr2-b-1n';l:$100;p:$400;crc:$1daf1fa4),(n:'lr2-b-1l';l:$100;p:$500;crc:$c8fb708a),
        (n:'lr2-b-5p';l:$20;p:$600;crc:$e01f69e2),());
        ldrun2_char:array[0..3] of tipo_roms=(
        (n:'lr2-h-1e';l:$2000;p:0;crc:$9d63a8ff),(n:'lr2-h-1j';l:$2000;p:$2000;crc:$40332bbd),
        (n:'lr2-h-1h';l:$2000;p:$4000;crc:$9404727d),());
        ldrun2_sound:array[0..3] of tipo_roms=(
        (n:'lr2-a-3e';l:$2000;p:$a000;crc:$853f3898),(n:'lr2-a-3f';l:$2000;p:$c000;crc:$7a96accd),
        (n:'lr2-a-3h';l:$2000;p:$e000;crc:$2a0e83ca),());
        ldrun2_sprites:array[0..6] of tipo_roms=(
        (n:'lr2-b-4k';l:$2000;p:0;crc:$79909871),(n:'lr2-b-4f';l:$2000;p:$2000;crc:$06ba1ef4),
        (n:'lr2-b-3n';l:$2000;p:$4000;crc:$3cc5893f),(n:'lr2-b-4n';l:$2000;p:$6000;crc:$49c12f42),
        (n:'lr2-b-4c';l:$2000;p:$8000;crc:$fbe6d24c),(n:'lr2-b-4e';l:$2000;p:$a000;crc:$75172d1f),());

type
    tipo_update_video_m62=procedure;
    tipo_calc_nchar_spelunker=function(color:byte):word;

var
 sound_command,val_port1,val_port2,ldrun_color,sprites_sp:byte;
 scroll_x,scroll_y:parejas;
 memoria_sprites:array[0..$1f] of byte;
 mem_rom:array[0..3,0..$1fff] of byte;
 mem_rom2:array[0..15,0..$fff] of byte;
 rom_bank,rom_bank2,pal_bank,ldrun2_banksw:byte;
 bankcontrol:array[0..1] of byte;
 update_video_m62:tipo_update_video_m62;
 calc_nchar_sp:tipo_calc_nchar_spelunker;

implementation

procedure Cargar_irem_m62;
begin
llamadas_maquina.iniciar:=iniciar_irem_m62;
llamadas_maquina.bucle_general:=irem_m62_principal;
llamadas_maquina.cerrar:=cerrar_irem_m62;
llamadas_maquina.reset:=reset_irem_m62;
llamadas_maquina.fps_max:=55;
end;

procedure draw_sprites(pos,col,col_mask,pri_mask,pri:byte);inline;
var
  f,i,h,atrib:byte;
  nchar,x,y,color:word;
  flipy:boolean;
  incr:integer;
begin
for f:=0 to $1f do begin
  if ((memoria[$c000+(f*8)] and pri_mask)=pri) then begin
    atrib:=memoria[$c005+(f*8)];
    nchar:=memoria[$c004+(f*8)]+((atrib and $07) shl 8);
    color:=(memoria[$c000+(f*8)] and col_mask) shl 3;
    x:=((memoria[$c007+(f*8)] and 1) shl 8)+memoria[$c006+(f*8)];
    y:=256+(128*pos)-15-(256*(memoria[$c003+(f*8)] and 1)+memoria[$c002+(f*8)]);
    flipy:=(atrib and $80)<>0;
    i:=memoria_sprites[(nchar shr 5) and $1f];
    case i of
      1:begin //doble
         y:=y-16;
         //Cojo el sprite base
         nchar:=nchar and $fffe;
        end;
      2:begin //Cuadruple
         i:=3;
  			 nchar:=nchar and $fffc;
  			 y:=y-3*16;
        end;
    end;
    if flipy then begin
  				incr:=-1;
  				nchar:=nchar+i;
    end else incr:=1;
    for h:=0 to i do begin
      put_gfx_sprite(nchar+(h*incr),color+(256*col),(atrib and $40)<>0,flipy,1);
      actualiza_gfx_sprite(x,y+(16*h),2,1);
    end;
  end;
end;
end;

procedure update_video_kungfum;
var
  f,nchar,y,x:word;
  atrib,color:byte;
begin
for f:=0 to $7ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 64;
    y:=f div 64;
    atrib:=memoria[$d800+f];
    color:=atrib and $1f;
    nchar:=memoria[$d000+f]+((atrib and $c0) shl 2);
    put_gfx_flip(x*8,y*8,nchar,color shl 3,1,0,(atrib and $20)<>0,false);
    if not((y<6) or ((color shr 1)>$0c)) then put_gfx_block_trans(x*8,y*8,3,8,8)
      else put_gfx_flip(x*8,y*8,nchar,color shl 3,3,0,(atrib and $20)<>0,false);
    gfx[0].buffer[f]:=false;
  end;
end;
scroll__x_part(1,2,scroll_x.w,0,48,464);
//Sprites
draw_sprites(1,1,$1f,0,0);
//La parte de arriba tiene prioridad sobre los sprites?
scroll__x_part(3,2,scroll_x.w,0,48,464);
actualiza_trozo(128,0,256,48,1,128,0,256,48,2);
actualiza_trozo_final(128,0,256,256,2);
end;

procedure update_video_ldrun;
var
  f,nchar,y,x:word;
  atrib,color:byte;
begin
for f:=0 to $7ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 64;
    y:=f div 64;
    atrib:=memoria[$d001+(f*2)];
    color:=atrib and $1f;
    nchar:=memoria[$d000+(f*2)]+((atrib and $c0) shl 2);
    put_gfx_flip(x*8,y*8,nchar,color shl 3,1,0,(atrib and $20)<>0,false);
    if not((color shr 1)>=ldrun_color) then put_gfx_block_trans(x*8,y*8,3,8,8)
      else put_gfx_trans_flip(x*8,y*8,nchar,color shl 3,3,0,(atrib and $20)<>0,false);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(64,0,384,256,1,64,0,384,256,2);
draw_sprites(1,1,$f,$10,0);
actualiza_trozo(64,0,384,256,3,64,0,384,256,2);
draw_sprites(1,1,$f,$10,$10);
actualiza_trozo_final(64,0,384,256,2);
end;

function calc_nchar_splunker(color:byte):word;
begin
  calc_nchar_splunker:=((color and $10) shl 4)+((color and $20) shl 6)+((color and $c0) shl 3);
end;

function calc_nchar_splunker2(color:byte):word;
begin
  calc_nchar_splunker2:=(color and $f0) shl 4;
end;

procedure update_video_spelunker;
var
  f,x,y:word;
  color,nchar:word;
begin
for f:=0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    color:=memoria[$c801+(f*2)];
    nchar:=memoria[$c800+(f*2)]+((color and $10) shl 4);
    put_gfx_trans(x*12,y*8,nchar,(pal_bank or (color and $f)) shl 3,3,0);
    gfx[0].buffer[f]:=false;
  end;
end;
for f:=0 to $fff do begin
  if gfx[2].buffer[f] then begin
    x:=f mod 64;
    y:=f div 64;
    color:=memoria[$a001+(f*2)];
    nchar:=memoria[$a000+(f*2)]+calc_nchar_sp(color);
    put_gfx(x*8,y*8,nchar,(pal_bank or (color and $f)) shl 3,1,2);
    gfx[2].buffer[f]:=false;
  end;
end;
scroll_x_y(1,2,scroll_x.w,scroll_y.w);
draw_sprites(2,sprites_sp,$1f,0,0);
actualiza_trozo_final(64,128,384,256,2);
actualiza_trozo(0,0,384,256,3,0,0,384,256,0);
end;

function iniciar_irem_m62:boolean;
var
      f:word;
      memoria_temp:array[0..$1ffff] of byte;
const
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
procedure cargar_paleta;
var
  colores:tpaleta;
  f:byte;
begin
for f:=0 to $ff do begin
    //Chars
    colores[f].r:=((memoria_temp[f] and $f) shl 4) or (memoria_temp[f] and $f);
    colores[f].g:=((memoria_temp[f+$100] and $f) shl 4) or (memoria_temp[f+$100] and $f);
    colores[f].b:=((memoria_temp[f+$200] and $f) shl 4) or (memoria_temp[f+$200] and $f);
    //Sprites
    colores[f+$100].r:=((memoria_temp[f+$300] and $f) shl 4) or (memoria_temp[f] and $f);
    colores[f+$100].g:=((memoria_temp[f+$400] and $f) shl 4) or (memoria_temp[f+$100] and $f);
    colores[f+$100].b:=((memoria_temp[f+$500] and $f) shl 4) or (memoria_temp[f+$200] and $f);
end;
set_pal(colores,512);
end;
procedure cargar_paleta_spl2;
var
  colores:tpaleta;
  f:word;
begin
for f:=0 to $1ff do begin
    //Chars
    colores[f].r:=((memoria_temp[f] and $f) shl 4) or (memoria_temp[f] and $f);
    colores[f].g:=((memoria_temp[f] and $f0) shr 4) or (memoria_temp[f] and $f0);
    colores[f].b:=((memoria_temp[f+$200] and $f) shl 4) or (memoria_temp[f+$200] and $f);
end;
for f:=0 to $ff do begin
    colores[f+$200].r:=((memoria_temp[f+$400] and $f) shl 4) or (memoria_temp[f+$400] and $f);
    colores[f+$200].g:=((memoria_temp[f+$500] and $f) shl 4) or (memoria_temp[f+$500] and $f);
    colores[f+$200].b:=((memoria_temp[f+$600] and $f) shl 4) or (memoria_temp[f+$600] and $f);
end;
set_pal(colores,768);
end;
procedure make_chars_spl;
const
    pc_spl_x:array[0..11] of dword=(0,1,2,3,
		    $2000*8+0,$2000*8+1,$2000*8+2,$2000*8+3,
    		$2000*8+4,$2000*8+5,$2000*8+6,$2000*8+7);
var
  mem_char:array[0..$bfff] of byte;
begin
  copymemory(@mem_char[$0000],@memoria_temp[$0000],$800);
  copymemory(@mem_char[$2000],@memoria_temp[$0800],$800);
  copymemory(@mem_char[$0800],@memoria_temp[$1000],$800);
  copymemory(@mem_char[$2800],@memoria_temp[$1800],$800);
  copymemory(@mem_char[$1000],@memoria_temp[$2000],$800);
  copymemory(@mem_char[$3000],@memoria_temp[$2800],$800);
  copymemory(@mem_char[$1800],@memoria_temp[$3000],$800);
  copymemory(@mem_char[$3800],@memoria_temp[$3800],$800);
  copymemory(@mem_char[$4000],@memoria_temp[$4000],$800);
  copymemory(@mem_char[$6000],@memoria_temp[$4800],$800);
  copymemory(@mem_char[$4800],@memoria_temp[$5000],$800);
  copymemory(@mem_char[$6800],@memoria_temp[$5800],$800);
  copymemory(@mem_char[$5000],@memoria_temp[$6000],$800);
  copymemory(@mem_char[$7000],@memoria_temp[$6800],$800);
  copymemory(@mem_char[$5800],@memoria_temp[$7000],$800);
  copymemory(@mem_char[$7800],@memoria_temp[$7800],$800);
  copymemory(@mem_char[$8000],@memoria_temp[$8000],$800);
  copymemory(@mem_char[$a000],@memoria_temp[$8800],$800);
  copymemory(@mem_char[$8800],@memoria_temp[$9000],$800);
  copymemory(@mem_char[$a800],@memoria_temp[$9800],$800);
  copymemory(@mem_char[$9000],@memoria_temp[$a000],$800);
  copymemory(@mem_char[$b000],@memoria_temp[$a800],$800);
  copymemory(@mem_char[$9800],@memoria_temp[$b000],$800);
  copymemory(@mem_char[$b800],@memoria_temp[$b800],$800);
  init_gfx(0,12,8,$200);
  gfx[0].trans[0]:=true;
  des_gfx.pos_planos[0]:=0;
  des_gfx.pos_planos[1]:=$4000*8;
  des_gfx.pos_planos[2]:=2*$4000*8;
  des_gfx.bit_pixel:=3;
  des_gfx.banks:=0;
  des_gfx.long_sprites:=8*8;
  convert_gfx(@gfx[0],0,@mem_char[0],@pc_spl_x[0],@pc_y[0],false,false);
end;
procedure make_chars(num:word;ngfx:byte);
begin
init_gfx(ngfx,8,8,num);
des_gfx.pos_planos[0]:=2*num*8*8;
des_gfx.pos_planos[1]:=num*8*8;
des_gfx.pos_planos[2]:=0;
des_gfx.bit_pixel:=3;
des_gfx.banks:=0;
des_gfx.long_sprites:=8*8;
convert_gfx(@gfx[ngfx],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
end;
procedure make_sprites(num:word);
begin
  init_gfx(1,16,16,num);
  gfx[1].trans[0]:=true;
  des_gfx.pos_planos[0]:=2*num*32*8;
  des_gfx.pos_planos[1]:=num*32*8;
  des_gfx.pos_planos[2]:=0;
  des_gfx.long_sprites:=32*8;
  convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
end;

begin
iniciar_irem_m62:=false;
fillchar(memoria_temp[0],$20000,0);
iniciar_audio(false);
//Pantallas:  principal+char y sprites
case main_vars.tipo_maquina of
  42:begin
        p_final[0].x:=256;
        p_final[1].scroll.long_x:=512;
        p_final[1].scroll.max_x:=256+128;
        p_final[1].scroll.mask_x:=511;
        p_final[3].scroll:=p_final[1].scroll;
     end;
  72,73:begin
          p_final[0].x:=384;
          p_final[1].scroll.long_x:=512;
          p_final[1].scroll.max_x:=384+128;
          p_final[1].scroll.mask_x:=511;
          p_final[1].scroll.long_y:=512;
          p_final[1].scroll.max_y:=256+128;
          p_final[1].scroll.mask_y:=511;
        end;
  74,75:p_final[0].x:=384;
end;
p_final[0].y:=256;
p_final[1].x:=512;
p_final[1].y:=512;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[2].final_mix:=true;
p_final[3].x:=512;
p_final[3].y:=512;
p_final[3].trans:=true;
iniciar_video;
//Sound CPU
snd_m6800:=cpu_m6800.create(3579545,1,CPU_M6803);
snd_m6800.change_ram_calls(snd_getbyte,snd_putbyte);
snd_m6800.change_io_calls(in_port1,in_port2,nil,nil,out_port1,out_port2,nil,nil);
snd_m6800.init_sound(irem_m62_sonido);
//sound chips
msm5205_init(0,384000,snd_m6800.numero_cpu,MSM5205_S96_4B,1,3579545/4,adpcm_int);
msm5205_init(1,384000,snd_m6800.numero_cpu,MSM5205_SEX_4B,1,3579545/4,nil);
ay8910_0:=ay8910_chip.create(3579545 div 4,1);
ay8910_0.change_io_calls(ay0_porta_r,nil,nil,ay0_portb_w);
ay8910_1:=ay8910_chip.create(3579545 div 4,1);
case main_vars.tipo_maquina of
  42:begin  //KungFu Master
        //Main CPU
        main_z80:=cpu_z80.create(3072000,1);
        main_z80.change_ram_calls(kungfum_getbyte,kungfum_putbyte);
        main_z80.change_io_calls(kungfum_inbyte,kungfum_outbyte);
        //video
        update_video_m62:=update_video_kungfum;
        //cargar roms
        if not(cargar_roms(@memoria[0],@kungfum_rom[0],'kungfum.zip',0)) then exit;
        //cargar sonido
        if not(cargar_roms(@mem_snd[0],@kungfum_sound[0],'kungfum.zip',0)) then exit;
        //convertir chars
        if not(cargar_roms(@memoria_temp[0],@kungfum_char[0],'kungfum.zip',0)) then exit;
        make_chars(1024,0);
        gfx[0].trans[0]:=true;
        //convertir sprites
        if not(cargar_roms(@memoria_temp[0],@kungfum_sprites[0],'kungfum.zip',0)) then exit;
        make_sprites(1024);
        //poner la paleta
        if not(cargar_roms(@memoria_temp[0],@kungfum_pal[0],'kungfum.zip',0)) then exit;
        cargar_paleta;
        copymemory(@memoria_sprites[0],@memoria_temp[$600],$20);
     end;
     72:begin  //Spelunker
        //Main CPU
        main_z80:=cpu_z80.create(4000000,1);
        main_z80.change_ram_calls(spl_getbyte,spl_putbyte);
        main_z80.change_io_calls(kungfum_inbyte,kungfum_outbyte);
        //video
        update_video_m62:=update_video_spelunker;
        calc_nchar_sp:=calc_nchar_splunker;
        sprites_sp:=1;
        //cargar roms y ponerlas en sus bancos
        if not(cargar_roms(@memoria_temp[0],@spl_rom[0],'spelunkr.zip',0)) then exit;
        copymemory(@memoria[0],@memoria_temp[0],$8000);
        for f:=0 to 3 do copymemory(@mem_rom[f,0],@memoria_temp[$8000+(f*$2000)],$2000);
        //cargar sonido
        if not(cargar_roms(@mem_snd[0],@spl_sound[0],'spelunkr.zip',0)) then exit;
        //convertir chars
        if not(cargar_roms(@memoria_temp[0],@spl_char[0],'spelunkr.zip',0)) then exit;
        make_chars_spl;
        //convertir sprites
        if not(cargar_roms(@memoria_temp[0],@spl_sprites[0],'spelunkr.zip',0)) then exit;
        make_sprites($400);
        //convertir tiles
        if not(cargar_roms(@memoria_temp[0],@spl_tiles[0],'spelunkr.zip',0)) then exit;
        make_chars(4096,2);
        //poner la paleta
        if not(cargar_roms(@memoria_temp[0],@spl_pal[0],'spelunkr.zip',0)) then exit;
        cargar_paleta;
        copymemory(@memoria_sprites[0],@memoria_temp[$600],$20);
     end;
     73:begin  //Spelunker II
        //Main CPU
        main_z80:=cpu_z80.create(4000000,1);
        main_z80.change_ram_calls(spl2_getbyte,spl2_putbyte);
        main_z80.change_io_calls(kungfum_inbyte,kungfum_outbyte);
        //video
        update_video_m62:=update_video_spelunker;
        calc_nchar_sp:=calc_nchar_splunker2;
        sprites_sp:=2;
        //cargar roms y ponerlas en sus bancos (2)
        if not(cargar_roms(@memoria_temp[0],@spl2_rom[0],'spelunk2.zip',0)) then exit;
        copymemory(@memoria[0],@memoria_temp[0],$8000);
        for f:=0 to 15 do copymemory(@mem_rom2[f,0],@memoria_temp[$8000+(f*$1000)],$1000);
        for f:=0 to 3 do copymemory(@mem_rom[f,0],@memoria_temp[$18000+(f*$1000)],$1000);
        //cargar sonido
        if not(cargar_roms(@mem_snd[0],@spl2_sound[0],'spelunk2.zip',0)) then exit;
        //convertir chars
        if not(cargar_roms(@memoria_temp[0],@spl2_char[0],'spelunk2.zip',0)) then exit;
        make_chars_spl;
        //convertir sprites
        if not(cargar_roms(@memoria_temp[0],@spl2_sprites[0],'spelunk2.zip',0)) then exit;
        make_sprites($400);
        //convertir tiles
        if not(cargar_roms(@memoria_temp[0],@spl2_tiles[0],'spelunk2.zip',0)) then exit;
        make_chars(4096,2);
        //poner la paleta
        if not(cargar_roms(@memoria_temp[0],@spl2_pal[0],'spelunk2.zip',0)) then exit;
        cargar_paleta_spl2;
        copymemory(@memoria_sprites[0],@memoria_temp[$700],$20);
     end;
     74:begin  //Lode Runner
        //Main CPU
        main_z80:=cpu_z80.create(4000000,1);
        main_z80.change_ram_calls(ldrun_getbyte,ldrun_putbyte);
        main_z80.change_io_calls(kungfum_inbyte,kungfum_outbyte);
        //video
        update_video_m62:=update_video_ldrun;
        ldrun_color:=$0c;
        //cargar roms
        if not(cargar_roms(@memoria[0],@ldrun_rom[0],'ldrun.zip',0)) then exit;
        //cargar sonido
        if not(cargar_roms(@mem_snd[0],@ldrun_sound[0],'ldrun.zip',0)) then exit;
        //convertir chars
        if not(cargar_roms(@memoria_temp[0],@ldrun_char[0],'ldrun.zip',0)) then exit;
        make_chars($400,0);
        gfx[0].trans[0]:=true;
        //convertir sprites
        if not(cargar_roms(@memoria_temp[0],@ldrun_sprites[0],'ldrun.zip',0)) then exit;
        make_sprites($100);
        //poner la paleta
        if not(cargar_roms(@memoria_temp[0],@ldrun_pal[0],'ldrun.zip',0)) then exit;
        cargar_paleta;
        copymemory(@memoria_sprites[0],@memoria_temp[$600],$20);
     end;
     75:begin  //Lode Runner II
        //Main CPU
        main_z80:=cpu_z80.create(4000000,1);
        main_z80.change_ram_calls(ldrun2_getbyte,ldrun2_putbyte);
        main_z80.change_io_calls(ldrun2_inbyte,ldrun2_outbyte);
        //video
        update_video_m62:=update_video_ldrun;
        ldrun_color:=$04;
        //cargar roms y ponerlas en sus bancos
        if not(cargar_roms(@memoria_temp[0],@ldrun2_rom[0],'ldrun2.zip',0)) then exit;
        copymemory(@memoria[0],@memoria_temp[0],$8000);
        for f:=0 to 1 do copymemory(@mem_rom[f,0],@memoria_temp[$8000+(f*$2000)],$2000);
        //cargar sonido
        if not(cargar_roms(@mem_snd[0],@ldrun2_sound[0],'ldrun2.zip',0)) then exit;
        //convertir chars
        if not(cargar_roms(@memoria_temp[0],@ldrun2_char[0],'ldrun2.zip',0)) then exit;
        make_chars($400,0);
        gfx[0].trans[0]:=true;
        //convertir sprites
        if not(cargar_roms(@memoria_temp[0],@ldrun2_sprites[0],'ldrun2.zip',0)) then exit;
        make_sprites($200);
        //poner la paleta
        if not(cargar_roms(@memoria_temp[0],@ldrun2_pal[0],'ldrun2.zip',0)) then exit;
        cargar_paleta;
        copymemory(@memoria_sprites[0],@memoria_temp[$600],$20);
     end;
end;
//final
reset_irem_m62;
iniciar_irem_m62:=true;
end;

procedure cerrar_irem_m62;
begin
main_z80.free;
snd_m6800.Free;
ay8910_0.Free;
ay8910_1.Free;
msm5205_close(0);
msm5205_close(1);
close_audio;
close_video;
end;

procedure reset_irem_m62;
begin
 main_z80.reset;
 snd_m6800.reset;
 reset_audio;
 ay8910_0.reset;
 ay8910_1.reset;
 msm5205_reset(0);
 msm5205_reset(1);
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 rom_bank:=0;
 rom_bank2:=0;
 pal_bank:=0;
 sound_command:=0;
 val_port1:=0;
 val_port2:=0;
 scroll_x.w:=0;
 scroll_y.w:=0;
 ldrun2_banksw:=0;
 bankcontrol[0]:=0;
 bankcontrol[1]:=0;
end;

procedure eventos_irem_m62;
begin
if event.arcade then begin
  if arcade_input.up[0] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.down[0] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.left[0] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.right[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.but0[0] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.but1[0] then in1:=(in1 and $7f) else in1:=(in1 or $80);
  if arcade_input.coin[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.coin[1] then in2:=(in2 and $ef) else in2:=(in2 or $10);
  if arcade_input.start[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.start[1] then in0:=(in0 and $fd) else in0:=(in0 or $2);
end;
end;

procedure irem_m62_principal;
var
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
frame_s:=snd_m6800.tframes;
while EmuStatus=EsRuning do begin
  //main
  main_z80.run(trunc(frame_m));
  frame_m:=frame_m+main_z80.tframes-main_z80.contador;
  //snd
  snd_m6800.run(trunc(frame_s));
  frame_s:=frame_s+snd_m6800.tframes-snd_m6800.contador;
  //end
  main_z80.pedir_irq:=HOLD_LINE;
  update_video_m62;
  eventos_irem_m62;
  video_sync;
end;
end;

//KungFu Master
function kungfum_getbyte(direccion:word):byte;
begin
  kungfum_getbyte:=memoria[direccion];
end;

procedure kungfum_putbyte(direccion:word;valor:byte);
begin
if direccion<$8000 then exit;
memoria[direccion]:=valor;
case direccion of
    $a000:scroll_x.l:=valor;
    $b000:scroll_x.h:=(valor and 1);
    $d000..$dfff:gfx[0].buffer[direccion and $7ff]:=true;
end;
end;

function kungfum_inbyte(puerto:word):byte;
begin
case (puerto and $ff) of
  $0:kungfum_inbyte:=in0;
  $1:kungfum_inbyte:=in1;
  $2:kungfum_inbyte:=in2;
  $3:kungfum_inbyte:=$ff;
  $4:kungfum_inbyte:=$fd;
end;
end;

procedure kungfum_outbyte(valor:byte;puerto:word);
begin
case (puerto and $ff) of
  0:if ((valor and $80)=0) then sound_command:=valor and $7f
    	else snd_m6800.pedir_irq:=ASSERT_LINE;
end;
end;

//Spelunker
function spl_getbyte(direccion:word):byte;
begin
case direccion of
  $8000..$9fff:spl_getbyte:=mem_rom[rom_bank,direccion and $1fff];
  else spl_getbyte:=memoria[direccion];
end;
end;

procedure spl_putbyte(direccion:word;valor:byte);
begin
if direccion<$a000 then exit;
memoria[direccion]:=valor;
case direccion of
    $a000..$bfff:gfx[2].buffer[(direccion and $1fff) shr 1]:=true;
    $c800..$cfff:gfx[0].buffer[(direccion and $7ff) shr 1]:=true;
    $d000:scroll_y.l:=valor;
    $d001:scroll_y.h:=(valor and 1);
    $d002:scroll_x.l:=valor;
    $d003:scroll_x.h:=(valor and 1);
    $d004:rom_bank:=(valor and 3);
    $d005:if pal_bank<>((valor and 1) shl 4) then begin
            pal_bank:=(valor and 1) shl 4;
            fillchar(gfx[0].buffer[0],$400,1);
            fillchar(gfx[2].buffer[0],$1000,1);
          end;
end;
end;

//Spelunker II
function spl2_getbyte(direccion:word):byte;
begin
case direccion of
  $8000..$8fff:spl2_getbyte:=mem_rom[rom_bank,direccion and $fff];
  $9000..$9fff:spl2_getbyte:=mem_rom2[rom_bank2,direccion and $fff];
  else spl2_getbyte:=memoria[direccion];
end;
end;

procedure spl2_putbyte(direccion:word;valor:byte);
begin
if direccion<$a000 then exit;
memoria[direccion]:=valor;
case direccion of
    $a000..$bfff:gfx[2].buffer[(direccion and $1fff) shr 1]:=true;
    $c800..$cfff:gfx[0].buffer[(direccion and $7ff) shr 1]:=true;
    $d000:scroll_y.l:=valor;
    $d001:scroll_x.l:=valor;
    $d002:begin
            scroll_x.h:=(valor and 2) shr 1;
	          scroll_y.h:=(valor and 1);
          	if (pal_bank<>((valor and $0c) shl 2)) then begin
                		pal_bank:=(valor and $0c) shl 2;
		                fillchar(gfx[0].buffer[0],$400,1);
                    fillchar(gfx[2].buffer[0],$1000,1);
            end;
          end;
    $d003:begin
            rom_bank:=(valor and $c0) shr 6;
            rom_bank2:=(valor and $3c) shr 2;
          end;
end;
end;

//Lode Runner
function ldrun_getbyte(direccion:word):byte;
begin
  ldrun_getbyte:=memoria[direccion];
end;

procedure ldrun_putbyte(direccion:word;valor:byte);
begin
if direccion<$8000 then exit;
memoria[direccion]:=valor;
case direccion of
  $d000..$dfff:gfx[0].buffer[(direccion and $fff) shr 1]:=true;
end;
end;

//Lode Runner II
function ldrun2_getbyte(direccion:word):byte;
begin
case direccion of
  $8000..$9fff:ldrun2_getbyte:=mem_rom[rom_bank,direccion and $1fff];
  else ldrun2_getbyte:=memoria[direccion];
end;
end;

procedure ldrun2_putbyte(direccion:word;valor:byte);
begin
if direccion<$a000 then exit;
memoria[direccion]:=valor;
case direccion of
  $d000..$dfff:gfx[0].buffer[(direccion and $fff) shr 1]:=true;
end;
end;

function ldrun2_inbyte(puerto:word):byte;
begin
case (puerto and $ff) of
  $0:ldrun2_inbyte:=in0;
  $1:ldrun2_inbyte:=in1;
  $2:ldrun2_inbyte:=in2;
  $3:ldrun2_inbyte:=$ff;
  $4:ldrun2_inbyte:=$fd;
  $80:begin
        if (ldrun2_banksw<>0) then begin
      		ldrun2_banksw:=ldrun2_banksw-1;
      		// swap to bank #1 on second read */
      		if (ldrun2_banksw=0) then rom_bank:=1;
        end;
        ldrun2_inbyte:=0;
      end;
end;
end;

procedure ldrun2_outbyte(valor:byte;puerto:word);
const
  banks:array[1..30] of byte=(
		0,0,0,0,0,1,0,1,0,0,
		0,1,1,1,1,1,0,0,0,0,
		1,0,1,1,1,1,1,1,1,1);
begin
case (puerto and $ff) of
  0:if ((valor and $80)=0) then sound_command:=valor and $7f
    	else snd_m6800.pedir_irq:=ASSERT_LINE;
  $80..$81:begin
             bankcontrol[puerto and 1]:=valor;
	           if ((puerto and 1)=0) then begin
		            rom_bank:=banks[valor];
             end else begin
		            if ((bankcontrol[0]=$1) and (valor=$0d)) then	ldrun2_banksw:=2
            		  else ldrun2_banksw:=0;
	            end;
           end;
end;
end;

//sonido
function snd_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$1f:snd_getbyte:=snd_m6800.m6803_internal_reg_r(direccion);
    else snd_getbyte:=mem_snd[direccion];
end;
end;

procedure snd_putbyte(direccion:word;valor:byte);
begin
if direccion>$3fff then exit;
mem_snd[direccion]:=valor;
case direccion of
  $0..$1f:snd_m6800.m6803_internal_reg_w(direccion,valor);
  $0800..$8ff:case direccion and $3 of
                  0:snd_m6800.pedir_irq:=CLEAR_LINE;
                  1:msm5205_data_w(0,valor);
                  2:msm5205_data_w(1,valor);
               end;
end;
end;

procedure out_port1(valor:byte);
begin
  val_port1:=valor;
end;

procedure out_port2(valor:byte);
begin
  if (((val_port2 and $01)<>0) and ((not(valor and $01))<>0)) then begin
		// control or data port? */
		if (val_port2 and $04)<>0 then begin
			// PSG 0 or 1? control */
			if (val_port2 and $08)<>0 then ay8910_0.control(val_port1);
			if (val_port2 and $10)<>0 then ay8910_1.control(val_port1);
		end else begin
			// PSG 0 or 1? data */
			if (val_port2 and $08)<>0 then AY8910_0.Write(val_port1);
			if (val_port2 and $10)<>0 then AY8910_1.Write(val_port1);
		end;
	end;
  val_port2:=valor;
end;

function in_port1:byte;
var
  ret:byte;
begin
 ret:=$ff;
 // PSG 0 or 1? */
	if (val_port2 and $08)<>0 then ret:=AY8910_0.Read
    else if (val_port2 and $10)<>0 then ret:=AY8910_1.Read;
	in_port1:=ret;
end;

function in_port2:byte;
begin
  in_port2:=0;
end;

function ay0_porta_r:byte;
begin
  ay0_porta_r:=sound_command;
end;

procedure ay0_portb_w(valor:byte);
begin
  // bits 0 and 1 reset the two chips */
	msm5205_reset_w(0,(valor and 1));
  msm5205_reset_w(1,(valor and 2));
end;

procedure adpcm_int;
begin
  snd_m6800.pedir_nmi:=PULSE_LINE;
end;

procedure irem_m62_sonido;
begin
  ay8910_0.update;
  ay8910_1.update;
end;

end.
