unit phoenix_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     nz80,main_engine,controls_engine,gfx_engine,tms36xx,
     phoenix_audio_digital,rom_engine,pal_engine,sound_engine;

procedure Cargar_Phoenix;
procedure phoenix_principal;
function phoenix_iniciar:boolean;
procedure phoenix_reset;
procedure phoenix_cerrar;
//Main CPU
function phoenix_getbyte(direccion:word):byte;
procedure phoenix_putbyte(direccion:word;valor:byte);
//Sound
procedure phoenix_sound_update;

var
 isinc,banco_pal:byte;
 scroll_y:byte;

const
        phoenix_rom:array[0..8] of tipo_roms=(
        (n:'ic45';l:$800;p:0;crc:$9f68086b),(n:'ic46';l:$800;p:$800;crc:$273a4a82),
        (n:'ic47';l:$800;p:$1000;crc:$3d4284b9),(n:'ic48';l:$800;p:$1800;crc:$cb5d9915),
        (n:'ic49';l:$800;p:$2000;crc:$a105e4e7),(n:'ic50';l:$800;p:$2800;crc:$ac5e9ec1),
        (n:'ic51';l:$800;p:$3000;crc:$2eab35b4),(n:'ic52';l:$800;p:$3800;crc:$aff8e9c5),());
        phoenix_char1:array[0..2] of tipo_roms=(
        (n:'ic23';l:$800;p:0;crc:$3c7e623f),(n:'ic24';l:$800;p:$800;crc:$59916d3b),());
        phoenix_char2:array[0..2] of tipo_roms=(
        (n:'ic39';l:$800;p:0;crc:$53413e8f),(n:'ic40';l:$800;p:$800;crc:$0be2ba91),());
        phoenix_pal:array[0..2] of tipo_roms=(
        (n:'ic40_b.bin';l:$100;p:0;crc:$79350b25),(n:'ic41_a.bin';l:$100;p:$100;crc:$e176b768),());

implementation

procedure Cargar_Phoenix;
begin
llamadas_maquina.iniciar:=phoenix_iniciar;
llamadas_maquina.bucle_general:=phoenix_principal;
llamadas_maquina.cerrar:=phoenix_cerrar;
llamadas_maquina.reset:=phoenix_reset;
llamadas_maquina.fps_max:=61.035156;
end;

function phoenix_iniciar:boolean;
var
      colores:tpaleta;
      f:word;
      g,ctemp1,ctemp2:byte;
      memoria_temp:array[0..$fff] of byte;
const
      pc_x:array[0..7] of dword=(7, 6, 5, 4, 3, 2, 1, 0);
      pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
      phoenix_dec:array[0..5] of extended=(0.5,0,0,1.05,0,0);
begin
phoenix_iniciar:=false;
iniciar_audio(false);
p_final[0].x:=208;
p_final[0].y:=248;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].scroll.long_y:=256;
p_final[1].scroll.max_y:=256;
p_final[1].scroll.mask_y:=255;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].trans:=true;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].final_mix:=true;
iniciar_video;
//Main CPU
main_z80:=cpu_z80.create(5500000,256);
main_z80.change_ram_calls(phoenix_getbyte,phoenix_putbyte);
main_z80.init_sound(phoenix_sound_update);
//Chip sonido
tms36xx_start(372,0.21,@phoenix_dec[0]);
phoenix_audio_start;
//cargar roms
if not(cargar_roms(@memoria[0],@phoenix_rom[0],'phoenix.zip',0)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@phoenix_char1[0],'phoenix.zip',0)) then exit;
init_gfx(0,8,8,512);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=256*8*8;
des_gfx.pos_planos[1]:=0;
des_gfx.bit_pixel:=2;
des_gfx.banks:=2;
des_gfx.long_sprites:=8*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//Segundo juego de chars
if not(cargar_roms(@memoria_temp[0],@phoenix_char2[0],'phoenix.zip',0)) then exit;
convert_gfx(@gfx[0],256*8*8,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//poner paleta
if not(cargar_roms(@memoria_temp[0],@phoenix_pal[0],'phoenix.zip',0)) then exit;
for f:=0 to 255 do begin
    ctemp1:=memoria_temp[f];
    ctemp2:=memoria_temp[f+256];
    colores[f].r:=$55*(ctemp1 and 1)+$AA*(ctemp2 and 1);
    colores[f].g:=$55*((ctemp1 shr 2) and 1)+$AA*((ctemp2 shr 2) and 1);
    colores[f].b:=$55*((ctemp1 shr 1) and 1)+$AA*((ctemp2 shr 1) and 1);
end;
set_pal(colores,256);
for g:=0 to $3f do begin
        ctemp1:=((g and $1c) shr 2) or ((g and 3) shl 3) or ((g and $20) shl 1);
        gfx[0].colores[g]:=ctemp1;
        gfx[0].colores[g+$40]:=ctemp1+$20;
end;
//final
phoenix_reset;
phoenix_iniciar:=true;
end;

procedure phoenix_cerrar;
begin
main_z80.free;
tms36xx_close;
phoenix_audio_cerrar;
close_audio;
close_video;
end;

procedure phoenix_reset;
begin
main_z80.reset;
scroll_y:=0;
banco_pal:=0;
isinc:=0;
in0:=$FF;
phoenix_audio_reset;
end;

procedure update_video_phoenix;inline;
var
    nchar:byte;
    color,f,x,y:word;
begin
for f:=0 to $3ff do begin
  x:=(31-(f shr 5)) shl 3;
  y:=(f and $1f) shl 3;
  if gfx[0].buffer[f] then begin
    nchar:=memoria[$4800+f];
    color:=((nchar and $e0) shr 3)+banco_pal;
    put_gfx(x,y,nchar,color,1,0);
    gfx[0].buffer[f]:=false;
  end;
  if gfx[0].buffer[f+$400] then begin
    nchar:=memoria[$4000+f];
    color:=((nchar and $e0) shr 3)+banco_pal+64;
    put_gfx_trans(x,y,nchar+256,color,2,0);
    gfx[0].buffer[f+$400]:=false;
  end;
end;
scroll__y(1,3,scroll_y);
actualiza_trozo(0,0,256,256,2,0,0,256,256,3);
actualiza_trozo_final(48,0,208,248,3);
end;

procedure eventos_phoenix;
begin
if event.arcade then begin
  if arcade_input.coin[0] then in0:=in0 and $FE else in0:=in0 or 1;
  if arcade_input.start[0] then in0:=in0 and $FD else in0:=in0 or 2;
  if arcade_input.start[1] then in0:=in0 and $FB else in0:=in0 or 4;
  if arcade_input.right[0] then in0:=in0 and $DF else in0:=in0 or $20;
  if arcade_input.left[0] then in0:=in0 and $BF else in0:=in0 or $40;
  if arcade_input.down[0] then in0:=in0 and $7F else in0:=in0 or $80;
  if arcade_input.but0[0] then in0:=in0 and $EF else in0:=in0 or $10;
end;
end;

procedure phoenix_principal;
var
  frame:single;
  f:byte;
begin
init_controls(false,false,false,true);
frame:=main_z80.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to $ff do begin
    main_z80.run(trunc(frame));
    frame:=frame+main_z80.tframes-main_z80.contador;
    case f of
        207:begin
              isinc:=$80;
              update_video_phoenix;
            end;
        255:isinc:=0;
    end;
  end;
  phoenix_audio_update;
  eventos_phoenix;
  video_sync;
end;
end;

function phoenix_getbyte(direccion:word):byte;
begin
direccion:=direccion and $7FFF;
case direccion of
        $5000..$53ff:phoenix_getbyte:=banco_pal shr 4;
        $5800..$5bff:phoenix_getbyte:=scroll_y;
        $7000..$73FF:phoenix_getbyte:=in0;
        $7800..$7bff:phoenix_getbyte:=isinc;
        else phoenix_getbyte:=memoria[direccion];
end;
end;

procedure phoenix_putbyte(direccion:word;valor:byte);
begin
direccion:=direccion and $7FFF;
if direccion<$4000 then exit;
memoria[direccion]:=valor;
case direccion of
  $4000..$43ff:gfx[0].buffer[(direccion and $3ff)+$400]:=true;
  $4800..$4bff:gfx[0].buffer[direccion and $3ff]:=true;
  $5000..$53ff:banco_pal:=valor shl 4;
  $5800..$5bff:scroll_y:=valor;
  $6000..$63ff:if sound_latch_a<>valor then begin
                  phoenix_wsound_a(valor);
                  sound_latch_a:=valor;
               end;
  $6800..$6bff:begin
                  phoenix_wsound_b(valor);
                  mm6221aa_tune_w(valor shr 6);
               end;
end;
end;

procedure phoenix_sound_update;
begin
  tms36xx_sound_update;
end;

end.
