unit skykid_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6809,m680x,namco_snd,main_engine,controls_engine,gfx_engine,rom_engine,
     pal_engine,misc_functions,sound_engine;

procedure Cargar_skykid;
procedure skykid_principal; 
function iniciar_skykid:boolean; 
procedure reset_skykid; 
procedure cerrar_skykid; 
//Main CPU
function skykid_getbyte(direccion:word):byte;
procedure skykid_putbyte(direccion:word;valor:byte);
//MCU CPU
function mcu_getbyte(direccion:word):byte;  
procedure mcu_putbyte(direccion:word;valor:byte); 
procedure out_port1(valor:byte); 
function in_port1:byte;
function in_port2:byte;


const
        skykid_rom:array[0..3] of tipo_roms=(
        (n:'sk2_2.6c';l:$4000;p:$0;crc:$ea8a5822),(n:'sk1-1c.6b';l:$4000;p:$4000;crc:$7abe6c6c),
        (n:'sk1_3.6d';l:$4000;p:$8000;crc:$314b8765),());
        skykid_char:tipo_roms=(n:'sk1_6.6l';l:$2000;p:0;crc:$58b731b9);
        skykid_tiles:tipo_roms=(n:'sk1_5.7e';l:$2000;p:0;crc:$c33a498e);
        skykid_sprites:array[0..2] of tipo_roms=(
        (n:'sk1_8.10n';l:$4000;p:0;crc:$44bb7375),(n:'sk1_7.10m';l:$4000;p:$4000;crc:$3454671d),());
        skykid_mcu:array[0..2] of tipo_roms=(
        (n:'sk2_4.3c';l:$2000;p:$8000;crc:$a460d0e0),(n:'cus63-63a1.mcu';l:$1000;p:$f000;crc:$6ef08fb3),());
        skykid_prom:array[0..5] of tipo_roms=(
        (n:'sk1-1.2n';l:$100;p:$0;crc:$0218e726),(n:'sk1-2.2p';l:$100;p:$100;crc:$fc0d5b85),
        (n:'sk1-3.2r';l:$100;p:$200;crc:$d06b620b),(n:'sk1-4.5n';l:$200;p:$300;crc:$c697ac72),
        (n:'sk1-5.6n';l:$200;p:$500;crc:$161514a4),());

var
 rom_bank:array[0..1,0..$1fff] of byte;
 rom_nbank,scroll_y,inputport_selected,priority:byte;
 scroll_x:word;
 irq_enable,irq_enable_mcu:boolean;

implementation

procedure Cargar_skykid;
begin
llamadas_maquina.iniciar:=iniciar_skykid;
llamadas_maquina.bucle_general:=skykid_principal;
llamadas_maquina.cerrar:=cerrar_skykid;
llamadas_maquina.reset:=reset_skykid;
llamadas_maquina.fps_max:=60.60606060606060;
end;

function iniciar_skykid:boolean; 
var
  colores:tpaleta;
  f:word;
  memoria_temp:array[0..$ffff] of byte;
const
    pc_x:array[0..7] of dword=(8*8, 8*8+1, 8*8+2, 8*8+3, 0, 1, 2, 3 );
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8 );
    ps_x:array[0..15] of dword=(0, 1, 2, 3, 8*8, 8*8+1, 8*8+2, 8*8+3,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 24*8+0, 24*8+1, 24*8+2, 24*8+3);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			32*8, 33*8, 34*8, 35*8, 36*8, 37*8, 38*8, 39*8);
    pt_x:array[0..7] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3 );
    pt_y:array[0..7] of dword=(0*8, 2*8, 4*8, 6*8, 8*8, 10*8, 12*8, 14*8);
begin
iniciar_skykid:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=288;
p_final[0].y:=224;
p_final[1].x:=288;
p_final[1].y:=224;
p_final[1].trans:=true;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].scroll.long_x:=512;
p_final[2].scroll.long_y:=256;
p_final[2].scroll.max_x:=512;
p_final[2].scroll.max_y:=256;
p_final[2].scroll.mask_x:=511;
p_final[2].scroll.mask_y:=255;
p_final[3].x:=512;
p_final[3].y:=256;
p_final[3].final_mix:=true;
iniciar_video;
//Main CPU
main_m6809:=cpu_m6809.Create(1536000,256);
main_m6809.change_ram_calls(skykid_getbyte,skykid_putbyte);
//MCU CPU
main_m6800:=cpu_m6800.create(6144000,$100,cpu_hd63701);
main_m6800.change_ram_calls(mcu_getbyte,mcu_putbyte);
main_m6800.change_io_calls(in_port1,in_port2,nil,nil,out_port1,nil,nil,nil);
//cargar roms
if not(cargar_roms(@memoria_temp[0],@skykid_rom[0],'skykid.zip',0)) then exit;
//Pongo las ROMs en su banco
copymemory(@memoria[$8000],@memoria_temp[$0],$8000);
for f:=0 to 1 do copymemory(@rom_bank[f,0],@memoria_temp[$8000+(f*$2000)],$2000);
//Cargar MCU
if not(cargar_roms(@mem_snd[0],@skykid_mcu[0],'skykid.zip',0)) then exit;
namco_sound_init(8,true);
//convertir chars
if not(cargar_roms(@memoria_temp[0],@skykid_char,'skykid.zip',1)) then exit;
init_gfx(0,8,8,$200);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=4;
des_gfx.bit_pixel:=2;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
fillchar(memoria_temp[0],$10000,0);
if not(cargar_roms(@memoria_temp[0],@skykid_sprites[0],'skykid.zip',0)) then exit;
// unpack the third sprite ROM
for f:=0 to $1fff do begin
		memoria_temp[f+$4000+$4000]:=memoria_temp[f+$4000];		// sprite set #1, plane 3
		memoria_temp[f+$6000+$4000]:=memoria_temp[f+$4000] shr 4;	// sprite set #2, plane 3
		memoria_temp[f+$4000]:=memoria_temp[f+$2000+$4000];		// sprite set #3, planes 1&2 (plane 3 is empty)
end;
init_gfx(1,16,16,$200);
des_gfx.pos_planos[0]:=$200*64*8+4;
des_gfx.pos_planos[1]:=0;
des_gfx.pos_planos[2]:=4;
des_gfx.bit_pixel:=3;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@skykid_tiles,'skykid.zip',1)) then exit;
init_gfx(2,8,8,$200);
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=4;
des_gfx.bit_pixel:=2;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[2],0,@memoria_temp[0],@pt_x[0],@pt_y[0],false,false);
//Paleta
if not(cargar_roms(@memoria_temp[0],@skykid_prom[0],'skykid.zip',0)) then exit;
for f:=0 to $ff do begin
  colores[f].r:=(memoria_temp[f] and $f)+((memoria_temp[f] and $f) shl 4);
  colores[f].g:=(memoria_temp[f+$100] and $f)+((memoria_temp[f+$100] and $f) shl 4);
  colores[f].b:=(memoria_temp[f+$200] and $f)+((memoria_temp[f+$200] and $f) shl 4);
end;
set_pal(colores,$100);
// tiles/sprites color table
for f:=$0 to $3ff do begin
  gfx[1].colores[f]:=memoria_temp[$300+f];
  gfx[2].colores[f]:=memoria_temp[$300+f];
end;
//final
reset_skykid;
iniciar_skykid:=true;
end;

procedure cerrar_skykid;
begin
main_m6809.Free;
main_m6800.Free;
close_audio;
close_video;
end;

procedure reset_skykid;
begin
 main_m6809.reset;
 main_m6800.reset;
 namco_sound_reset;
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 in3:=$ff;
 rom_nbank:=0;
 irq_enable:=false;
 irq_enable_mcu:=false;
 scroll_y:=0;
 inputport_selected:=0;
 scroll_x:=0;
end;

procedure draw_sprites;inline;
const
  gfx_offs:array[0..1,0..1] of byte=((0,1),(2,3));
var
  f:byte;
  nchar,color,sx,sy:word;
  flipx,flipy,atrib:byte;
  sizex,sizey,x,y:byte;
begin
	for f:=0 to $3f do begin
    atrib:=memoria[$5f80+(f*2)];
		nchar:=memoria[$4f80+(f*2)]+(atrib and $80) shl 1;
		color:=(memoria[$4f81+(f*2)] and $3f) shl 3;
		sx:=memoria[$5781+(f*2)]+(memoria[$5f81+(f*2)] and 1) shl 8;
		sy:=memoria[$5780+(f*2)];
		flipx:=not(atrib) and $01;
		flipy:=(not(atrib) and $02) shr 1;
		sizex:=(atrib and $04) shr 2;
		sizey:=(atrib and $08) shr 3;
		sy:=sy+16*sizey-9;
		for y:=0 to sizey do begin
			for x:=0 to sizex do begin
        put_gfx_sprite_mask(nchar+gfx_offs[y xor (sizey*flipy),x xor (sizex*flipx)],color+$200,flipx=0,flipy=0,1,$ff,$ff);
        actualiza_gfx_sprite(343-(sx+16*x),sy-16*y,3,1);
			end;
		end;
	end;
end;

procedure update_video_skykid;inline;
var
  f,color,nchar,offs:word;
  x,y,sx,sy,atrib:byte;
begin
for x:=0 to 27 do begin
  for y:=0 to 35 do begin
     sx:=x+2;
     sy:=y-2;
	   if (sy and $20)<>0 then offs:=sx+((sy and $1f) shl 5)
	    else offs:=sy+(sx shl 5);
     if gfx[0].buffer[offs] then begin
       color:=((memoria[$4400+offs]) and $3f) shl 2;
       put_gfx_trans(y*8,x*8,memoria[$4000+offs],color,1,0);
       gfx[0].buffer[offs]:=false;
     end;
  end;
end;
for f:=0 to $7ff do begin
  if gfx[2].buffer[f] then begin
    x:=f mod 64;
    y:=f div 64;
    atrib:=memoria[$2800+f];
    color:=(((atrib and $7e) shr 1)+((atrib and $01) shl 6)) shl 2;
    nchar:=memoria[$2000+f]+(atrib and $1) shl 8;
    put_gfx(x*8,y*8,nchar,color,2,2);
    gfx[2].buffer[f]:=false;
  end;
end;
scroll_x_y(2,3,scroll_x,scroll_y);
if (priority and $f0)<>$50 then begin
  draw_sprites;
  actualiza_trozo(0,0,288,224,1,0,0,288,224,3);
end else begin
  actualiza_trozo(0,0,288,224,1,0,0,288,224,3);
  draw_sprites;
end;
actualiza_trozo_final(0,0,288,224,3);
end;

procedure eventos_skykid;
begin
if event.arcade then begin
  //P1
  if arcade_input.left[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.right[0] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.down[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.up[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.but0[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.but1[0] then in3:=(in3 and $f7) else in3:=(in3 or $8);
  //P2
  if arcade_input.left[1] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.right[1] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.down[1] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.up[1] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.but0[1] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.but1[1] then in3:=(in3 and $fb) else in3:=(in3 or $4);
  //COIN
  if arcade_input.coin[0] then in2:=(in2 and $fe) else in2:=(in2 or $1);
  if arcade_input.coin[1] then in2:=(in2 and $fd) else in2:=(in2 or $2);
  if arcade_input.start[0] then in2:=(in2 and $f7) else in2:=(in2 or $8);
  if arcade_input.start[1] then in2:=(in2 and $ef) else in2:=(in2 or $10);
end;
end;

procedure skykid_principal;
var
  f:word;
  frame_m,frame_mcu:single;
begin
init_controls(false,false,false,true);
frame_m:=main_m6809.tframes;
frame_mcu:=main_m6800.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to $ff do begin
    //Main CPU
    main_m6809.run(trunc(frame_m));
    frame_m:=frame_m+main_m6809.tframes-main_m6809.contador;
    //Sound CPU
    main_m6800.run(trunc(frame_mcu));
    frame_mcu:=frame_mcu+main_m6800.tframes-main_m6800.contador;
  end;
  if irq_enable then main_m6809.pedir_irq:=ASSERT_LINE;
  if irq_enable_mcu then main_m6800.pedir_irq:=ASSERT_LINE;
  if sound_status.hay_sonido then begin
      namco_playsound;
      play_sonido;
  end;
  update_video_skykid;
  eventos_skykid;
  video_sync;
end;
end;

function skykid_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$1fff:skykid_getbyte:=rom_bank[rom_nbank,direccion];
  $6800..$6bff:skykid_getbyte:=namcos1_cus30_r(direccion and $3ff);
  else skykid_getbyte:=memoria[direccion];
end;
end;

procedure skykid_putbyte(direccion:word;valor:byte);
begin
case direccion of
  $0..$1fff:exit;
  $2000..$2fff:gfx[2].buffer[direccion and $7ff]:=true;
  $4000..$47ff:gfx[0].buffer[direccion and $3ff]:=true;
  $6000..$60ff:begin
                  scroll_y:=direccion and $ff;
                  scroll_y:=(7-scroll_y) and $ff;
               end;
  $6200..$63ff:begin
                  scroll_x:=direccion and $1ff;
                  scroll_x:=(189-(scroll_x xor 1)) and $1ff;
               end;
  $6800..$6bff:namcos1_cus30_w(direccion and $3ff,valor);
  $7000..$7fff:begin
                   irq_enable:=not(BIT((direccion and $fff),11));
                   if not(irq_enable) then main_m6809.pedir_irq:=CLEAR_LINE;
               end;
  $8000..$8fff:if not(BIT((direccion and $fff),11)) then main_m6800.reset;
  $9000..$9fff:rom_nbank:=(not(BIT_n((direccion and $fff),11))) and 1;
  $a000..$a001:priority:=valor;
end;
if direccion<$8000 then memoria[direccion]:=valor;
end;

function mcu_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$1f:mcu_getbyte:=main_m6800.m6803_internal_reg_r(direccion);
  $1000..$13ff:mcu_getbyte:=namcos1_cus30_r(direccion and $3ff);
    else mcu_getbyte:=mem_snd[direccion];
end;
end;

procedure mcu_putbyte(direccion:word;valor:byte);
begin
case direccion of
  $0..$1f:main_m6800.m6803_internal_reg_w(direccion,valor);
  $1000..$13ff:namcos1_cus30_w(direccion and $3ff,valor);
  $4000..$7fff:begin
                  irq_enable_mcu:=not(BIT(direccion and $3fff,13));
                  if not(irq_enable_mcu) then main_m6800.pedir_irq:=CLEAR_LINE;
               end;
  $8000..$bfff,$f000..$ffff:exit;
end;
mem_snd[direccion]:=valor;
end;

procedure out_port1(valor:byte);
begin
if ((valor and $e0)=$60) then inputport_selected:=valor and $07;
end;

function in_port1:byte;
begin
  case inputport_selected of
		$00:in_port1:=(($ff) and $f8) shr 3;	// DSW B (bits 0-4) */
		$01:in_port1:=((($ff) and $7) shl 2) or ((($ff) and $c0) shr 6);// DSW B (bits 5-7), DSW A (bits 0-1) */
		$02:in_port1:=(($ff) and $3e) shr 1;	// DSW A (bits 2-6) */
		$03:in_port1:=((($ff) and $1) shl 4) or (in3 and $f);	// DSW A (bit 7), DSW C (bits 0-3) */
		$04:in_port1:=in2;	// coins, start */
		$05:in_port1:=in1;	// 2P controls */
		$06:in_port1:=in0;	// 1P controls */
    else in_port1:=$ff;
	end;
end;

function in_port2:byte;
begin
  in_port2:=$ff;
end;

end.
