unit sonson_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6809,ay_8910,main_engine,controls_engine,gfx_engine,rom_engine,
     pal_engine,sound_engine,timer_engine,qsnapshot;

procedure Cargar_sonson;
procedure sonson_principal;
function iniciar_sonson:boolean;
procedure reset_sonson;
procedure cerrar_sonson;
//Main CPU
function sonson_getbyte(direccion:word):byte;
procedure sonson_putbyte(direccion:word;valor:byte);
//Sound CPU
function ssonson_getbyte(direccion:word):byte;
procedure ssonson_putbyte(direccion:word;valor:byte);
procedure sonson_sound_update;
procedure sonson_snd_irq;
//Save/load
procedure sonson_qsave(nombre:string);
procedure sonson_qload(nombre:string);

const
        sonson_rom:array[0..3] of tipo_roms=(
        (n:'ss.01e';l:$4000;p:$4000;crc:$cd40cc54),(n:'ss.02e';l:$4000;p:$8000;crc:$c3476527),
        (n:'ss.03e';l:$4000;p:$c000;crc:$1fd0e729),());
        sonson_sonido:tipo_roms=(n:'ss_6.c11';l:$2000;p:$e000;crc:$1135c48a);
        sonson_char:array[0..2] of tipo_roms=(
        (n:'ss_7.b6';l:$2000;p:0;crc:$990890b1),(n:'ss_8.b5';l:$2000;p:$2000;crc:$9388ff82),());
        sonson_sprites:array[0..6] of tipo_roms=(
        (n:'ss_9.m5';l:$2000;p:0;crc:$8cb1cacf),(n:'ss_10.m6';l:$2000;p:$2000;crc:$f802815e),
        (n:'ss_11.m3';l:$2000;p:$4000;crc:$4dbad88a),(n:'ss_12.m4';l:$2000;p:$6000;crc:$aa05e687),
        (n:'ss_13.m1';l:$2000;p:$8000;crc:$66119bfa),(n:'ss_14.m2';l:$2000;p:$a000;crc:$e14ef54e),());
        sonson_prom:array[0..4] of tipo_roms=(
        (n:'ssb4.b2';l:$20;p:0;crc:$c8eaf234),(n:'ssb5.b1';l:$20;p:$20;crc:$0e434add),
        (n:'ssb2.c4';l:$100;p:$40;crc:$c53321c6),(n:'ssb3.h7';l:$100;p:$140;crc:$7d2c324a),());

var
 soundlatch,last:byte;
 scroll_x:byte;

implementation

procedure Cargar_sonson;
begin
llamadas_maquina.iniciar:=iniciar_sonson;
llamadas_maquina.bucle_general:=sonson_principal;
llamadas_maquina.cerrar:=cerrar_sonson;
llamadas_maquina.reset:=reset_sonson;
llamadas_maquina.save_qsnap:=sonson_qsave;
llamadas_maquina.load_qsnap:=sonson_qload;
end;

function iniciar_sonson:boolean;
var
      colores:tpaleta;
      f:word;
      memoria_temp:array[0..$bfff] of byte;
const
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
  ps_x:array[0..15] of dword=(8*16+7, 8*16+6, 8*16+5, 8*16+4, 8*16+3, 8*16+2, 8*16+1, 8*16+0,
			7, 6, 5, 4, 3, 2, 1, 0);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_sonson:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=240;
p_final[0].y:=240;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].final_mix:=true;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].scroll.long_x:=256;
p_final[2].scroll.max_x:=256;
p_final[2].scroll.mask_x:=255;
iniciar_video;
//Main CPU
main_m6809:=cpu_m6809.Create(2000000,256);
main_m6809.change_ram_calls(sonson_getbyte,sonson_putbyte);
//Sound CPU
snd_m6809:=cpu_m6809.Create(2000000,256);
snd_m6809.change_ram_calls(ssonson_getbyte,ssonson_putbyte);
snd_m6809.init_sound(sonson_sound_update);
//IRQ Sound CPU
init_timer(1,2000000/(4*60),sonson_snd_irq,true);
//Sound Chip
AY8910_0:=ay8910_chip.create(1500000,1);
AY8910_1:=ay8910_chip.create(1500000,1);
//cargar roms
if not(cargar_roms(@memoria[0],@sonson_rom[0],'sonson.zip',0)) then exit;
//Cargar Sound
if not(cargar_roms(@mem_snd[0],@sonson_sonido,'sonson.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@sonson_char[0],'sonson.zip',0)) then exit;
init_gfx(0,8,8,1024);
des_gfx.pos_planos[0]:=$2000*8;
des_gfx.pos_planos[1]:=0*8;
des_gfx.bit_pixel:=2;
des_gfx.banks:=0;
des_gfx.long_sprites:=8*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@sonson_sprites[0],'sonson.zip',0)) then exit;
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_gfx.pos_planos[0]:=$8000*8;
des_gfx.pos_planos[1]:=$4000*8;
des_gfx.pos_planos[2]:=0*8;
des_gfx.bit_pixel:=3;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//colores
if not(cargar_roms(@memoria_temp[0],@sonson_prom[0],'sonson.zip',0)) then exit;
for f:=0 to 31 do begin
  colores[f].r:=((memoria_temp[f+$20] and $f) shl 4) or (memoria_temp[f+$20] and $f);
  colores[f].g:=((memoria_temp[f] and $f0) shr 4) or (memoria_temp[f] and $f0);
  colores[f].b:=((memoria_temp[f] and $f) shl 4) or (memoria_temp[f] and $f);
end;
set_pal(colores,32);
for f:=0 to 255 do begin
  gfx[0].colores[f]:=memoria_temp[$40+f];
  gfx[1].colores[f]:=memoria_temp[$140+f]+16;
end;
//final
reset_sonson;
iniciar_sonson:=true;
end;

procedure cerrar_sonson;
begin
main_m6809.Free;
snd_m6809.Free;
AY8910_0.Free;
AY8910_1.Free;
close_audio;
close_video;
end;

procedure reset_sonson;
begin
 main_m6809.reset;
 snd_m6809.reset;
 AY8910_0.reset;
 AY8910_1.reset;
 reset_audio;
 soundlatch:=0;
 last:=0;
 scroll_x:=0;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
end;

procedure update_video_sonson;inline;
var
  f,color,nchar:word;
  x,y,atrib:byte;
begin
//chars
for f:=$0 to $3ff do begin
 if gfx[0].buffer[f] then begin
    y:=f div 32;
    x:=f mod 32;
    atrib:=memoria[$1400+f];
    color:=atrib and $fc;
    nchar:=memoria[$1000+f]+((atrib and $3) shl 8);
    put_gfx(x*8,y*8,nchar,color,2,0);
    gfx[0].buffer[f]:=false;
 end;
end;
scroll__x(2,1,scroll_x);
actualiza_trozo(0,0,256,40,2,0,0,256,40,1);
//sprites
for f:=$17 downto 0 do begin
  atrib:=memoria[$2021+(f*4)];
  nchar:=memoria[$2022+(f*4)]+((atrib and $20) shl 3);
  color:=(atrib and $1f) shl 3;
  x:=memoria[$2023+(f*4)];
  y:=memoria[$2020+(f*4)];
  put_gfx_sprite(nchar,color,(atrib and $40)=0,(atrib and $80)=0,1);
  actualiza_gfx_sprite(x,y,1,1);
end;
actualiza_trozo_final(8,8,240,240,1);
end;

procedure eventos_sonson;
begin
if event.arcade then begin
  if arcade_input.up[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.down[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.left[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.right[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.but0[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.coin[0] then in2:=(in2 and $ef) else in2:=(in2 or $10);
  if arcade_input.coin[1] then in2:=(in2 and $df) else in2:=(in2 or $20);
  if arcade_input.start[0] then in2:=(in2 and $fe) else in2:=(in2 or 1);
  if arcade_input.start[1] then in2:=(in2 and $fd) else in2:=(in2 or 2);
  if arcade_input.up[1] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.down[1] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.left[1] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.right[1] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.but0[1] then in1:=(in1 and $fe) else in1:=(in1 or $1);
end;
end;

procedure sonson_principal;
var
  f:byte;
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_m6809.tframes;
frame_s:=snd_m6809.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to 255 do begin
    //Main CPU
    main_m6809.run(trunc(frame_m));
    frame_m:=frame_m+main_m6809.tframes-main_m6809.contador;
    //Snd CPU
    snd_m6809.run(trunc(frame_s));
    frame_s:=frame_s+snd_m6809.tframes-snd_m6809.contador;
    if f=247 then begin
      main_m6809.pedir_irq:=HOLD_LINE;
      update_video_sonson;
    end;
  end;
  eventos_sonson;
  video_sync;
end;
end;

function sonson_getbyte(direccion:word):byte;
begin
    case direccion of
        0..$17ff,$2020..$207f,$4000..$ffff:sonson_getbyte:=memoria[direccion];
        $3002:sonson_getbyte:=in0;
        $3003:sonson_getbyte:=in1;
        $3004:sonson_getbyte:=in2;
        $3005:sonson_getbyte:=$DF;
        $3006:sonson_getbyte:=$EB;
    end;
end;

procedure sonson_putbyte(direccion:word;valor:byte);
begin
if direccion>$3FFF then exit;
memoria[direccion]:=valor;
case direccion of
  $1000..$17ff:gfx[0].buffer[direccion and $3ff]:=true;
  $3000:scroll_x:=valor;
  $3010:soundlatch:=valor;
  $3019:begin
          if ((last=0) and ((valor and 1)=1)) then snd_m6809.pedir_firq:=HOLD_LINE;
          last:=valor and 1;
        end;
end;
end;

function ssonson_getbyte(direccion:word):byte;
begin
case direccion of
  0..$7ff,$e000..$ffff:ssonson_getbyte:=mem_snd[direccion];
  $a000:ssonson_getbyte:=soundlatch
end;
end;

procedure ssonson_putbyte(direccion:word;valor:byte);
begin
if direccion>$dFFF then exit;
mem_snd[direccion]:=valor;
case direccion of
  $2000:ay8910_0.Control(valor);
  $2001:ay8910_0.Write(valor);
  $4000:ay8910_1.Control(valor);
  $4001:ay8910_1.Write(valor);
end;
end;

procedure sonson_snd_irq;
begin
  snd_m6809.pedir_irq:=HOLD_LINE;
end;

procedure sonson_sound_update;
begin
  ay8910_0.update;
  ay8910_1.update;
end;

procedure sonson_qsave(nombre:string);
var
  data:pbyte;
  buffer:array[0..2] of byte;
  size:word;
begin
open_qsnapshot_save('sonson'+nombre);
getmem(data,250);
//CPU
size:=main_m6809.save_snapshot(data);
savedata_qsnapshot(data,size);
size:=snd_m6809.save_snapshot(data);
savedata_qsnapshot(data,size);
//SND
size:=AY8910_0.save_snapshot(data);
savedata_qsnapshot(data,size);
size:=AY8910_1.save_snapshot(data);
savedata_qsnapshot(data,size);
//MEM
savedata_com_qsnapshot(@memoria[$0],$4000);
savedata_com_qsnapshot(@mem_snd[$0],$e000);
//MISC
buffer[0]:=soundlatch;
buffer[1]:=last;
buffer[2]:=scroll_x;
savedata_qsnapshot(@buffer[0],3);
freemem(data);
close_qsnapshot;
end;

procedure sonson_qload(nombre:string);
var
  data:pbyte;
  buffer:array[0..2] of byte;
begin
if not(open_qsnapshot_load('sonson'+nombre)) then exit;
getmem(data,250);
//CPU
loaddata_qsnapshot(data);
main_m6809.load_snapshot(data);
loaddata_qsnapshot(data);
snd_m6809.load_snapshot(data);
//SND
loaddata_qsnapshot(data);
AY8910_0.load_snapshot(data);
loaddata_qsnapshot(data);
AY8910_1.save_snapshot(data);
//MEM
loaddata_qsnapshot(@memoria[0]);
loaddata_qsnapshot(@mem_snd[$0]);
//MISC
loaddata_qsnapshot(@buffer[0]);
soundlatch:=buffer[0];
last:=buffer[1];
scroll_x:=buffer[2];
freemem(data);
close_qsnapshot;
//END
fillchar(gfx[0].buffer[0],$400,1);
end;

end.
