unit system86_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6809,m680x,namco_snd,main_engine,controls_engine,gfx_engine,
     ym_2151,rom_engine,pal_engine,misc_functions,sound_engine;

procedure Cargar_system86;
procedure system86_principal;
function iniciar_system86:boolean;
procedure reset_system86;
procedure cerrar_system86; 
//Main CPU
function system86_getbyte(direccion:word):byte;
procedure system86_putbyte(direccion:word;valor:byte);
procedure system86_putbyte_ext(direccion:word;valor:byte);
//Sub CPU
function rthunder_sub_getbyte(direccion:word):byte;
procedure rthunder_sub_putbyte(direccion:word;valor:byte);
function hopmappy_sub_getbyte(direccion:word):byte;
procedure hopmappy_sub_putbyte(direccion:word;valor:byte);
//MCU CPU
function rthunder_mcu_getbyte(direccion:word):byte;
procedure rthunder_mcu_putbyte(direccion:word;valor:byte);
function in_port1:byte;
function in_port2:byte;
//Video
procedure rthunder_video; 
procedure skykiddx_video; 
//Sound
procedure sound_instruccion;

type
    tipo_update_video_system86=procedure;
const
        //Rolling Thunder
        rthunder_rom:tipo_roms=(n:'rt3_1b.9c';l:$8000;p:$8000;crc:$7d252a1b);
        rthunder_rom_bank:array[0..4] of tipo_roms=(
        (n:'rt1_17.f1';l:$10000;p:0;crc:$766af455),(n:'rt1_18.h1';l:$10000;p:$10000;crc:$3f9f2f5d),
        (n:'rt3_19.k1';l:$10000;p:$20000;crc:$c16675e9),(n:'rt3_20.m1';l:$10000;p:$30000;crc:$c470681b),());
        rthunder_sub_rom:array[0..2] of tipo_roms=(
        (n:'rt3_2b.12c';l:$8000;p:$0;crc:$a7ea46ee),(n:'rt3_3.12d';l:$8000;p:$8000;crc:$a13f601c),());
        rthunder_chars:array[0..2] of tipo_roms=(
        (n:'rt1_7.7r';l:$10000;p:0;crc:$a85efa39),(n:'rt1_8.7s';l:$8000;p:$10000;crc:$f7a95820),());
        rthunder_tiles:array[0..2] of tipo_roms=(
        (n:'rt1_5.4r';l:$8000;p:0;crc:$d0fc470b),(n:'rt1_6.4s';l:$4000;p:$8000;crc:$6b57edb2),());
        rthunder_sprites:array[0..8] of tipo_roms=(
        (n:'rt1_9.12h';l:$10000;p:0;crc:$8e070561),(n:'rt1_10.12k';l:$10000;p:$10000;crc:$cb8fb607),
        (n:'rt1_11.12l';l:$10000;p:$20000;crc:$2bdf5ed9),(n:'rt1_12.12m';l:$10000;p:$30000;crc:$e6c6c7dc),
        (n:'rt1_13.12p';l:$10000;p:$40000;crc:$489686d7),(n:'rt1_14.12r';l:$10000;p:$50000;crc:$689e56a8),
        (n:'rt1_15.12t';l:$10000;p:$60000;crc:$1d8bf2ca),(n:'rt1_16.12u';l:$10000;p:$70000;crc:$1bbcf37b),());
        rthunder_mcu:array[0..2] of tipo_roms=(
        (n:'rt3_4.6b';l:$8000;p:$4000;crc:$00cf293f),(n:'cus60-60a1.mcu';l:$1000;p:$f000;crc:$076ea82a),());
        rthunder_prom:array[0..5] of tipo_roms=(
        (n:'rt1-1.3r';l:$200;p:$0;crc:$8ef3bb9d),(n:'rt1-2.3s';l:$200;p:$200;crc:$6510a8f2),
        (n:'rt1-3.4v';l:$800;p:$400;crc:$95c7d944),(n:'rt1-4.5v';l:$800;p:$c00;crc:$1391fec9),
        (n:'rt1-5.6u';l:$20;p:$1400;crc:$e4130804),());
        //Hopping Mappy
        hopmappy_rom:tipo_roms=(n:'hm1_1.9c';l:$8000;p:$8000;crc:$1a83914e);
        hopmappy_sub_rom:tipo_roms=(n:'hm1_2.12c';l:$4000;p:$c000;crc:$c46cda65);
        hopmappy_chars:tipo_roms=(n:'hm1_6.7r';l:$4000;p:$0;crc:$fd0e8887);
        hopmappy_tiles:tipo_roms=(n:'hm1_5.4r';l:$4000;p:$0;crc:$9c4f31ae);
        hopmappy_sprites:tipo_roms=(n:'hm1_4.12h';l:$8000;p:$0;crc:$78719c52);
        hopmappy_mcu:array[0..2] of tipo_roms=(
        (n:'hm1_3.6b';l:$2000;p:$8000;crc:$6496e1db),(n:'cus60-60a1.mcu';l:$1000;p:$f000;crc:$076ea82a),());
        hopmappy_prom:array[0..5] of tipo_roms=(
        (n:'hm1-1.3r';l:$200;p:$0;crc:$cc801088),(n:'hm1-2.3s';l:$200;p:$200;crc:$a1cb71c5),
        (n:'hm1-3.4v';l:$800;p:$400;crc:$e362d613),(n:'hm1-4.5v';l:$800;p:$c00;crc:$678252b4),
        (n:'hm1-5.6u';l:$20;p:$1400;crc:$475bf500),());
        //Sky Kid Deluxe
        skykiddx_rom:array[0..2] of tipo_roms=(
        (n:'sk3_1b.9c';l:$8000;p:$0;crc:$767b3514),(n:'sk3_2.9d';l:$8000;p:$8000;crc:$74b8f8e2),());
        skykiddx_sub_rom:tipo_roms=(n:'sk3_3.12c';l:$8000;p:$8000;crc:$6d1084c4);
        skykiddx_chars:array[0..2] of tipo_roms=(
        (n:'sk3_9.7r';l:$8000;p:$0;crc:$48675b17),(n:'sk3_10.7s';l:$4000;p:$8000;crc:$7418465a),());
        skykiddx_tiles:array[0..2] of tipo_roms=(
        (n:'sk3_7.4r';l:$8000;p:$0;crc:$4036b735),(n:'sk3_8.4s';l:$4000;p:$8000;crc:$044bfd21),());
        skykiddx_sprites:array[0..2] of tipo_roms=(
        (n:'sk3_5.12h';l:$8000;p:$0;crc:$5c7d4399),(n:'sk3_6.12k';l:$8000;p:$8000;crc:$c908a3b2),());
        skykiddx_mcu:array[0..2] of tipo_roms=(
        (n:'sk3_4.6b';l:$4000;p:$8000;crc:$e6cae2d6),(n:'cus60-60a1.mcu';l:$1000;p:$f000;crc:$076ea82a),());
        skykiddx_prom:array[0..5] of tipo_roms=(
        (n:'sk3-1.3r';l:$200;p:$0;crc:$9e81dedd),(n:'sk3-2.3s';l:$200;p:$200;crc:$cbfec4dd),
        (n:'sk3-3.4v';l:$800;p:$400;crc:$81714109),(n:'sk3-4.5v';l:$800;p:$c00;crc:$1bf25acc),
        (n:'sk3-5.6u';l:$20;p:$1400;crc:$e4130804),());

var
 rom_bank:array[0..$1f,0..$1fff] of byte;
 rom_sub_bank:array[0..$3,0..$1fff] of byte;
 nchar_prom:array[0..$1f] of byte;
 rom_nbank,rom_sub_nbank,tile_bank,back_color,bank_sprites:byte;
 scroll_y,prior:array[0..3] of byte;
 scroll_x:array[0..3] of parejas;
 copy_sprites,irq_enable,irq_sub_enable:boolean;
 mask_chars,mask_tiles:word;
 dip_2:byte;
 update_video_system86:tipo_update_video_system86;

implementation

procedure Cargar_system86;
begin
llamadas_maquina.iniciar:=iniciar_system86;
llamadas_maquina.bucle_general:=system86_principal;
llamadas_maquina.cerrar:=cerrar_system86;
llamadas_maquina.reset:=reset_system86;
llamadas_maquina.fps_max:=60.606060;
end;

function iniciar_system86:boolean; 
var
  colores:tpaleta;
  f:word;
  memoria_temp:array[0..$7ffff] of byte;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..31] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4,
 			8*4, 9*4, 10*4, 11*4, 12*4, 13*4, 14*4, 15*4,
			16*64+0*4, 16*64+1*4, 16*64+2*4, 16*64+3*4, 16*64+4*4, 16*64+5*4, 16*64+6*4, 16*64+7*4,
			16*64+8*4, 16*64+9*4, 16*64+10*4, 16*64+11*4, 16*64+12*4, 16*64+13*4, 16*64+14*4, 16*64+15*4);
    ps_y:array[0..31] of dword=(0*64, 1*64, 2*64, 3*64, 4*64, 5*64, 6*64, 7*64,
			8*64, 9*64, 10*64, 11*64, 12*64, 13*64, 14*64, 15*64,
			32*64, 33*64, 34*64, 35*64, 36*64, 37*64, 38*64, 39*64,
			40*64, 41*64, 42*64, 43*64, 44*64, 45*64, 46*64, 47*64);
procedure convert_data(long:dword);
var
  size,i:dword;
  dest1,dest2,mono:dword;
  buffer:array[0..$1ffff] of byte;
  data1,data2:byte;
begin
  size:=(long*2) div 3;
	dest1:=0;
	dest2:=0+(size div 2);
  mono:=0+size;
  copymemory(@buffer[0],@memoria_temp[0],size);
  for i:=0 to ((size div 2)-1) do begin
			data1:=buffer[i*2];
			data2:=buffer[(i*2)+1];
			memoria_temp[dest1]:=(data1 shl 4) or (data2 and $f);
      dest1:=dest1+1;
			memoria_temp[dest2]:=(data1 and $f0) or (data2 shr 4);
      dest2:=dest2+1;
      memoria_temp[mono]:=memoria_temp[mono] xor $ff;
      mono:=mono+1;
  end;
end;
begin
iniciar_system86:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=288;
p_final[0].y:=224;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[1].scroll.long_x:=512;
p_final[1].scroll.long_y:=256;
p_final[1].scroll.max_x:=512;
p_final[1].scroll.max_y:=256;
p_final[1].scroll.mask_x:=511;
p_final[1].scroll.mask_y:=255;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].trans:=true;
p_final[2].scroll:=p_final[1].scroll;
p_final[3].x:=512;
p_final[3].y:=256;
p_final[3].trans:=true;
p_final[3].scroll:=p_final[1].scroll;
p_final[4].x:=512;
p_final[4].y:=256;
p_final[4].trans:=true;
p_final[4].scroll:=p_final[1].scroll;
p_final[5].x:=512;
p_final[5].y:=256;
p_final[5].final_mix:=true;
iniciar_video;
//Main CPU
main_m6809:=cpu_m6809.Create(1536000,256);
//Sub CPU
snd_m6809:=cpu_m6809.Create(1536000,256);
//MCU CPU
main_m6800:=cpu_m6800.create(6144000,$100,cpu_hd63701);
main_m6800.change_ram_calls(rthunder_mcu_getbyte,rthunder_mcu_putbyte);
main_m6800.change_io_calls(in_port1,in_port2,nil,nil,nil,nil,nil,nil);
main_m6800.init_sound(sound_instruccion);
//Sound
namco_sound_init(8,true);
YM2151_Init(0,main_m6800.numero_cpu,3579580,main_m6800.clock,nil,nil);
case main_vars.tipo_maquina of
    124:begin
            //cargar roms main CPU
            if not(cargar_roms(@memoria[$0],@rthunder_rom,'rthunder.zip',1)) then exit;
            main_m6809.change_ram_calls(system86_getbyte,system86_putbyte_ext);
            //Pongo las ROMs en su banco
            if not(cargar_roms(@memoria_temp[0],@rthunder_rom_bank[0],'rthunder.zip',0)) then exit;
            for f:=0 to $1f do copymemory(@rom_bank[f,0],@memoria_temp[f*$2000],$2000);
            //cargar roms sub CPU
            if not(cargar_roms(@memoria_temp[0],@rthunder_sub_rom[0],'rthunder.zip',0)) then exit;
            snd_m6809.change_ram_calls(rthunder_sub_getbyte,rthunder_sub_putbyte);
            //Pongo las ROMs en su banco
            copymemory(@mem_misc[$8000],@memoria_temp[$0],$8000);
            for f:=0 to $3 do copymemory(@rom_sub_bank[f,0],@memoria_temp[(f*$2000)+$8000],$2000);
            //Cargar MCU
            if not(cargar_roms(@mem_snd[0],@rthunder_mcu[0],'rthunder.zip',0)) then exit;
            //convertir chars
            if not(cargar_roms(@memoria_temp[0],@rthunder_chars[0],'rthunder.zip',0)) then exit;
            convert_data($18000);
            mask_chars:=$fff;
            init_gfx(0,8,8,$1000);
            gfx[0].trans[7]:=true;
            des_gfx.pos_planos[0]:=$2000*8*8;
            des_gfx.pos_planos[1]:=$1000*8*8;
            des_gfx.pos_planos[2]:=0;
            des_gfx.bit_pixel:=3;
            des_gfx.banks:=0;
            des_gfx.long_sprites:=8*8;
            convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
            //tiles
            if not(cargar_roms(@memoria_temp[0],@rthunder_tiles[0],'rthunder.zip',0)) then exit;
            convert_data($c000);
            mask_tiles:=$7ff;
            init_gfx(1,8,8,$800);
            gfx[1].trans[7]:=true;
            des_gfx.pos_planos[0]:=$1000*8*8;
            des_gfx.pos_planos[1]:=$800*8*8;
            des_gfx.pos_planos[2]:=0;
            des_gfx.bit_pixel:=3;
            des_gfx.banks:=0;
            des_gfx.long_sprites:=8*8;
            convert_gfx(@gfx[1],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
            //sprites
            if not(cargar_roms(@memoria_temp[0],@rthunder_sprites[0],'rthunder.zip',0)) then exit;
            init_gfx(2,32,32,$400);
            gfx[2].trans[15]:=true;
            des_gfx.pos_planos[0]:=0;
            des_gfx.pos_planos[1]:=1;
            des_gfx.pos_planos[2]:=2;
            des_gfx.pos_planos[3]:=3;
            des_gfx.bit_pixel:=4;
            des_gfx.long_sprites:=64*64;
            convert_gfx(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
            bank_sprites:=$400 div 8;
            //Paleta
            if not(cargar_roms(@memoria_temp[0],@rthunder_prom[0],'rthunder.zip',0)) then exit;
            dip_2:=$f9;
            update_video_system86:=rthunder_video;
    end;
    125:begin
            //cargar roms main CPU
            if not(cargar_roms(@memoria[$0],@hopmappy_rom,'hopmappy.zip',1)) then exit;
            main_m6809.change_ram_calls(system86_getbyte,system86_putbyte);
            //cargar roms sub CPU
            if not(cargar_roms(@mem_misc[0],@hopmappy_sub_rom,'hopmappy.zip',1)) then exit;
            snd_m6809.change_ram_calls(hopmappy_sub_getbyte,hopmappy_sub_putbyte);
            //Cargar MCU
            if not(cargar_roms(@mem_snd[0],@hopmappy_mcu[0],'hopmappy.zip',0)) then exit;
            //convertir chars
            fillchar(memoria_temp[0],$6000,0);
            if not(cargar_roms(@memoria_temp[0],@hopmappy_chars,'hopmappy.zip',1)) then exit;
            convert_data($6000);
            init_gfx(0,8,8,$400);
            mask_chars:=$3ff;
            mask_tiles:=$3ff;
            gfx[0].trans[7]:=true;
            des_gfx.pos_planos[0]:=$800*8*8;
            des_gfx.pos_planos[1]:=$400*8*8;
            des_gfx.pos_planos[2]:=0;
            des_gfx.bit_pixel:=3;
            des_gfx.banks:=0;
            des_gfx.long_sprites:=8*8;
            convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
            //tiles
            fillchar(memoria_temp[0],$6000,0);
            if not(cargar_roms(@memoria_temp[0],@hopmappy_tiles,'hopmappy.zip',1)) then exit;
            convert_data($6000);
            init_gfx(1,8,8,$400);
            gfx[1].trans[7]:=true;
            des_gfx.pos_planos[0]:=$800*8*8;
            des_gfx.pos_planos[1]:=$400*8*8;
            des_gfx.pos_planos[2]:=0;
            des_gfx.bit_pixel:=3;
            des_gfx.banks:=0;
            des_gfx.long_sprites:=8*8;
            convert_gfx(@gfx[1],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
            //sprites
            if not(cargar_roms(@memoria_temp[0],@hopmappy_sprites,'hopmappy.zip',1)) then exit;
            init_gfx(2,32,32,$200);
            gfx[2].trans[15]:=true;
            des_gfx.pos_planos[0]:=0;
            des_gfx.pos_planos[1]:=1;
            des_gfx.pos_planos[2]:=2;
            des_gfx.pos_planos[3]:=3;
            des_gfx.bit_pixel:=4;
            des_gfx.long_sprites:=64*64;
            convert_gfx(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
            bank_sprites:=$200 div 8;
            //Paleta
            if not(cargar_roms(@memoria_temp[0],@hopmappy_prom[0],'hopmappy.zip',0)) then exit;
            dip_2:=$ff;
            update_video_system86:=rthunder_video;
    end;
    126:begin
            //cargar roms main CPU
            if not(cargar_roms(@memoria_temp[$0],@skykiddx_rom[0],'skykiddx.zip',0)) then exit;
            copymemory(@memoria[$8000],@memoria_temp[0],$8000);
            for f:=0 to 3 do copymemory(@rom_bank[f,0],@memoria_temp[$8000+(f*$2000)],$2000);
            main_m6809.change_ram_calls(system86_getbyte,system86_putbyte);
            //cargar roms sub CPU
            if not(cargar_roms(@mem_misc[0],@skykiddx_sub_rom,'skykiddx.zip',1)) then exit;
            snd_m6809.change_ram_calls(hopmappy_sub_getbyte,hopmappy_sub_putbyte);
            //Cargar MCU
            if not(cargar_roms(@mem_snd[0],@skykiddx_mcu[0],'skykiddx.zip',0)) then exit;
            //convertir chars
            if not(cargar_roms(@memoria_temp[0],@skykiddx_chars[0],'skykiddx.zip',0)) then exit;
            convert_data($c000);
            init_gfx(0,8,8,$800);
            mask_chars:=$7ff;
            mask_tiles:=$7ff;
            gfx[0].trans[7]:=true;
            des_gfx.pos_planos[0]:=$1000*8*8;
            des_gfx.pos_planos[1]:=$800*8*8;
            des_gfx.pos_planos[2]:=0;
            des_gfx.bit_pixel:=3;
            des_gfx.banks:=0;
            des_gfx.long_sprites:=8*8;
            convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
            //tiles
            if not(cargar_roms(@memoria_temp[0],@skykiddx_tiles[0],'skykiddx.zip',0)) then exit;
            convert_data($c000);
            init_gfx(1,8,8,$800);
            gfx[1].trans[7]:=true;
            des_gfx.pos_planos[0]:=$1000*8*8;
            des_gfx.pos_planos[1]:=$800*8*8;
            des_gfx.pos_planos[2]:=0;
            des_gfx.bit_pixel:=3;
            des_gfx.banks:=0;
            des_gfx.long_sprites:=8*8;
            convert_gfx(@gfx[1],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
            //sprites
            if not(cargar_roms(@memoria_temp[0],@skykiddx_sprites[0],'skykiddx.zip',0)) then exit;
            init_gfx(2,32,32,$200);
            gfx[2].trans[15]:=true;
            des_gfx.pos_planos[0]:=0;
            des_gfx.pos_planos[1]:=1;
            des_gfx.pos_planos[2]:=2;
            des_gfx.pos_planos[3]:=3;
            des_gfx.bit_pixel:=4;
            des_gfx.long_sprites:=64*64;
            convert_gfx(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
            bank_sprites:=$200 div 8;
            //Paleta
            if not(cargar_roms(@memoria_temp[0],@skykiddx_prom[0],'skykiddx.zip',0)) then exit;
            dip_2:=$ff;
            update_video_system86:=skykiddx_video;
    end;
end;
for f:=0 to $1ff do begin
  colores[f].r:=((memoria_temp[f] shr 0) and $01)*$0e+((memoria_temp[f] shr 1) and $01)*$1f+((memoria_temp[f] shr 2) and $01)*$43+((memoria_temp[f] shr 3) and $01)*$8f;
  colores[f].g:=((memoria_temp[f] shr 4) and $01)*$0e+((memoria_temp[f] shr 5) and $01)*$1f+((memoria_temp[f] shr 6) and $01)*$43+((memoria_temp[f] shr 7) and $01)*$8f;
  colores[f].b:=((memoria_temp[f+$200] shr 0) and $01)*$0e+((memoria_temp[f+$200] shr 1) and $01)*$1f+((memoria_temp[f+$200] shr 2) and $01)*$43+((memoria_temp[f+$200] shr 3) and $01)*$8f;
end;
set_pal(colores,$200);
// tiles/sprites color table
for f:=$0 to $7ff do begin
  gfx[0].colores[f]:=memoria_temp[$400+f];
  gfx[1].colores[f]:=memoria_temp[$400+f];
  gfx[2].colores[f]:=memoria_temp[$400+$800+f];
end;
//color prom used at run time
copymemory(@nchar_prom[0],@memoria_temp[$1400],$20);
//final
reset_system86;
iniciar_system86:=true;
end;

procedure cerrar_system86;
begin
main_m6809.Free;
snd_m6809.free;
main_m6800.Free;
YM2151_Close(0);
close_audio;
close_video;
end;

procedure reset_system86;
var
  f:byte;
begin
 main_m6809.reset;
 snd_m6809.reset;
 main_m6800.reset;
 namco_sound_reset;
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 rom_nbank:=0;
 rom_sub_nbank:=0;
 for f:=0 to 3 do scroll_y[f]:=0;
 for f:=0 to 3 do scroll_x[0].w:=0;
 for f:=0 to 3 do prior[f]:=0;
 tile_bank:=0;
 copy_sprites:=false;
 irq_enable:=true;
 irq_sub_enable:=true;
end;

procedure draw_sprites(prior:byte;despx,despy:word);inline;
var
  source,finish:word;
  sprite_xoffs,color,nchar:word;
  sprite_yoffs,attr1,attr2:byte;
  priority,sizex,sizey:byte;
  flipx,flipy:boolean;
  tx,ty,x,y:word;
const
  sprite_size:array[0..3] of byte=(16,8,32,4);
begin
	source:=$6000-$20;	// the last is NOT a sprite */
	finish:=$5800;
	sprite_xoffs:=memoria[$5800+$07f5]+((memoria[$5800+$07f4] and $1) shl 8);
	sprite_yoffs:=memoria[$5800+$07f7];
	while (source>=finish) do begin
    priority:=(memoria[finish+14] and $e0) shr 5;
    if priority<>prior then begin
      finish:=finish+$10;
      continue;
    end;
		attr1:=memoria[finish+10];
		attr2:=memoria[finish+14];
		color:=memoria[finish+12];
		flipx:=(attr1 and $20)<>0;
		flipy:=(attr2 and $01)<>0;
		sizex:=sprite_size[(attr1 and $c0) shr 6];
		sizey:=sprite_size[(attr2 and $06) shr 1];
		tx:=attr1 and $18;
		ty:=attr2 and $18;
    if flipx then tx:=(tx-sizex) and $1f;
    if flipy then ty:=(ty-sizey) and $1f;
		x:=(memoria[finish+13]+((color and $01) shl 8))+sprite_xoffs-despx;
		y:=(256-(memoria[finish+15])-sizey)-((sprite_yoffs-despy)+1);
		nchar:=memoria[finish+11] and (bank_sprites-1);
		nchar:=nchar+((attr1 and $7)*bank_sprites);
		color:=(color and $fe) shl 3;
    put_gfx_sprite(nchar,color,flipx,flipy,2);
    actualiza_gfx_sprite_size_pos(x-70,y+8,5,sizex,sizey,tx,ty);
		finish:=finish+$10;
	end;
end;

procedure update_video_screen;
var
        f,color,nchar,offs:word;
        x,y:byte;
begin
fill_full_screen(5,gfx[0].colores[8*back_color+7]);
for f:=0 to $7ff do begin
    x:=f mod 64;
    y:=f div 64;
    //Screen 0
    if gfx[0].buffer[f] then begin
      color:=memoria[$1+(f*2)];
      offs:=((nchar_prom[((0 and 1) shl 4)+((color and $03) shl 2)] and $0e) shr 1)*$100+tile_bank*$800;
      nchar:=memoria[$0+(f*2)]+offs;
      put_gfx_trans(x*8,y*8,(nchar and mask_chars),color shl 3,1,0);
      gfx[0].buffer[f]:=false;
    end;
    //Screen 1
    if gfx[0].buffer[$800+f] then begin
      color:=memoria[$1001+(f*2)];
      offs:=((nchar_prom[((1 and 1) shl 4)+((color and $03) shl 2)] and $0e) shr 1)*$100+tile_bank*$800;
      nchar:=memoria[$1000+(f*2)]+offs;
      put_gfx_trans(x*8,y*8,(nchar and mask_chars),color shl 3,2,0);
      gfx[0].buffer[$800+f]:=false;
    end;
    //Screen 2
    if gfx[1].buffer[f] then begin
      color:=memoria[$2001+(f*2)];
      offs:=((nchar_prom[((2 and 1) shl 4)+(color and $03)] and $e0) shr 5)*$100;
      nchar:=memoria[$2000+(f*2)]+offs;
      put_gfx_trans(x*8,y*8,(nchar and mask_tiles),color shl 3,3,1);
      gfx[1].buffer[f]:=false;
    end;
    //Screen 3
    if gfx[1].buffer[$800+f] then begin
      color:=memoria[$3001+(f*2)];
      offs:=((nchar_prom[((3 and 1) shl 4)+(color and $03)] and $e0) shr 5)*$100;
      nchar:=memoria[$3000+(f*2)]+offs;
      put_gfx_trans(x*8,y*8,(nchar and mask_tiles),color shl 3,4,1);
      gfx[1].buffer[$800+f]:=false;
    end;
end;
end;

procedure skykiddx_video;
const
  diff_x2:array[0..3] of byte=(19,18,21,20);
  diff_y2:array[0..3] of byte=(1,16,0,0);
var
  layer,f:byte;
begin
update_video_screen;
for layer:=0 to 7 do begin
  for f:=3 downto 0 do begin
    if (prior[f]=layer) then begin
      scroll_x_y(f+1,5,224-(scroll_x[f].w+diff_x2[f]),scroll_y[f]-diff_y2[f]);
    end;
  end;
  draw_sprites(layer,88,2);
end;
actualiza_trozo_final(0,25,288,224,5);
end;

procedure rthunder_video;
var
  layer,f:byte;
const
  diff_x:array[0..3] of byte=(20,18,21,19);
begin
update_video_screen;
for layer:=0 to 7 do begin
  for f:=3 downto 0 do begin
    if (prior[f]=layer) then begin
      scroll_x_y(f+1,5,scroll_x[f].w+diff_x[f],scroll_y[f]);
    end;
  end;
  draw_sprites(layer,0,3);
end;
actualiza_trozo_final(0,25,288,224,5);
end;


procedure eventos_system86;
begin
if event.arcade then begin
  //IN0
  if arcade_input.but1[0] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.down[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.down[1] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.right[1] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.coin[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.start[0] then in0:=(in0 and $bf) else in0:=(in0 or $40);
  //IN1
  if arcade_input.but1[1] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.up[0] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.up[1] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.coin[1] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.start[1] then in1:=(in1 and $bf) else in1:=(in1 or $40);
  //IN2
  if arcade_input.but0[0] then in2:=(in2 and $f7) else in2:=(in2 or $8);
  if arcade_input.left[0] then in2:=(in2 and $ef) else in2:=(in2 or $10);
  if arcade_input.right[0] then in2:=(in2 and $df) else in2:=(in2 or $20);
  if arcade_input.but0[1] then in2:=(in2 and $bf) else in2:=(in2 or $40);
  if arcade_input.left[1] then in2:=(in2 and $7f) else in2:=(in2 or $80);
end;
end;

procedure copy_sprites_hw;inline;
var
  i,j:byte;
begin
for i:=0 to $7f do begin
  for j:=10 to 15 do memoria[$5800+(i*$10)+j]:=memoria[$5800+(i*$10)+j-6];
end;
copy_sprites:=false;
end;

procedure system86_principal;
var
  f:word;
  frame_m,frame_s,frame_mcu:single;
begin
init_controls(false,false,false,true);
frame_m:=main_m6809.tframes;
frame_s:=snd_m6809.tframes;
frame_mcu:=main_m6800.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to $ff do begin
    //Main CPU
    main_m6809.run(trunc(frame_m));
    frame_m:=frame_m+main_m6809.tframes-main_m6809.contador;
    //Sub CPU
    snd_m6809.run(trunc(frame_s));
    frame_s:=frame_s+snd_m6809.tframes-snd_m6809.contador;
    //Sound CPU
    main_m6800.run(trunc(frame_mcu));
    frame_mcu:=frame_mcu+main_m6800.tframes-main_m6800.contador;
  end;
  if irq_enable then main_m6809.pedir_irq:=ASSERT_LINE;
  if irq_sub_enable then snd_m6809.pedir_irq:=ASSERT_LINE;
  main_m6800.pedir_irq:=HOLD_LINE;
  if sound_status.hay_sonido then namco_playsound;
  update_video_system86;
  if copy_sprites then copy_sprites_hw;
  eventos_system86;
  video_sync;
end;
end;

function system86_getbyte(direccion:word):byte;
begin
case direccion of
  $4000..$43ff:system86_getbyte:=namcos1_cus30_r(direccion and $3ff);
  $6000..$7fff:system86_getbyte:=rom_bank[rom_nbank,direccion and $1fff];
  else system86_getbyte:=memoria[direccion];
end;
end;

procedure system86_putbyte(direccion:word;valor:byte);
begin
case direccion of
  0..$1fff:if memoria[direccion]<>valor then gfx[0].buffer[direccion shr 1]:=true;
  $2000..$3fff:if memoria[direccion]<>valor then gfx[1].buffer[(direccion and $1fff) shr 1]:=true;
  $4000..$43ff:namcos1_cus30_w(direccion and $3ff,valor);
  $5ff2:copy_sprites:=true;
  $8400:main_m6809.pedir_irq:=CLEAR_LINE;
  $8800..$8fff:tile_bank:=bit_n(direccion,10);
  $9000:begin
          prior[0]:=(valor and $e) shr 1;
          scroll_x[0].h:=valor and 1;
        end;
  $9001:scroll_x[0].l:=valor;
  $9002:scroll_y[0]:=valor;
  $9003:rom_nbank:=valor and $3;
  $9004:begin
          prior[1]:=(valor and $e) shr 1;
          scroll_x[1].h:=valor and 1;
        end;
  $9005:scroll_x[1].l:=valor;
  $9006:scroll_y[1]:=valor;
  $9400:begin
          prior[2]:=(valor and $e) shr 1;
          scroll_x[2].h:=valor and 1;
        end;
  $9401:scroll_x[2].l:=valor;
  $9402:scroll_y[2]:=valor;
  $9404:begin
          prior[3]:=(valor and $e) shr 1;
          scroll_x[3].h:=valor and 1;
        end;
  $9405:scroll_x[3].l:=valor;
  $9406:scroll_y[3]:=valor;
  $a000:back_color:=valor;
end;
if direccion<$6000 then memoria[direccion]:=valor;
end;

procedure system86_putbyte_ext(direccion:word;valor:byte);
begin
case direccion of
  0..$1fff:if memoria[direccion]<>valor then gfx[0].buffer[direccion shr 1]:=true;
  $2000..$3fff:if memoria[direccion]<>valor then gfx[1].buffer[(direccion and $1fff) shr 1]:=true;
  $4000..$43ff:namcos1_cus30_w(direccion and $3ff,valor);
  $5ff2:copy_sprites:=true;
  $6000..$7fff:begin
                 case ((direccion and $1e00) shr 9) of
    		            0,1,2,3:;//namco_63701x_w(space->machine->device("namco2"), (offset & 0x1e00) >> 9,data);
		                4:rom_nbank:=valor and $1f;
                 end;
                 exit;
               end;
  $8400:main_m6809.pedir_irq:=CLEAR_LINE;
  $8800..$8fff:tile_bank:=bit_n(direccion,10);
  $9000:begin
          prior[0]:=(valor and $e) shr 1;
          scroll_x[0].h:=valor and 1;
        end;
  $9001:scroll_x[0].l:=valor;
  $9002:scroll_y[0]:=valor;
  $9004:begin
          prior[1]:=(valor and $e) shr 1;
          scroll_x[1].h:=valor and 1;
        end;
  $9005:scroll_x[1].l:=valor;
  $9006:scroll_y[1]:=valor;
  $9400:begin
          prior[2]:=(valor and $e) shr 1;
          scroll_x[2].h:=valor and 1;
        end;
  $9401:scroll_x[2].l:=valor;
  $9402:scroll_y[2]:=valor;
  $9404:begin
          prior[3]:=(valor and $e) shr 1;
          scroll_x[3].h:=valor and 1;
        end;
  $9405:scroll_x[3].l:=valor;
  $9406:scroll_y[3]:=valor;
  $a000:back_color:=valor;
end;
if direccion<$6000 then memoria[direccion]:=valor;
end;

//Rolling Thunder
function rthunder_sub_getbyte(direccion:word):byte;
begin
case direccion of
  0..$1fff:rthunder_sub_getbyte:=memoria[$4000+direccion]; //sprite ram
  $2000..$3fff:rthunder_sub_getbyte:=memoria[$0+(direccion and $1fff)];  //video 1 ram
  $4000..$5fff:rthunder_sub_getbyte:=memoria[$2000+(direccion and $1fff)]; //video 2 ram
  $6000..$7fff:rthunder_sub_getbyte:=rom_sub_bank[rom_sub_nbank,direccion and $1fff];
  $8000..$ffff:rthunder_sub_getbyte:=mem_misc[direccion];
end;
end;

procedure rthunder_sub_putbyte(direccion:word;valor:byte);
begin
case direccion of
  0..$1fff:begin  //sprite ram
              memoria[$4000+direccion]:=valor;
              if direccion=$1ff2 then copy_sprites:=true;
           end;
  $2000..$3fff:if memoria[$0+(direccion and $1fff)]<>valor then begin  //video 1 ram
                  memoria[$0+(direccion and $1fff)]:=valor;
                  gfx[0].buffer[(direccion and $1fff) shr 1]:=true;
               end;
  $4000..$5fff:if memoria[$2000+(direccion and $1fff)]<>valor then begin //video 2 ram
                  memoria[$2000+(direccion and $1fff)]:=valor;
                  gfx[1].buffer[(direccion and $1fff) shr 1]:=true;
               end;
  $8800:snd_m6809.pedir_irq:=CLEAR_LINE;
  $d803:rom_sub_nbank:=valor and $3;
end;
end;

function rthunder_mcu_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$1f:rthunder_mcu_getbyte:=main_m6800.m6803_internal_reg_r(direccion);
  $1000..$13ff:rthunder_mcu_getbyte:=namcos1_cus30_r(direccion and $3ff);
  $2001:rthunder_mcu_getbyte:=YM2151_status_port_read(0);
  $2020:rthunder_mcu_getbyte:=in0;
  $2021:rthunder_mcu_getbyte:=in1;
  $2030:rthunder_mcu_getbyte:=$ff;
  $2031:rthunder_mcu_getbyte:=dip_2;
    else rthunder_mcu_getbyte:=mem_snd[direccion];
end;
end;

procedure rthunder_mcu_putbyte(direccion:word;valor:byte);
begin
case direccion of
  $0..$1f:main_m6800.m6803_internal_reg_w(direccion,valor);
  $1000..$13ff:namcos1_cus30_w(direccion and $3ff,valor);
  $2000:YM2151_register_port_write(0,valor);
  $2001:YM2151_data_port_write(0,valor);
  $4000..$bfff,$f000..$ffff:exit;
end;
mem_snd[direccion]:=valor;
end;

//Hopping Mappy
function hopmappy_sub_getbyte(direccion:word):byte;
begin
case direccion of
  $4000..$5fff:hopmappy_sub_getbyte:=memoria[direccion];
    else hopmappy_sub_getbyte:=mem_misc[direccion];
end;
end;

procedure hopmappy_sub_putbyte(direccion:word;valor:byte);
begin
case direccion of
  0..$3fff:mem_misc[direccion]:=valor;
  $4000..$5fff:begin
                  memoria[direccion]:=valor;
                  if direccion=$5ff2 then copy_sprites:=true;
               end;
  $9400:snd_m6809.pedir_irq:=CLEAR_LINE;
end;
end;

//Misc Funcitions
function in_port1:byte;
begin
  in_port1:=in2;
end;

function in_port2:byte;
begin
  in_port2:=$ff;
end;

procedure sound_instruccion;
begin
  ym2151_Update(0);
end;

end.
