unit tecmo_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     nz80,main_engine,controls_engine,gfx_engine,msm5205,ym_3812,
     rom_engine,pal_engine,sound_engine;

procedure Cargar_tecmo;
procedure tecmo_principal;
function iniciar_tecmo:boolean;
procedure reset_tecmo;
procedure cerrar_tecmo;
//Sound
procedure snd_despues_instruccion;
procedure snd_adpcm;
procedure snd_irq(irqstate:integer);
//Rygar
function rygar_getbyte(direccion:word):byte;
procedure rygar_putbyte(direccion:word;valor:byte);
procedure rygar_snd_putbyte(direccion:word;valor:byte);
function rygar_snd_getbyte(direccion:word):byte;
//Silk Worm
function sw_getbyte(direccion:word):byte;
procedure sw_putbyte(direccion:word;valor:byte);
procedure sw_snd_putbyte(direccion:word;valor:byte);
function sw_snd_getbyte(direccion:word):byte;

const
        //Rygar
        rygar_rom:array[0..3] of tipo_roms=(
        (n:'5.5p';l:$8000;p:0;crc:$062cd55d),(n:'cpu_5m.bin';l:$4000;p:$8000;crc:$7ac5191b),
        (n:'cpu_5j.bin';l:$8000;p:$10000;crc:$ed76d606),());
        rygar_char:tipo_roms=(n:'cpu_8k.bin';l:$8000;p:0;crc:$4d482fb6);
        rygar_tiles1:array[0..4] of tipo_roms=(
        (n:'vid_6p.bin';l:$8000;p:0;crc:$9eae5f8e),(n:'vid_6o.bin';l:$8000;p:$8000;crc:$5a10a396),
        (n:'vid_6n.bin';l:$8000;p:$10000;crc:$7b12cf3f),(n:'vid_6l.bin';l:$8000;p:$18000;crc:$3cea7eaa),());
        rygar_tiles2:array[0..4] of tipo_roms=(
        (n:'vid_6f.bin';l:$8000;p:0;crc:$9840edd8),(n:'vid_6e.bin';l:$8000;p:$8000;crc:$ff65e074),
        (n:'vid_6c.bin';l:$8000;p:$10000;crc:$89868c85),(n:'vid_6b.bin';l:$8000;p:$18000;crc:$35389a7b),());
        rygar_adpcm:tipo_roms=(n:'cpu_1f.bin';l:$4000;p:0;crc:$3cc98c5a);
        rygar_sound:tipo_roms=(n:'cpu_4h.bin';l:$2000;p:0;crc:$e4a2fa87);
        rygar_sprites:array[0..4] of tipo_roms=(
        (n:'vid_6k.bin';l:$8000;p:0;crc:$aba6db9e),(n:'vid_6j.bin';l:$8000;p:$8000;crc:$ae1f2ed6),
        (n:'vid_6h.bin';l:$8000;p:$10000;crc:$46d9e7df),(n:'vid_6g.bin';l:$8000;p:$18000;crc:$45839c9a),());
        //Silkworm
        sw_rom:array[0..2] of tipo_roms=(
        (n:'silkworm.4';l:$10000;p:0;crc:$a5277cce),(n:'silkworm.5';l:$10000;p:$10000;crc:$a6c7bb51),());
        sw_char:tipo_roms=(n:'silkworm.2';l:$8000;p:0;crc:$e80a1cd9);
        sw_tiles1:array[0..4] of tipo_roms=(
        (n:'silkworm.10';l:$10000;p:0;crc:$8c7138bb),(n:'silkworm.11';l:$10000;p:$10000;crc:$6c03c476),
        (n:'silkworm.12';l:$10000;p:$20000;crc:$bb0f568f),(n:'silkworm.13';l:$10000;p:$30000;crc:$773ad0a4),());
        sw_tiles2:array[0..4] of tipo_roms=(
        (n:'silkworm.14';l:$10000;p:0;crc:$409df64b),(n:'silkworm.15';l:$10000;p:$10000;crc:$6e4052c9),
        (n:'silkworm.16';l:$10000;p:$20000;crc:$9292ed63),(n:'silkworm.17';l:$10000;p:$30000;crc:$3fa4563d),());
        sw_adpcm:tipo_roms=(n:'silkworm.1';l:$8000;p:0;crc:$5b553644);
        sw_sound:tipo_roms=(n:'silkworm.3';l:$8000;p:0;crc:$b589f587);
        sw_sprites:array[0..4] of tipo_roms=(
        (n:'silkworm.6';l:$10000;p:0;crc:$1138d159),(n:'silkworm.7';l:$10000;p:$10000;crc:$d96214f7),
        (n:'silkworm.8';l:$10000;p:$20000;crc:$0494b38e),(n:'silkworm.9';l:$10000;p:$30000;crc:$8ce3cdf5),());

var
 mem_adpcm:array[0..$7fff] of byte;
 bank_rom:array[0..$1f,0..$7ff] of byte;
 adpcm_end,adpcm_pos:word;
 adpcm_data:integer;
 nbank_rom:byte;
 scroll_x1,scroll_x2:parejas;
 scroll_y1,scroll_y2:byte;
 soundlatch,tipo_video:byte;
 bg_ram,fg_ram:array[0..$3ff] of byte;
 txt_ram:array[0..$7ff] of byte;

implementation

procedure Cargar_tecmo;
begin
llamadas_maquina.iniciar:=iniciar_tecmo;
llamadas_maquina.bucle_general:=tecmo_principal;
llamadas_maquina.cerrar:=cerrar_tecmo;
llamadas_maquina.reset:=reset_tecmo;
end;

function iniciar_tecmo:boolean;
const
  ps_x:array[0..15] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4,
			32*8+0*4, 32*8+1*4, 32*8+2*4, 32*8+3*4, 32*8+4*4, 32*8+5*4, 32*8+6*4, 32*8+7*4);
  ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
			16*32, 17*32, 18*32, 19*32, 20*32, 21*32, 22*32, 23*32);
  pc_x:array[0..7] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4);
  pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
var
  memoria_temp:array[0..$3ffff] of byte;
  f:byte;

procedure char_convert(num:word);
begin
  init_gfx(0,8,8,num);
  gfx[0].trans[0]:=true;
  des_gfx.pos_planos[0]:=0;
  des_gfx.pos_planos[1]:=1;
  des_gfx.pos_planos[2]:=2;
  des_gfx.pos_planos[3]:=3;
  des_gfx.bit_pixel:=4;
  des_gfx.banks:=0;
  des_gfx.long_sprites:=32*8;
  convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
end;

procedure sprite_convert(num:word);
begin
  init_gfx(2,8,8,num);
  gfx[2].trans[0]:=true;
  des_gfx.pos_planos[0]:=0;
  des_gfx.pos_planos[1]:=1;
  des_gfx.pos_planos[2]:=2;
  des_gfx.pos_planos[3]:=3;
  des_gfx.bit_pixel:=4;
  des_gfx.banks:=0;
  des_gfx.long_sprites:=32*8;
  convert_gfx(@gfx[2],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
end;

procedure tile_convert(pos:word);
begin
  gfx[1].trans[0]:=true;
  des_gfx.pos_planos[0]:=0;
  des_gfx.pos_planos[1]:=1;
  des_gfx.pos_planos[2]:=2;
  des_gfx.pos_planos[3]:=3;
  des_gfx.bit_pixel:=4;
  des_gfx.long_sprites:=128*8;
  des_gfx.banks:=2;
  convert_gfx(@gfx[1],pos*16*16,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
end;

begin
iniciar_tecmo:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[1].final_mix:=true;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].trans:=true;
p_final[2].scroll.long_x:=512;
p_final[2].scroll.long_y:=256;
p_final[2].scroll.max_x:=256+48;
p_final[2].scroll.max_y:=256;
p_final[2].scroll.mask_x:=511;
p_final[2].scroll.mask_y:=255;
//chars
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
//foreground
p_final[7].x:=512;
p_final[7].y:=256;
p_final[7].trans:=true;
p_final[7].scroll:=p_final[2].scroll;
iniciar_video;
//Main CPU
main_z80:=cpu_z80.create(6000000,1);
//Sound CPU
snd_z80:=cpu_z80.create(4000000,1);
snd_z80.init_sound(snd_despues_instruccion);
//Sound Chip
msm5205_init(0,400000,snd_z80.numero_cpu,MSM5205_S48_4B,1,snd_z80.clock,snd_adpcm);
ym3812_init(0,snd_z80.numero_cpu,4000000,snd_z80.clock,snd_irq,4);
//cargar roms
case main_vars.tipo_maquina of
  26:begin
      //Main
      main_z80.change_ram_calls(rygar_getbyte,rygar_putbyte);
      //Sound
      snd_z80.change_ram_calls(rygar_snd_getbyte,rygar_snd_putbyte);
      //Video
      tipo_video:=0;
      if not(cargar_roms(@memoria_temp[0],@rygar_rom[0],'rygar.zip',0)) then exit;
      copymemory(@memoria[0],@memoria_temp[0],$c000);
      //copymemory(@memoria[$8000],@memoria_temp[$8000],$4000);
      for f:=0 to $1f do copymemory(@bank_rom[f,0],@memoria_temp[$10000+(f*$800)],$800);
      //cargar sonido
      if not(cargar_roms(@mem_snd[0],@rygar_sound,'rygar.zip',1)) then exit;
      if not(cargar_roms(@mem_adpcm[0],@rygar_adpcm,'rygar.zip',1)) then exit;
      //convertir chars
      if not(cargar_roms(@memoria_temp[0],@rygar_char,'rygar.zip',1)) then exit;
      char_convert(1024);
      //Sprites
      if not(cargar_roms(@memoria_temp[0],@rygar_sprites[0],'rygar.zip',0)) then exit;
      sprite_convert(4096);
      //foreground
      init_gfx(1,16,16,$800);
      if not(cargar_roms(@memoria_temp[0],@rygar_tiles1[0],'rygar.zip',0)) then exit;
      tile_convert($400);
      //background
      if not(cargar_roms(@memoria_temp[0],@rygar_tiles2[0],'rygar.zip',0)) then exit;
      tile_convert(0);
  end;
  97:begin  //Silk Worm
      //Main
      main_z80.change_ram_calls(sw_getbyte,sw_putbyte);
      //Sound
      snd_z80.change_ram_calls(sw_snd_getbyte,sw_snd_putbyte);
      //Video
      tipo_video:=1;
      if not(cargar_roms(@memoria_temp[0],@sw_rom[0],'silkworm.zip',0)) then exit;
      copymemory(@memoria[0],@memoria_temp[0],$10000);
      for f:=0 to $1f do copymemory(@bank_rom[f,0],@memoria_temp[$10000+(f*$800)],$800);
      //cargar sonido
      if not(cargar_roms(@mem_snd[0],@sw_sound,'silkworm.zip',1)) then exit;
      if not(cargar_roms(@mem_adpcm[0],@sw_adpcm,'silkworm.zip',1)) then exit;
      //convertir chars
      if not(cargar_roms(@memoria_temp[0],@sw_char,'silkworm.zip',1)) then exit;
      char_convert($400);
      //Sprites
      if not(cargar_roms(@memoria_temp[0],@sw_sprites[0],'silkworm.zip',0)) then exit;
      sprite_convert($2000);
      //foreground
      init_gfx(1,16,16,$1000);
      if not(cargar_roms(@memoria_temp[0],@sw_tiles1[0],'silkworm.zip',0)) then exit;
      tile_convert($800);
      //background
      if not(cargar_roms(@memoria_temp[0],@sw_tiles2[0],'silkworm.zip',0)) then exit;
      tile_convert(0);
     end;
end;
reset_tecmo;
iniciar_tecmo:=true;
end;

procedure cerrar_tecmo;
begin
main_z80.free;
snd_z80.free;
msm5205_close(0);
ym3812_close(0);
close_audio;
close_video;
end;

procedure reset_tecmo;
begin
 main_z80.reset;
 snd_z80.reset;
 ym3812_reset(0);
 msm5205_reset(0);
 reset_audio;
 adpcm_end:=0;
 adpcm_pos:=0;
 adpcm_data:=-1;
 in0:=0;
 in1:=0;
 in2:=0;
 nbank_rom:=0;
 scroll_x1.w:=0;
 scroll_x2.w:=0;
 scroll_y1:=0;
 scroll_y2:=0;
 soundlatch:=0;
end;

procedure draw_sprites(prioridad:byte);
const
  layout:array[0..7,0..7] of byte = (
		(0,1,4,5,16,17,20,21),
		(2,3,6,7,18,19,22,23),
		(8,9,12,13,24,25,28,29),
		(10,11,14,15,26,27,30,31),
		(32,33,36,37,48,49,52,53),
		(34,35,38,39,50,51,54,55),
		(40,41,44,45,56,57,60,61),
		(42,43,46,47,58,59,62,63));
var
  nchar,dx,dy,sx,sy,x,y,f,color:word;
  flags,bank:byte;
  size:word;
  flipx,flipy:boolean;
begin
for f:=0 to $ff do begin
 flags:=memoria[$e003+(f*8)];
 if prioridad=(flags shr 6) then begin
  bank:=memoria[$e000+(f*8)];
  if (bank and 4)<>0 then begin //sprite visible
    if tipo_video=1 then nchar:=memoria[$e001+(f*8)]+((bank and $f8) shl 5)
      else nchar:=memoria[$e001+(f*8)]+((bank and $f0) shl 4);
    size:=memoria[$e002+(f*8)] and 3;
    nchar:=nchar and (not((1 shl (size*2))-1));
    size:=1 shl size;
    dx:=memoria[$e005+(f*8)]-((flags and $10) shl 4);
    dy:=memoria[$e004+(f*8)]-((flags and $20) shl 3);
    color:=(flags and $f) shl 4;
    flipx:=(bank and $1)<>0;
    flipy:=(bank and $2)<>0;
    for y:=0 to (size-1) do begin
				for x:=0 to (size-1) do begin
          if flipx then sx:=dx+8*(size-1-x)
              else sx:=dx+8*x;
          if flipy then sy:=dy+8*(size-1-y)
              else sy:=dy+8*y;
          put_gfx_sprite(nchar+layout[y,x],color,flipx,flipy,2);
          actualiza_gfx_sprite(sx+48,sy,1,2);
        end;
    end;
  end;
 end;
end;
end;

procedure update_video_tecmo;
var
        f,color,nchar:word;
        x,y:word;
        atrib:byte;
begin
//chars
for f:=0 to $3ff do begin
  atrib:=txt_ram[$400+f];
  color:=atrib shr 4;
  if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
      x:=f mod 32;
      y:=f div 32;
      nchar:=txt_ram[f]+((atrib and $3) shl 8);
      put_gfx_trans(x*8,y*8,nchar,(color shl 4)+$100,6,0);
      gfx[0].buffer[f]:=false;
  end;
end;
for f:=0 to $1ff do begin
    //Background
    atrib:=bg_ram[$200+f];
    color:=atrib shr 4;
    if ((gfx[1].buffer[f]) or (gfx[1].color_buffer[color])) then begin
        x:=f mod 32;
        y:=f div 32;
        nchar:=bg_ram[f]+((atrib and $7) shl 8);
        put_gfx_trans(x*16,y*16,nchar,(color shl 4)+$300,2,1);
        gfx[1].buffer[f]:=false;
    end;
    //Delante
    atrib:=fg_ram[$200+f];
    color:=atrib shr 4;
    if ((gfx[1].buffer[f+$200]) or (gfx[1].color_buffer[color+$10])) then begin
        x:=f mod 32;
        y:=f div 32;
        nchar:=fg_ram[f]+((atrib and $7) shl 8);
        put_gfx_trans(x*16,y*16,nchar+(1024*(tipo_video+1)),(color shl 4)+$200,7,1);
        gfx[1].buffer[f+$200]:=false;
    end;
end;
fillchar(gfx[0].color_buffer[0],$10,0);
fillchar(gfx[1].color_buffer[0],$10+$10,0);
fill_full_screen(1,$100);
draw_sprites(3);
scroll_x_y(2,1,scroll_x2.w,scroll_y2);
draw_sprites(2);
scroll_x_y(7,1,scroll_x1.w,scroll_y1);
draw_sprites(1);
actualiza_trozo(0,0,256,256,6,48,0,256,256,1);
draw_sprites(0);
actualiza_trozo_final(48,16,256,224,1);
end;

procedure eventos_tecmo;
begin
if event.arcade then begin
  if arcade_input.down[0] then in0:=(in0 or 4) else in0:=(in0 and $fb);
  if arcade_input.up[0] then in0:=(in0 or 8) else in0:=(in0 and $f7);
  if arcade_input.left[0] then in0:=(in0 or 1) else in0:=(in0 and $fe);
  if arcade_input.right[0] then in0:=(in0 or 2) else in0:=(in0 and $fd);
  if arcade_input.down[1] then in3:=(in3 or 4) else in3:=(in3 and $fb);
  if arcade_input.up[1] then in3:=(in3 or 8) else in3:=(in3 and $f7);
  if arcade_input.left[1] then in3:=(in3 or 1) else in3:=(in3 and $fe);
  if arcade_input.right[1] then in3:=(in3 or 2) else in3:=(in3 and $fd);
  if arcade_input.start[0] then in2:=(in2 or 2) else in2:=(in2 and $fd);
  if arcade_input.start[1] then in2:=(in2 or 1) else in2:=(in2 and $fe);
  if arcade_input.coin[1] then in2:=(in2 or 4) else in2:=(in2 and $fb);
  if arcade_input.coin[0] then in2:=(in2 or 8) else in2:=(in2 and $f7);
  if arcade_input.but1[0] then in1:=(in1 or $1) else in1:=(in1 and $fe);
  if arcade_input.but0[0] then in1:=(in1 or $2) else in1:=(in1 and $fd);
  if arcade_input.but1[1] then in4:=(in4 or $1) else in4:=(in4 and $fe);
  if arcade_input.but0[1] then in4:=(in4 or $2) else in4:=(in4 and $fd);
end;
end;

procedure tecmo_principal;
var
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
  //Main CPU
  main_z80.run(trunc(frame_m));
  frame_m:=frame_m+main_z80.tframes-main_z80.contador;
  //Sound CPU
  snd_z80.run(trunc(frame_s));
  frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
  //Main loop
  main_z80.pedir_irq:=HOLD_LINE;
  update_video_tecmo;
  eventos_tecmo;
  video_sync;
end;
end;

procedure cambiar_color(numero:word);
var
  color:tcolor;
  valor:byte;
begin
  valor:=buffer_paleta[numero];
  color.b:=pal4bit(valor);
  valor:=buffer_paleta[1+numero];
  color.g:=pal4bit(valor);
  color.r:=pal4bit(valor shr 4);
  numero:=numero shr 1;
  set_pal_color(color,addr(paleta[numero]));
  case numero of
    256..511:gfx[0].color_buffer[(numero shr 4) and $f]:=true;
    512..767:gfx[1].color_buffer[((numero shr 4) and $f)+$10]:=true;
    768..1023:gfx[1].color_buffer[(numero shr 4) and $f]:=true;
  end;
end;

function rygar_getbyte(direccion:word):byte;
begin
case direccion of
  $d000..$d7ff:rygar_getbyte:=txt_ram[direccion and $7ff];
  $d800..$dbff:rygar_getbyte:=fg_ram[direccion and $3ff];
  $dc00..$dfff:rygar_getbyte:=bg_ram[direccion and $3ff];
  $f000..$f7ff:rygar_getbyte:=bank_rom[nbank_rom,direccion and $7ff];
  $f800:rygar_getbyte:=in0;
  $f801:rygar_getbyte:=in1;
  $f802:rygar_getbyte:=in3;
  $f803:rygar_getbyte:=in4;
  $f804:rygar_getbyte:=in2;
  $f805..$f806,$f808:rygar_getbyte:=0;
  $f807:rygar_getbyte:=4;
  $f809:rygar_getbyte:=8;
  $f80f:rygar_getbyte:=0;
  else rygar_getbyte:=memoria[direccion];
end;
end;

procedure rygar_putbyte(direccion:word;valor:byte);
begin
if (direccion<$c000) then exit;
memoria[direccion]:=valor;
case direccion of
    $d000..$d7ff:if txt_ram[direccion and $7ff]<>valor then begin
                    gfx[0].buffer[direccion and $3ff]:=true;
                    txt_ram[direccion and $7ff]:=valor;
                 end;
    $d800..$dbff:if fg_ram[direccion and $3ff]<>valor then begin
                    gfx[1].buffer[(direccion and $1ff)+$200]:=true;
                    fg_ram[direccion and $3ff]:=valor;
                 end;
    $dc00..$dfff:if bg_ram[direccion and $3ff]<>valor then begin
                    gfx[1].buffer[direccion and $1ff]:=true;
                    bg_ram[direccion and $3ff]:=valor;
                 end;
    $e800..$efff:if buffer_paleta[direccion and $7ff]<>valor then begin
                    buffer_paleta[direccion and $7ff]:=valor;
                    cambiar_color(direccion and $7fe);
                 end;
    $f000..$f7ff:exit;  //ROM
    $f800:scroll_x1.l:=valor;
    $f801:scroll_x1.h:=valor and 1;
    $f802:scroll_y1:=valor;
    $f803:scroll_x2.l:=valor;
    $f804:scroll_x2.h:=valor and 1;
    $f805:scroll_y2:=valor;
    $f806:begin
            soundlatch:=valor;
            snd_z80.pedir_nmi:=PULSE_LINE;
          end;
    $f808:nbank_rom:=(valor and $f8) shr 3;
end;
end;

function rygar_snd_getbyte(direccion:word):byte;
begin
if direccion=$c000 then rygar_snd_getbyte:=soundlatch
  else rygar_snd_getbyte:=mem_snd[direccion];
end;

procedure rygar_snd_putbyte(direccion:word;valor:byte);
begin
if direccion<$4000 then exit;
mem_snd[direccion]:=valor;
  case direccion of
     $8000:ym3812_control_port(0,valor);
     $8001:ym3812_write_port(0,valor);
     $c000:begin
              adpcm_pos:=(valor shl 8);
              msm5205_reset_w(0,0);
           end;
     $d000:adpcm_end:=((valor+1) shl 8);
  end;
end;

//Silkworm
function sw_getbyte(direccion:word):byte;
begin
case direccion of
  $c000..$c3ff:sw_getbyte:=bg_ram[direccion and $3ff];
  $c400..$c7ff:sw_getbyte:=fg_ram[direccion and $3ff];
  $c800..$cfff:sw_getbyte:=txt_ram[direccion and $7ff];
  $f000..$f7ff:sw_getbyte:=bank_rom[nbank_rom,direccion and $7ff];
  $f800:sw_getbyte:=in0;
  $f801:sw_getbyte:=in1;
  $f802:sw_getbyte:=in3;
  $f803:sw_getbyte:=in4;
  $f804..$f806,$f808:sw_getbyte:=0;
  $f807:sw_getbyte:=8;
  $f809:sw_getbyte:=0;
  $f80f:sw_getbyte:=in2;
  else sw_getbyte:=memoria[direccion];
end;
end;

procedure sw_putbyte(direccion:word;valor:byte);
begin
if (direccion<$c000) then exit;
case direccion of
    $c000..$c3ff:if bg_ram[direccion and $3ff]<>valor then begin
                    gfx[1].buffer[direccion and $1ff]:=true;
                    bg_ram[direccion and $3ff]:=valor;
                 end;
    $c400..$c7ff:if fg_ram[direccion and $3ff]<>valor then begin
                    gfx[1].buffer[(direccion and $1ff)+$200]:=true;
                    fg_ram[direccion and $3ff]:=valor;
                 end;
    $c800..$cfff:if txt_ram[direccion and $7ff]<>valor then begin
                    gfx[0].buffer[direccion and $3ff]:=true;
                    txt_ram[direccion and $7ff]:=valor;
                 end;
    $e800..$efff:if buffer_paleta[direccion and $7ff]<>valor then begin
                    buffer_paleta[direccion and $7ff]:=valor;
                    cambiar_color(direccion and $7fe);
                 end;
    $f000..$f7ff:exit;  //ROM
    $f800:scroll_x1.l:=valor;
    $f801:scroll_x1.h:=valor and 1;
    $f802:scroll_y1:=valor;
    $f803:scroll_x2.l:=valor;
    $f804:scroll_x2.h:=valor and 1;
    $f805:scroll_y2:=valor;
    $f806:begin
            soundlatch:=valor;
            snd_z80.pedir_nmi:=PULSE_LINE;
          end;
    $f808:nbank_rom:=(valor and $f8) shr 3;
end;
memoria[direccion]:=valor;
end;

function sw_snd_getbyte(direccion:word):byte;
begin
if direccion=$c000 then sw_snd_getbyte:=soundlatch
  else sw_snd_getbyte:=mem_snd[direccion];
end;

procedure sw_snd_putbyte(direccion:word;valor:byte);
begin
if direccion<$8000 then exit;
mem_snd[direccion]:=valor;
  case direccion of
     $a000:ym3812_control_port(0,valor);
     $a001:ym3812_write_port(0,valor);
     $c000:begin
              adpcm_pos:=(valor shl 8);
              msm5205_reset_w(0,0);
           end;
     $c400:adpcm_end:=((valor+1) shl 8);
  end;
end;

procedure snd_irq(irqstate:integer);
begin
  if (irqstate=1) then snd_z80.pedir_irq:=ASSERT_LINE
    else snd_z80.pedir_irq:=CLEAR_LINE;
end;

procedure snd_despues_instruccion;
begin
  YM3812_Update(0);
end;

procedure snd_adpcm;
begin
if ((adpcm_pos>=adpcm_end) or	(adpcm_pos>$7fff)) then begin
  MSM5205_reset_w(0,1);
  exit;
end;
if (adpcm_data<>-1) then begin
		MSM5205_data_w(0,adpcm_data and $0f);
		adpcm_data:=-1;
end	else begin
		adpcm_data:=mem_adpcm[adpcm_pos];
    adpcm_pos:=adpcm_pos+1;
		MSM5205_data_w(0,(adpcm_data and $f0) shr 4);
end;
end;

end.
