unit tehkanworldcup_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     nz80,main_engine,controls_engine,gfx_engine,ay_8910,msm5205,
     rom_engine,pal_engine,sound_engine;

procedure Cargar_tehkanwc;
procedure tehkanwc_principal;
function iniciar_tehkanwc:boolean;
procedure reset_tehkanwc;
procedure cerrar_tehkanwc;
//Main CPU
function tehkanwc_getbyte(direccion:word):byte;
procedure tehkanwc_putbyte(direccion:word;valor:byte);
//Sub CPU
function tehkanwc_misc_getbyte(direccion:word):byte;
procedure tehkanwc_misc_putbyte(direccion:word;valor:byte);
//Sound CPU
function snd_getbyte(direccion:word):byte;
procedure snd_putbyte(direccion:word;valor:byte);
function snd_inbyte(puerto:word):byte;
procedure snd_outbyte(valor:byte;puerto:word);
procedure tehkanwc_sound_update;
procedure tehkan_porta_write(valor:byte);
procedure tehkan_portb_write(valor:byte);
function tehkan_porta_read:byte;
function tehkan_portb_read:byte;
procedure msm5205_sound;

const
        tehkanwc_rom:array[0..3] of tipo_roms=(
        (n:'twc-1.bin';l:$4000;p:0;crc:$34d6d5ff),(n:'twc-2.bin';l:$4000;p:$4000;crc:$7017a221),
        (n:'twc-3.bin';l:$4000;p:$8000;crc:$8b662902),());
        tehkanwc_cpu2:tipo_roms=(n:'twc-4.bin';l:$8000;p:0;crc:$70a9f883);
        tehkanwc_sound:tipo_roms=(n:'twc-6.bin';l:$4000;p:0;crc:$e3112be2);
        tehkanwc_chars:tipo_roms=(n:'twc-12.bin';l:$4000;p:0;crc:$a9e274f8);
        tehkanwc_sprites:array[0..2] of tipo_roms=(
        (n:'twc-8.bin';l:$8000;p:0;crc:$055a5264),(n:'twc-7.bin';l:$8000;p:$8000;crc:$59faebe7),());
        tehkanwc_tiles:array[0..2] of tipo_roms=(
        (n:'twc-11.bin';l:$8000;p:0;crc:$669389fc),(n:'twc-9.bin';l:$8000;p:$8000;crc:$347ef108),());
        tehkanwc_adpcm:tipo_roms=(n:'twc-5.bin';l:$4000;p:0;crc:$444b5544);

var
 scroll_x:parejas;
 sound_latch,sound_latch2,scroll_y:byte;
 track0,track1:array[0..1] of byte;
 msm_data_offs:word;
 mem_adpcm:array[0..$7fff] of byte;
 msm_toggle:byte;

implementation

procedure Cargar_tehkanwc;
begin
llamadas_maquina.iniciar:=iniciar_tehkanwc;
llamadas_maquina.bucle_general:=tehkanwc_principal;
llamadas_maquina.cerrar:=cerrar_tehkanwc;
llamadas_maquina.reset:=reset_tehkanwc;
end;

function iniciar_tehkanwc:boolean;
const
  ps_x:array[0..15] of dword=(1*4, 0*4, 3*4, 2*4, 5*4, 4*4, 7*4, 6*4,
			8*32+1*4, 8*32+0*4, 8*32+3*4, 8*32+2*4, 8*32+5*4, 8*32+4*4, 8*32+7*4, 8*32+6*4);
  ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
			16*32, 17*32, 18*32, 19*32, 20*32, 21*32, 22*32, 23*32);
  pc_x:array[0..7] of dword=(1*4, 0*4, 3*4, 2*4, 5*4, 4*4, 7*4, 6*4);
  pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
var
  memoria_temp:array[0..$ffff] of byte;
begin
iniciar_tehkanwc:=false;
iniciar_audio(false);
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[1].scroll.long_x:=512;
p_final[1].scroll.max_x:=256;
p_final[1].scroll.mask_x:=511;
p_final[1].scroll.long_y:=256;
p_final[1].scroll.max_y:=256;
p_final[1].scroll.mask_y:=255;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].final_mix:=true;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].trans:=true;
p_final[4].x:=256;
p_final[4].y:=256;
p_final[4].trans:=true;
iniciar_video;
//Main CPU
main_z80:=cpu_z80.create(4608000,600);
main_z80.change_ram_calls(tehkanwc_getbyte,tehkanwc_putbyte);
//Misc CPU
sub_z80:=cpu_z80.create(4608000,600);
sub_z80.change_ram_calls(tehkanwc_misc_getbyte,tehkanwc_misc_putbyte);
//Sound CPU
snd_z80:=cpu_z80.create(4608000,600);
snd_z80.change_ram_calls(snd_getbyte,snd_putbyte);
snd_z80.change_io_calls(snd_inbyte,snd_outbyte);
snd_z80.init_sound(tehkanwc_sound_update);
//Sound Chip
ay8910_0:=ay8910_chip.create(1536000,1);
ay8910_0.change_io_calls(nil,nil,tehkan_porta_write,tehkan_portb_write);
ay8910_1:=ay8910_chip.create(1536000,1);
ay8910_1.change_io_calls(tehkan_porta_read,tehkan_portb_read,nil,nil);
msm5205_init(0,384000,snd_z80.numero_cpu,MSM5205_S96_4B,1,snd_z80.clock,msm5205_sound);
//cargar roms
if not(cargar_roms(@memoria[0],@tehkanwc_rom[0],'tehkanwc.zip',0)) then exit;
//cargar cpu 2
if not(cargar_roms(@mem_misc[0],@tehkanwc_cpu2,'tehkanwc.zip',1)) then exit;
//cargar sonido
if not(cargar_roms(@mem_snd[0],@tehkanwc_sound,'tehkanwc.zip',1)) then exit;
//Cargar ADPCM
if not(cargar_roms(@mem_adpcm[0],@tehkanwc_adpcm,'tehkanwc.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@tehkanwc_chars,'tehkanwc.zip',1)) then exit;
init_gfx(0,8,8,512);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=1;
des_gfx.pos_planos[2]:=2;
des_gfx.pos_planos[3]:=3;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@tehkanwc_sprites[0],'tehkanwc.zip',0)) then exit;
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=1;
des_gfx.pos_planos[2]:=2;
des_gfx.pos_planos[3]:=3;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=128*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@tehkanwc_tiles[0],'tehkanwc.zip',0)) then exit;
init_gfx(2,16,8,1024);
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=1;
des_gfx.pos_planos[2]:=2;
des_gfx.pos_planos[3]:=3;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
reset_tehkanwc;
iniciar_tehkanwc:=true;
end;

procedure cerrar_tehkanwc;
begin
main_z80.free;
sub_z80.free;
snd_z80.free;
ay8910_0.Free;
ay8910_1.Free;
msm5205_close(0);
close_audio;
close_video;
end;

procedure reset_tehkanwc;
begin
 main_z80.reset;
 sub_z80.reset;
 snd_z80.reset;
 ay8910_0.reset;
 ay8910_1.reset;
 msm5205_reset(0);
 reset_audio;
 in0:=0;
 in1:=$20;
 in2:=$f;
 in3:=0;
 in4:=$20;
 msm_data_offs:=0;
 msm_toggle:=0;
 scroll_x.w:=0;
 sound_latch:=0;
 sound_latch2:=0;
 scroll_y:=0;
end;

procedure update_video_tehkanwc;inline;
var
  f,color,nchar,atrib:word;
  x,y:word;
begin
//background
for f:=0 to $3ff do begin
  atrib:=memoria[$e001+(f*2)];
  color:=atrib and $f;
  if ((gfx[2].buffer[f]) or (gfx[2].color_buffer[color])) then begin
      x:=f mod 32;
      y:=f div 32;
      nchar:=memoria[$e000+(f*2)]+((atrib and $30) shl 4);
      put_gfx_flip(x*16,y*8,nchar,(color shl 4)+512,1,2,(atrib and $40)<>0,(atrib and $80)<>0);
      gfx[2].buffer[f]:=false;
  end;
end;
scroll_x_y(1,2,scroll_x.w,scroll_y);
//chars
for f:=0 to $3ff do begin
  atrib:=memoria[$d400+f];
  color:=atrib and $f;
  if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
      x:=f mod 32;
      y:=f div 32;
      nchar:=memoria[$d000+f]+((atrib and $10) shl 4);
      put_gfx_trans_flip(x*8,y*8,nchar,color shl 4,3,0,(atrib and $40)<>0,(atrib and $80)<>0);
      if (atrib and $20)=0 then put_gfx_trans_flip(x*8,y*8,nchar,color shl 4,4,0,(atrib and $40)<>0,(atrib and $80)<>0)
        else put_gfx_block_trans(x*8,y*8,4,8,8);
      gfx[0].buffer[f]:=false;
  end;
end;
fillchar(gfx[0].color_buffer[0],$10,0);
fillchar(gfx[2].color_buffer[0],$10,0);
//chars de arriba
actualiza_trozo(0,0,256,256,3,0,0,256,256,2);
//Sprites
for f:=0 to $ff do begin
  atrib:=memoria[$e801+(f*4)];
  x:=memoria[$e802+(f*4)]+((atrib and $20) shl 3)-128;
  y:=memoria[$e803+(f*4)];
  color:=(atrib and $7) shl 4;
  nchar:=memoria[$e800+(f*4)]+((atrib and $08) shl 5);
  put_gfx_sprite(nchar,color+256,(atrib and $40)<>0,(atrib and $80)<>0,1);
  actualiza_gfx_sprite(x,y,2,1);
end;
//Prioridad de los chars
actualiza_trozo(0,0,256,256,4,0,0,256,256,2);
actualiza_trozo_final(0,16,256,224,2);
end;

procedure eventos_tehkanwc;
begin
if event.arcade then begin
  //Player 1
  if arcade_input.down[0] then in0:=(in0 or 4) else in0:=(in0 and $fb);
  if arcade_input.up[0] then in0:=(in0 or 8) else in0:=(in0 and $f7);
  if arcade_input.left[0] then in0:=(in0 or 2) else in0:=(in0 and $fd);
  if arcade_input.right[0] then in0:=(in0 or 1) else in0:=(in0 and $fe);
  if arcade_input.but0[0] then in1:=(in1 and $df) else in1:=(in1 or $20);
  //Player 2
  if arcade_input.down[1] then in3:=(in3 or 4) else in3:=(in3 and $fb);
  if arcade_input.up[1] then in3:=(in3 or 8) else in3:=(in3 and $f7);
  if arcade_input.left[1] then in3:=(in3 or 2) else in3:=(in3 and $fd);
  if arcade_input.right[1] then in3:=(in3 or 1) else in3:=(in3 and $fe);
  if arcade_input.but0[1] then in4:=(in4 and $df) else in4:=(in4 or $20);
  //Rest
  if arcade_input.coin[0] then in2:=(in2 and $fe) else in2:=(in2 or 1);
  if arcade_input.coin[1] then in2:=(in2 and $fd) else in2:=(in2 or 2);
  if arcade_input.start[0] then in2:=(in2 and $fb) else in2:=(in2 or 4);
  if arcade_input.start[1] then in2:=(in2 and $f7) else in2:=(in2 or 8);
end;
end;

procedure tehkanwc_principal;
var
  frame_m,frame_s,frame_m2:single;
  f:word;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
frame_m2:=sub_z80.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
 for f:=0 to 599 do begin
  //CPU 1
  main_z80.run(trunc(frame_m));
  frame_m:=frame_m+main_z80.tframes-main_z80.contador;
  //CPU 2
  sub_z80.run(trunc(frame_m2));
  frame_m2:=frame_m2+sub_z80.tframes-sub_z80.contador;
  //CPU Sound
  snd_z80.run(trunc(frame_s));
  frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
  if f=562 then begin
     main_z80.pedir_irq:=HOLD_LINE;
     sub_z80.pedir_irq:=HOLD_LINE;
     snd_z80.pedir_irq:=HOLD_LINE;
     update_video_tehkanwc;
  end;
 end;
 eventos_tehkanwc;
 video_sync;
end;
end;

procedure cambiar_color(dir:word);inline;
var
        tmp_color:byte;
        color:tcolor;
begin
  tmp_color:=buffer_paleta[dir];
  color.b:=pal4bit(tmp_color);
  tmp_color:=buffer_paleta[dir+1];
  color.g:=pal4bit(tmp_color shr 4);
  color.r:=pal4bit(tmp_color);
  dir:=dir shr 1;
  set_pal_color(color,addr(paleta[dir]));
  case dir of
    0..255:gfx[0].color_buffer[dir shr 4]:=true;
    512..767:gfx[2].color_buffer[(dir shr 4) and $f]:=true;
  end;
end;

procedure mem_shared_w(direccion:word;valor:byte);inline;
begin
case direccion of
    $800..$fff:gfx[0].buffer[direccion and $3ff]:=true;
    $1000..$17ff:if buffer_paleta[direccion and $7ff]<>valor then begin
                    buffer_paleta[direccion and $7ff]:=valor;
                    cambiar_color(direccion and $7fe);
                  end;
    $1800..$2000:gfx[2].buffer[(direccion and $7ff) shr 1]:=true;
    $2400:scroll_x.l:=valor;
    $2401:scroll_x.h:=valor and 1;
    $2402:scroll_y:=valor;
end;
end;

function tehkanwc_getbyte(direccion:word):byte;
var
  ret:byte;
begin
case direccion of
  $f800:begin
          if (in0 and 1)<>0 then ret:=$c1
            else begin
              if (in0 and 2)<>0 then ret:=63
                else ret:=0-track0[0];
            end;
            tehkanwc_getbyte:=ret;
        end;
  $f801:begin
          if (in0 and 4)<>0 then ret:=$c1
            else begin
              if (in0 and 8)<>0 then ret:=63
                else ret:=0-track0[1];
            end;
            tehkanwc_getbyte:=ret;
        end;
  $f802,$f806:tehkanwc_getbyte:=in2;
  $f803:tehkanwc_getbyte:=in1;
  $f810:begin
          if (in3 and 1)<>0 then ret:=$c1
            else begin
              if (in3 and 2)<>0 then ret:=63
                else ret:=0-track1[0];
            end;
            tehkanwc_getbyte:=ret;
        end;
  $f811:begin
          if (in3 and 4)<>0 then ret:=$c1
            else begin
              if (in3 and 8)<>0 then ret:=63
                else ret:=0-track1[1];
            end;
            tehkanwc_getbyte:=ret;
        end;
  $f813:tehkanwc_getbyte:=in4;
  $f820:tehkanwc_getbyte:=sound_latch2;
  $f840,$f850,$f860:tehkanwc_getbyte:=$ff;
  $f870:tehkanwc_getbyte:=$f;
    else tehkanwc_getbyte:=memoria[direccion];
end;
end;

procedure tehkanwc_putbyte(direccion:word;valor:byte);
begin
case direccion of
    $0..$bfff:exit;
    $c800..$ec02:begin
                    memoria[direccion]:=valor;
                    mem_shared_w(direccion-$c800,valor);
                 end;
    $f800:track0[0]:=valor;
    $f801:track0[1]:=valor;
    $f810:track1[0]:=valor;
    $f811:track1[1]:=valor;
    $f820:begin
            sound_latch:=valor;
            snd_z80.pedir_nmi:=PULSE_LINE;
          end;
    $f840:if valor<>0 then sub_z80.reset
            else sub_z80.enabled:=false;
end;
memoria[direccion]:=valor;
end;

function tehkanwc_misc_getbyte(direccion:word):byte;
begin
case direccion of
  $c800..$ec02:tehkanwc_misc_getbyte:=memoria[direccion];
    else tehkanwc_misc_getbyte:=mem_misc[direccion];
end;
end;

procedure tehkanwc_misc_putbyte(direccion:word;valor:byte);
begin
case direccion of
    0..$7fff:exit;
    $c800..$ec02:begin
                    memoria[direccion]:=valor;
                    mem_shared_w(direccion-$c800,valor);
                 end;
    else mem_misc[direccion]:=valor;
end;
end;

function snd_getbyte(direccion:word):byte;
begin
case direccion of
  $c000:snd_getbyte:=sound_latch;
  else snd_getbyte:=mem_snd[direccion];
end;
end;

procedure snd_putbyte(direccion:word;valor:byte);
begin
if direccion<$4000 then exit;
mem_snd[direccion]:=valor;
case direccion of
  $8001:if (valor<>0) then msm5205_reset_w(0,1)
            else msm5205_reset_w(0,0);
  $c000:sound_latch2:=valor;
end;
end;

function snd_inbyte(puerto:word):byte;
begin
case (puerto and $ff) of
 0:snd_inbyte:=ay8910_0.Read;
 1:snd_inbyte:=ay8910_1.Read;
end;
end;

procedure snd_outbyte(valor:byte;puerto:word);
begin
case (puerto and $ff) of
  $0:ay8910_0.Write(valor);
  $1:ay8910_0.Control(valor);
  $2:ay8910_1.Write(valor);
  $3:ay8910_1.Control(valor);
end;
end;

procedure tehkan_porta_write(valor:byte);
begin
msm_data_offs:=(msm_data_offs and $ff00) or valor;
end;

procedure tehkan_portb_write(valor:byte);
begin
msm_data_offs:=(msm_data_offs and $ff) or (valor shl 8);
end;

function tehkan_porta_read:byte;
begin
tehkan_porta_read:=msm_data_offs and $ff;
end;

function tehkan_portb_read:byte;
begin
tehkan_portb_read:=msm_data_offs shr 8;
end;

procedure msm5205_sound;
var
  msm_data:byte;
begin
  msm_data:=mem_adpcm[msm_data_offs and $7fff];
	if msm_toggle=0 then msm5205_data_w(0,msm_data shr 4)
	  else begin
  		msm5205_data_w(0,msm_data and $0f);
	  	msm_data_offs:=msm_data_offs+1;
	  end;
	msm_toggle:=msm_toggle xor 1;
end;

procedure tehkanwc_sound_update;
begin
  ay8910_0.update;
  ay8910_1.update;
end;

end.
