unit zaxxon_hw;

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     nz80,main_engine,controls_engine,gfx_engine,rom_engine,misc_functions,
     pal_engine,sound_engine;

procedure Cargar_zaxxon;
procedure zaxxon_principal;
function iniciar_zaxxon:boolean;
procedure reset_zaxxon;
procedure cerrar_zaxxon;
//Congo
function congo_getbyte(direccion:word):byte;
procedure congo_putbyte(direccion:word;valor:byte);

const
        //Congo
        congo_rom:array[0..4] of tipo_roms=(
        (n:'congo_rev_c_rom1.u21';l:$2000;p:0;crc:$09355b5b),(n:'congo_rev_c_rom2a.u22';l:$2000;p:$2000;crc:$1c5e30ae),
        (n:'congo_rev_c_rom3.u23';l:$2000;p:$4000;crc:$5ee1132c),(n:'congo_rev_c_rom4.u24';l:$2000;p:$6000;crc:$5332b9bf),());
        congo_pal:array[0..2] of tipo_roms=(
        (n:'mr019.u87';l:$100;p:0;crc:$b788d8ae),(n:'mr019.u87';l:$100;p:$100;crc:$b788d8ae),());
        congo_char:tipo_roms=(n:'tip_top_rom_5.u76';l:$1000;p:0;crc:$7bf6ba2b);
        congo_bg:array[0..3] of tipo_roms=(
        (n:'tip_top_rom_8.u93';l:$2000;p:0;crc:$db99a619),(n:'tip_top_rom_9.u94';l:$2000;p:$2000;crc:$93e2309e),
        (n:'tip_top_rom_10.u95';l:$2000;p:$4000;crc:$f27a9407),());
        congo_sprites:array[0..6] of tipo_roms=(
        (n:'tip_top_rom_12.u78';l:$2000;p:0;crc:$15e3377a),(n:'tip_top_rom_13.u79';l:$2000;p:$2000;crc:$1d1321c8),
        (n:'tip_top_rom_11.u77';l:$2000;p:$4000;crc:$73e2709f),(n:'tip_top_rom_14.u104';l:$2000;p:$6000;crc:$bf9169fe),
        (n:'tip_top_rom_16.u106';l:$2000;p:$8000;crc:$cb6d5775),(n:'tip_top_rom_15.u105';l:$2000;p:$a000;crc:$7b15a7a4),());
        congo_sound:tipo_roms=(n:'tip_top_rom_17.u19';l:$2000;p:0;crc:$5024e673);
        congo_tilemap:array[0..2] of tipo_roms=(
        (n:'congo6.u57';l:$2000;p:0;crc:$d637f02b),(n:'congo7.u58';l:$2000;p:$2000;crc:$80927943),());
        //DIP
        pacman_dip:array [0..5] of def_dip=(
        (mask:$3;name:'Coinage';number:4;dip:((dip_val:$3;dip_name:'2 Coin - 1 Credit'),(dip_val:$1;dip_name:'1 Coin - 1 Credit'),(dip_val:$2;dip_name:'1 Coin - 2 Credit'),(dip_val:$0;dip_name:'Free Play'),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$c;name:'Lives';number:4;dip:((dip_val:$0;dip_name:'1'),(dip_val:$4;dip_name:'2'),(dip_val:$8;dip_name:'3'),(dip_val:$c;dip_name:'5'),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$30;name:'Bonus Life';number:3;dip:((dip_val:$0;dip_name:'10000'),(dip_val:$10;dip_name:'15000'),(dip_val:$20;dip_name:'20000'),(),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$40;name:'Difficulty';number:2;dip:((dip_val:$40;dip_name:'Normal'),(dip_val:$0;dip_name:'Hard'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$80;name:'Ghost Names';number:2;dip:((dip_val:$80;dip_name:'Normal'),(dip_val:$0;dip_name:'Alternate'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),());
        mspacman_dip:array [0..4] of def_dip=(
        (mask:$3;name:'Coinage';number:4;dip:((dip_val:$3;dip_name:'2 Coin - 1 Credit'),(dip_val:$1;dip_name:'1 Coin - 1 Credit'),(dip_val:$2;dip_name:'1 Coin - 2 Credit'),(dip_val:$0;dip_name:'Free Play'),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$c;name:'Lives';number:4;dip:((dip_val:$0;dip_name:'1'),(dip_val:$4;dip_name:'2'),(dip_val:$8;dip_name:'3'),(dip_val:$c;dip_name:'5'),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$30;name:'Bonus Life';number:3;dip:((dip_val:$0;dip_name:'10000'),(dip_val:$10;dip_name:'15000'),(dip_val:$20;dip_name:'20000'),(),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$40;name:'Difficulty';number:2;dip:((dip_val:$40;dip_name:'Normal'),(dip_val:$0;dip_name:'Hard'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),());

var
 irq_vblank:boolean;
 congo_color_bank,congo_fg_bank,pal_offset,fg_color:word;

implementation

procedure Cargar_zaxxon;
begin
llamadas_maquina.iniciar:=iniciar_zaxxon;
llamadas_maquina.bucle_general:=zaxxon_principal;
llamadas_maquina.cerrar:=cerrar_zaxxon;
llamadas_maquina.reset:=reset_zaxxon;
llamadas_maquina.fps_max:=59.999408;
end;

function iniciar_zaxxon:boolean;
var
      colores:tpaleta;
      f:word;
      bit0,bit1,bit2:byte;
      memoria_temp:array[0..$ffff] of byte;
      rweights,gweights,bweights:array[0..2] of double;
const
  ps_x:array[0..15] of dword=(8*8, 8*8+1, 8*8+2, 8*8+3, 16*8+0, 16*8+1, 16*8+2, 16*8+3,
			24*8+0, 24*8+1, 24*8+2, 24*8+3, 0, 1, 2, 3);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			32*8, 33*8, 34*8, 35*8, 36*8, 37*8, 38*8, 39*8);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
  resistances:array[0..2] of integer=(1000,470,220);
procedure conv_chars;
begin
  init_gfx(0,8,8,256);
  gfx[0].trans[0]:=true;
  des_gfx.pos_planos[0]:=2*256*8*8;
  des_gfx.pos_planos[1]:=256*8*8;
  des_gfx.bit_pixel:=2;
  des_gfx.banks:=0;
  des_gfx.long_sprites:=8*8;
  convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
end;
procedure conv_background;
begin
  init_gfx(1,8,8,1024);
  des_gfx.pos_planos[0]:=3*1024*8*8;
  des_gfx.pos_planos[1]:=2*1024*8*8;
  des_gfx.pos_planos[2]:=1024*8*8;
  des_gfx.bit_pixel:=3;
  des_gfx.banks:=0;
  des_gfx.long_sprites:=8*8;
  convert_gfx(@gfx[1],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
end;
procedure conv_static_background;
var
  f,x,y,color,nchar:word;
  atrib:byte;
begin
for f:=0 to $1fff do begin
  x:=255-(f shr 5);
  y:=f and $1f;
  atrib:=memoria_temp[f+$2000];
  color:=(atrib and $f0) shr 1;
  nchar:=memoria_temp[f]+((atrib and $3)*256);
  put_gfx(x*8,y*8,nchar,color+64,3,1);
end;
end;
procedure conv_sprites;
begin
  init_gfx(1,16,16,64);
  des_gfx.pos_planos[0]:=0;
  des_gfx.pos_planos[1]:=4;
  des_gfx.bit_pixel:=2;
  des_gfx.banks:=0;
  des_gfx.long_sprites:=64*8;
  convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
end;
begin
iniciar_zaxxon:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].final_mix:=true;
p_final[2].sprite_end_y:=256;
p_final[2].sprite_mask_y:=$ff;
p_final[3].x:=4096;
p_final[3].y:=256;
iniciar_video;
//Main CPU
main_z80:=cpu_z80.create(3072000,264);
case main_vars.tipo_maquina of
  175:begin  //Congo
        main_z80.change_ram_calls(congo_getbyte,congo_putbyte);
        //cargar roms
        if not(cargar_roms(@memoria[0],@congo_rom[0],'congo.zip',0)) then exit;
        //cargar sonido & iniciar_sonido
        if not(cargar_roms(@memoria_temp[0],@congo_char,'congo.zip',1)) then exit;
        conv_chars;
        if not(cargar_roms(@memoria_temp[0],@congo_bg,'congo.zip',0)) then exit;
        conv_background;
        //convertir sprites
//        if not(cargar_roms(@memoria_temp[0],@congo_sprites,'congo.zip',0)) then exit;
//        conv_sprites;
        //poner la paleta
        if not(cargar_roms(@memoria_temp[0],@congo_pal[0],'congo.zip',0)) then exit;
        //DIP
        marcade.dswa:=$C9;
        marcade.dswa_val:=@pacman_dip;
     end;
end;
compute_resistor_weights(0,	255, -1.0,
			3,@resistances[0],@rweights[0],470,0,
			3,@resistances[0],@gweights[0],470,0,
			2,@resistances[1],@bweights[0],470,0);
for f:=0 to $1ff do begin
		// red component */
		bit0:=(memoria_temp[f] shr 0) and $01;
		bit1:=(memoria_temp[f] shr 1) and $01;
		bit2:=(memoria_temp[f] shr 2) and $01;
		colores[f].r:=combine_3_weights(@rweights[0], bit0, bit1, bit2);
		// green component */
		bit0:=(memoria_temp[f] shr 3) and $01;
		bit1:=(memoria_temp[f] shr 4) and $01;
		bit2:=(memoria_temp[f] shr 5) and $01;
		colores[f].g:=combine_3_weights(@gweights[0], bit0, bit1, bit2);
		// blue component */
		bit0:=(memoria_temp[f] shr 6) and $01;
		bit1:=(memoria_temp[f] shr 7) and $01;
		colores[f].b:=combine_2_weights(@bweights[0], bit0, bit1);
end;
set_pal(colores,$200);
if not(cargar_roms(@memoria_temp[0],@congo_tilemap,'congo.zip',0)) then exit;
conv_static_background;
//final
reset_zaxxon;
iniciar_zaxxon:=true;
end;

procedure cerrar_zaxxon;
begin
main_z80.free;
close_audio;
close_video;
end;

procedure reset_zaxxon;
begin
 main_z80.reset;
 reset_audio;
 irq_vblank:=false;
 marcade.in0:=$FF;
 marcade.in1:=$FF;
 congo_fg_bank:=0;
 congo_color_bank:=0;
 pal_offset:=0;
 fg_color:=0;
end;

{procedure draw_background;
begin
	// only draw if enabled */
  if true then begin//(state->m_bg_enable)
		bitmap_t *pixmap = tilemap_get_pixmap(state->m_bg_tilemap);
		int colorbase = state->m_bg_color + (state->m_congo_color_bank << 8);
		int xmask = pixmap->width - 1;
		int ymask = pixmap->height - 1;
		int flipmask = flip_screen_get(machine) ? 0xff : 0x00;
		int flipoffs = flip_screen_get(machine) ? 0x38 : 0x40;
		int x, y;

		/* the starting X value is offset by 1 pixel (normal) or 7 pixels */
		/* (flipped) due to a delay in the loading */
		if (!flip_screen_get(machine))
			flipoffs -= 1;
		else
			flipoffs += 7;

		/* loop over visible rows */
		for (y = cliprect->min_y; y <= cliprect->max_y; y++)
		{
			UINT16 *dst = (UINT16 *)bitmap->base + y * bitmap->rowpixels;
			int srcx, srcy, vf;
			UINT16 *src;

			/* VF = flipped V signals */
			vf = y ^ flipmask;

			/* base of the source row comes from VF plus the scroll value */
			/* this is done by the 3 4-bit adders at U56, U74, U75 */
			srcy = vf + ((state->m_bg_position << 1) ^ 0xfff) + 1;
			src = (UINT16 *)pixmap->base + (srcy & ymask) * pixmap->rowpixels;

			/* loop over visible colums */
			for (x = cliprect->min_x; x <= cliprect->max_x; x++)
			{
				/* start with HF = flipped H signals */
				srcx = x ^ flipmask;
				if (skew)
				{
					/* position within source row is a two-stage addition */
					/* first stage is HF plus half the VF, done by the 2 4-bit */
					/* adders at U53, U54 */
					srcx += ((vf >> 1) ^ 0xff) + 1;

					/* second stage is first stage plus a constant based on the flip */
					/* value is 0x40 for non-flipped, or 0x38 for flipped */
					srcx += flipoffs;
				}

// 				/* store the pixel, offset by the color offset */
//				dst[x] = src[srcx & xmask] + colorbase;
//			}
//		}
//	}

//	/* if not enabled, fill the background with black */
//	else
//		bitmap_fill(bitmap, cliprect, get_black_pen(machine));
//}


procedure update_video_zaxxon;
var
  f,color,nchar:word;
  atrib,x,y:byte;
begin
//Background
actualiza_trozo(0,0,256,256,3,0,0,256,256,2);
for f:=0 to $3ff do begin
    if gfx[0].buffer[f] then begin
      x:=31-(f shr 5);
      y:=f and $1f;
      color:=(memoria[$a400+f] and $1f) shl 3;
      nchar:=memoria[$a000+f]+congo_fg_bank;
      put_gfx_trans(x*8,y*8,nchar,color+128+pal_offset,1,0);
      gfx[0].buffer[f]:=false;
    end;
end;
actualiza_trozo(0,0,256,256,1,0,0,256,256,2);
{for f:=7 downto 0 do begin
        atrib:=memoria[$4ff0+(f*2)];
        nchar:=atrib shr 2;
        color:=(memoria[$4ff1+(f*2)] and $1f) shl 2;
        x:=240-memoria[$5060+(f*2)];
        y:=272-memoria[$5061+(f*2)];
        put_gfx_sprite_mask(nchar,color,(atrib and 2)<>0,(atrib and 1)<>0,1,0,$f);
        actualiza_gfx_sprite(x-1,y,2,1);
end; }
actualiza_trozo_final(0,0,256,256,2);
end;

procedure eventos_zaxxon;
begin
exit;
if event.arcade then begin
  if arcade_input.up[0] then marcade.in0:=(marcade.in0 and $fe) else marcade.in0:=(marcade.in0 or $1);
  if arcade_input.down[0] then marcade.in0:=(marcade.in0 and $F7) else marcade.in0:=(marcade.in0 or $8);
  if arcade_input.left[0] then marcade.in0:=(marcade.in0 and $fd) else marcade.in0:=(marcade.in0 or $2);
  if arcade_input.right[0] then marcade.in0:=(marcade.in0 and $Fb) else marcade.in0:=(marcade.in0 or $4);
  if arcade_input.coin[0] then marcade.in0:=(marcade.in0 and $df) else marcade.in0:=(marcade.in0 or $20);
  if arcade_input.coin[1] then marcade.in0:=(marcade.in0 and $bf) else marcade.in0:=(marcade.in0 or $40);
  if arcade_input.start[0] then marcade.in1:=(marcade.in1 and $df) else marcade.in1:=(marcade.in1 or $20);
  if arcade_input.start[1] then marcade.in1:=(marcade.in1 and $bf) else marcade.in1:=(marcade.in1 or $40);
  if arcade_input.but0[0] then begin
    if (memoria[$180b]<>$01) then begin
      memoria[$180b]:=$01;
      memoria[$1FFD]:=$BD;
    end
  end else begin
    if (memoria[$180b]<>$be) then begin
      memoria[$180b]:=$BE;
      memoria[$1FFD]:=$00;
    end
  end;
end;
end;

procedure zaxxon_principal;
var
  frame:single;
  f:word;
begin
init_controls(false,false,false,true);
frame:=main_z80.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to 263 do begin
    main_z80.run(trunc(frame));
    frame:=frame+main_z80.tframes-main_z80.contador;
    if f=239 then begin
      if irq_vblank then main_z80.pedir_irq:=ASSERT_LINE;
      update_video_zaxxon;
    end;
  end;
  eventos_zaxxon;
  video_sync;
end;
end;

function congo_getbyte(direccion:word):byte;
begin
case direccion of
        0..$8fff:congo_getbyte:=memoria[direccion];
        $a000..$bfff:congo_getbyte:=memoria[(direccion and $7ff)+$a000];
        $c000..$dfff:case (direccion and $3f) of
                        0,4:congo_getbyte:=0;
                        1,5:congo_getbyte:=0;
                        2,6:congo_getbyte:=$77;
                        3,7:congo_getbyte:=$33;
                        8..$f:congo_getbyte:=0;
                     end;
end;
end;

procedure congo_putbyte(direccion:word;valor:byte);
begin
if direccion<$7fff then exit;
memoria[direccion]:=valor;
case direccion of
        $a000..$bfff:begin
                        memoria[(direccion and $7ff)+$a000]:=valor;
                        gfx[0].buffer[direccion and $3ff]:=true;
                     end;
        $c000..$dfff:case (direccion and $3f) of
                        $18..$1a:;//zaxxon_coin_enable_w
	                      $1b..$1c:;//zaxxon_coin_counter_w
	                      $1d:;//zaxxon_bg_enable_w
	                      $1e:;//zaxxon_flipscreen_w
	                      $1f:begin
                              irq_vblank:=(valor and 1)<>0;
                              if not(irq_vblank) then main_z80.pedir_irq:=CLEAR_LINE;
                            end;
	                      $21:begin //zaxxon_fg_color_w
                              fg_color:=(valor and 1)*$80;
                              pal_offset:=fg_color+(congo_color_bank shl 8);
                              fillchar(gfx[0].buffer[0],$400,1);
                              fillchar(gfx[1].buffer[0],$400,1);
                            end;
	                      $23:;//zaxxon_bg_color_w
	                      $26:begin
                              congo_fg_bank:=(congo_fg_bank and 1) shl 8;
                              fillchar(gfx[0].buffer[0],$400,1);
                            end;
	                      $27:begin//congo_color_bank_w
                              congo_color_bank:=valor and 1;
                              pal_offset:=fg_color+(congo_color_bank shl 8);
                              fillchar(gfx[0].buffer[0],$400,1);
                              fillchar(gfx[1].buffer[0],$400,1);
                            end;
	                      $28..$29:;//zaxxon_bg_position_w
	                      $30..$33:;//congo_sprite_custom_w
	                      $38..$3f:;//soundlatch_w
                     end;
end;
end;

end.
