﻿unit upd765;

interface
uses sysutils,{$IFDEF WINDOWS}windows,{$ENDIF}
     main_engine,dialogs;

type
disc_header_type=record
  nbof_tracks:byte;
  nbof_heads:byte;
  track_size_table:array[0..1,0..$cb] of byte;
end;
sector_info_type=record
  track:byte;
  head:byte;
  sector:byte;
  sector_size:byte;
  multi:boolean;
  cont_multi,pos_cont_multi:byte;
  status1:byte;
  status2:byte;
  data_length:word;
  posicion_data:word;
end;
track_type=record
  track_number:byte;
  side_number:byte;
  data_rate:byte;
  recording_mode:byte;
  sector_size:byte;
  number_sector:byte;
  GAP3:byte;
  track_lenght:word;
  data:pbyte;
  sector:array[0..28] of sector_info_type;
end;

DskImg=record
  ImageName:string;
  abierto:boolean;
  track_actual:byte;
  cara_actual:byte;
  sector_actual:byte;
  sector_read_track:byte;
  protegido:boolean;
  DiskHeader:disc_header_type;
  extended:boolean;
  Tracks:array[0..1,0..79] of track_type;
end;

var
  dsk:array[0..1] of DskImg;
  FloppyMotor:byte;
  FDCCurrDrv:byte;
  ExecCmdPhase:boolean;
  ResultPhase:boolean;
  StatusRegister:byte;
  st0,st1,st2,st3:byte;
  contador_status,contador_read_status:byte;

  FDCCommand:array[0..8] of byte;
  FDCResult:array[0..6] of byte;
  FDCPointer:word;
  FDCCmdPointer:word;
  FDCResPointer:word;
  FDCResCounter:word;
  FDCDataPointer:word;
  FDCDataLength:word;
  FDCCounter:word;
  SeekTrack:boolean;
  Mostrar_disco:boolean;
  bytes_in_cmd: array[0..31] of byte = (
  1,1,9,3,2,9,9,2,1,9,2,1,9,6,1,3,1,9,1,1,1,1,1,1,1,9,1,1,1,1,9,1);

procedure WriteFDCData(value:byte);
function ReadFDCStatus:byte;
function ReadFDCData:byte;
procedure ResetFDC;
function InsertDisk(DrvNum:byte;longi_ini:dword;datos:pbyte):boolean;
procedure clear_disk(drvnum:byte);

implementation
uses principal;

procedure GetRes7;
begin
    FDCResult[0]:=st0;
    FDCResult[1]:=st1;
    FDCResult[2]:=st2;
    FDCResult[3]:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].track;
    FDCResult[4]:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].head;
    FDCResult[5]:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].sector;
    FDCResult[6]:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].sector_size;
    StatusRegister:=$D0;
    FDCResPointer:=0;
    FDCResCounter:=7;
    st0:=0;
    st1:=0;
    st2:=0;
    ExecCmdPhase:=FALSE;
    ResultPhase:=TRUE;
 end;

function buscar_sector:boolean;
var
  index_count:byte;
begin
buscar_sector:=false;
if dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].number_sector=0 then begin
  buscar_sector:=TRUE;
  exit;
end;
index_count:=0;
while (index_count<>2) do begin
    if (dsk[FDCCurrDrv].sector_actual+1)>dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].number_sector then begin
      dsk[FDCCurrDrv].sector_actual:=0;
      index_count:=index_count+1;
    end;
		if (dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].sector=FDCCommand[4]) then begin
			if (dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].track=FDCCommand[2]) then begin
				if (dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].head=FDCCommand[3]) then begin
					if (dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].sector_size=FDCCommand[5]) then begin
						if (FDCCommand[4]=FDCCommand[6]) then st1:=st1 or $80;// set end of cylinder */
            st1:=st1 or (dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].status1 and $20);
            st2:=st2 or (dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].status1 and $60);
						buscar_sector:=TRUE;
            exit;
          end else begin
            buscar_sector:=TRUE;
            st1:=st1 or $80;
            exit;
          end;
				end;
			end else begin
				st1:=st1 or $4; //NEC765_ST1_NO_DATA
				st2:=st2 or $10; //NEC765_ST2_WRONG_CYLINDER
				if (dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].track=$ff) then st2:=st2 or $2; //NEC765_ST2_BAD_CYLINDER
        buscar_sector:=true;
        exit;
			end;
		end;
    dsk[FDCCurrDrv].sector_actual:=dsk[FDCCurrDrv].sector_actual+1;
	end;
end;

function saltar_sector:boolean;
begin
if ((FDCCommand[0] and $20)<>0) then begin
  if ((FDCCommand[0] and $1f)=$6) then begin
    if ((dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].status2 and $40)<>0) then begin
      saltar_sector:=TRUE;
      exit;
    end;
  end else begin
    if ((FDCCommand[0] and $1f)=$c) then begin
      if ((dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].status2 and $40)=0) then begin
        saltar_sector:=true;
        exit;
			end;
		end;
  end;
end;
saltar_sector:=FALSE;
end;

procedure read_sector;
var
  salir:boolean;
begin
salir:=false;
while not(salir) do begin
  if buscar_sector then begin
    if saltar_sector then begin
      if (FDCCommand[4]=FDCCommand[6]) then begin
        st1:=st1 and $7f;
        GetRes7;
        exit;
      end;
      FDCCommand[4]:=FDCCommand[4]+1;
    end else salir:=true;
  end else begin
    st0:=st0 or $40;
    st1:=st1 or $4;
    GetRes7;
    exit;
  end;
end;
ExecCmdPhase:=TRUE;
if dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].multi then begin
  inc(dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].pos_cont_multi);
  if (dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].pos_cont_multi>dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].cont_multi) then
    dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].pos_cont_multi:=1;
  FDCDataPointer:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].posicion_data+((dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].pos_cont_multi-1)*(1 shl (dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].sector_size+7)));
  FDCDataLength:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].data_length;
end else begin
  FDCDataPointer:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].posicion_data;
  FDCDataLength:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].data_length;
end;
if FDCCommand[5]=0 then begin
  FDCDataLength:=FDCCommand[8];
  if FDCDataLength>$80 then FDCDataLength:=$80;
end;
FDCCounter:=0;
StatusRegister:=$f0;
mostrar_disco:=true;
form1.StatusBar1.Refresh;
end;

procedure read_track;
begin
FDCDataLength:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_read_track].data_length;
FDCDataPointer:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_read_track].posicion_data;
FDCCounter:=0;
ExecCmdPhase:=TRUE;
StatusRegister:=$F0;
end;

procedure fdc_get_drive;
begin
	FDCCurrDrv:=(FDCCommand[1] and 1);
	dsk[FDCCurrDrv].cara_actual:=(FDCCommand[1] and 4) shr 2;
	st0:=st0 and $F8;
	st3:=st3 and $F8;
	st0:=st0 or (FDCCommand[1] and 1) or (FDCCommand[1] and 4);
  st3:=st3 or (FDCCommand[1] and 1) or (FDCCommand[1] and 4);
end;

function seek_track(track:byte):boolean;
var
  test:boolean;
begin
test:=not(track>(dsk[FDCCurrDrv].DiskHeader.nbof_tracks-1));
if test then dsk[FDCCurrDrv].track_actual:=track
  else dsk[FDCCurrDrv].track_actual:=dsk[FDCCurrDrv].DiskHeader.nbof_tracks;
seek_track:=test;
end;

procedure FDCExecWriteCommand;
begin
case (FDCCommand[0] and $1f) of
     0,1,11,14,16,18..24,26..29,31:begin
      FDCResCounter:=1;
      FDCResPointer:=0;
      st0:=$80 or st0;
      if ExecCmdPhase then begin  //Hacer timeout para la proteccion Hexagon
        st1:=st1 or $10;
        st0:=(st0 and $3f) or $40;
        StatusRegister:=$80;
      end;
      FDCResult[0]:=st0;
      ExecCmdPhase:=FALSE;
      ResultPhase:=TRUE;
      seektrack:=true;
     end;
     2:begin // Read track
      st0:=0;
      st1:=$4;
      st2:=0;
      fdc_get_drive;
      if not(dsk[FDCCurrDrv].abierto) then begin
        st0:=st0 or $48;
        GetRes7;
      end else begin
        mostrar_disco:=true;
        form1.StatusBar1.Refresh;
        dsk[FDCCurrDrv].sector_read_track:=0;
        read_track;
      end;
     end;
     3:begin // Specify
        ExecCmdPhase:=FALSE;
        ResultPhase:=FALSE;
        StatusRegister:=StatusRegister and ($40+$20+$10);
        StatusRegister:=StatusRegister or $80;
      end;
     4:begin // Sense drive status
      FDCCurrDrv:=(FDCCommand[1] and 1);
      st3:=st3 or (FDCCommand[1] and 1) or (FDCCommand[1] and 4);
      if dsk[FDCCurrDrv].protegido then st3:=st3 or $40;
      if dsk[FDCCurrDrv].abierto then st3:=st3 or $20;
      if (dsk[FDCCurrDrv].track_actual=0) then st3:=st3 or  $10;
      st3:=st3 or dsk[FDCCurrDrv].DiskHeader.nbof_heads shl 4;
      FDCResCounter:=1;
      FDCResPointer:=0;
      FDCResult[0]:=st3;
      ExecCmdPhase:=FALSE;
      ResultPhase:=TRUE;
      StatusRegister:=StatusRegister or $40;// $D0;
      StatusRegister:=StatusRegister and $20;
      end;
     5,9:begin  //Write data o deleted data (parcial)
         st0:=0;
         st1:=0;
         st2:=0;
         fdc_get_drive;
         if not(dsk[FDCCurrDrv].abierto) then begin
           st0:=st0 or $48;
           getres7;
           exit;
         end;
         if dsk[FDCCurrDrv].protegido then begin
           st0:=st0 or $40;
           st1:=st1 or 2;
           getres7;
           exit;
         end else begin
           st0:=0;
           st1:=0;
           st2:=0;
           fdc_get_drive;
         end;
     end;
     6,12:begin // Read data o deleted data
          st0:=0;
          st1:=0;
          st2:=0;
          fdc_get_drive;
          if not(dsk[FDCCurrDrv].abierto) then begin
            st0:=st0 or $48;
            getres7;
          end else read_sector;
        end;
     7:begin // Recalibrate
      st0:=$20;
      st1:=0;
      st2:=0;
      fdc_get_drive;
      StatusRegister:=$80;
      SeekTrack:=true;
      if not(dsk[FDCCurrDrv].abierto) then st0:=st0 or $48
        else seek_track(0);
      ExecCmdPhase:=FALSE;
      end;
     8:begin // Sense Interrupt
      FDCResPointer:=0;
      st0:=st0 and $f8;
      if SeekTrack then begin
        st0:=st0 or $20;
        FDCResCounter:=2;
        SeekTrack:=FALSE;
        FDCResult[1]:=dsk[FDCCurrDrv].track_actual;
        FDCResult[0]:=st0;
      end else begin
        st0:=$80;
        FDCResCounter:=1;
        FDCResult[0]:=st0;
      end;
      StatusRegister:=$d0;
      ExecCmdPhase:=FALSE;
      ResultPhase:=TRUE;
      end;
     10:begin // read ID of next sector
      st0:=0;
      st1:=0;
      st2:=0;
      fdc_get_drive;
      if dsk[FDCCurrDrv].sector_actual>dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].number_sector then begin
        if not(dsk[FDCCurrDrv].abierto) then st0:=$48
          else st0:=0;
        getres7;
        FDCResult[3]:=dsk[FDCCurrDrv].track_actual;
        FDCResult[4]:=0;
        FDCResult[5]:=0;
        FDCResult[6]:=0;
      end else begin
          if (dsk[FDCCurrDrv].sector_actual+1)>dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].number_sector then begin
            dsk[FDCCurrDrv].sector_actual:=0;
            getres7;
          end else begin
            getres7;
            inc(dsk[FDCCurrDrv].sector_actual);
          end;
        end;
        end;
     15:begin // SEEK
      fdc_get_drive;
      StatusRegister:=$80;
      SeekTrack:=TRUE;
      //st2:=st2 and $fd;
      st0:=$20;
      st1:=0;
      st2:=0;
      if not(dsk[FDCCurrDrv].abierto) then st0:=st0 or $48
        else seek_track(FDCCommand[2]);
      ExecCmdPhase:=FALSE;
      end;
      else MessageDlg('FDC765 Instruccion no implementada: '+inttostr(FDCCommand[0]), mtInformation,[mbOk], 0);
   end;
end;

function read_data_stop:boolean;
begin
read_data_stop:=false;
if ((FDCCommand[0] and $20)=0) then begin
		if ((FDCCommand[0] and $1f)=$06) then begin
			if ((dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].status2 and $40)<>0) then begin
				st2:=st2 or $40; //NEC765_ST2_CONTROL_MARK;
        read_data_stop:=true;
			end;
		end else begin
		if ((FDCCommand[0] and $1f)=$0c) then begin
			if ((dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].status2 and $40)=0) then begin
				st2:=st2 or $40; //NEC765_ST2_CONTROL_MARK;
        read_data_stop:=true;
			end;
    end;
	end;
end;
if ((dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].sector[dsk[FDCCurrDrv].sector_actual].status1 and $20)<>0) then begin
  st1:=st1 or $20;
  read_data_stop:=true;
end;
end;

function FDCExecReadCommand:byte;
var
  ret:pbyte;
begin
  case (FDCCommand[0] and $1f) of
     2:begin
      ret:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[FDCCurrDrv].track_actual].data;
      if ret=nil then begin
        st0:=$40+$80;
        st1:=0+$20;
        st2:=$1;
        GetRes7;
        exit;
      end;
      inc(ret,FDCdataPointer);
      FDCExecReadCommand:=ret^;
      inc(FDCDataPointer);
      inc(FDCCounter);
      if (FDCCounter=FDCDataLength) then begin
        if dsk[FDCCurrDrv].sector_read_track=FDCCommand[6]-1 then begin
            st1:=st1 or $80;
            GetRes7;
            mostrar_disco:=false;
            form1.StatusBar1.Refresh;
        end else begin
            inc(dsk[FDCCurrDrv].sector_read_track);
            read_track;
        end;
       end;
      end;
     6,12:begin
          ret:=dsk[FDCCurrDrv].Tracks[dsk[FDCCurrDrv].cara_actual,dsk[fdccurrdrv].track_actual].data;
          if ret=nil then begin
            st0:=$40+$80;
            st1:=0+$20;
            st2:=$1;
            GetRes7;
            exit;
          end;
          inc(ret,fdcdatapointer);
          //La proteccion SpeedLock+3 consiste en leer dos veces el primer byte
          //del sector 2 del track 2, la primera vez da un valor (el bueno)
          //las siguientes veces lee un valor distinto.
          FDCExecReadCommand:=ret^;
          inc(FDCDataPointer);
          inc(FDCCounter);
          if (FDCCounter=FDCDataLength) then begin
            if ((FDCCommand[4]=FDCCommand[6]) or read_data_stop) then begin
              st0:=st0 or $40;
              GetRes7;
            end else begin
              inc(FDCCommand[4]);
              read_sector;
              exit;
            end;
            mostrar_disco:=false;
            form1.StatusBar1.Refresh;
          end;
      end;
   end;
 end;

function FDCGetResult:byte;
var
  ret:byte;
begin
  ret:=FDCResult[FDCResPointer];
  FDCResPointer:= FDCResPointer + 1;
  if (FDCResPointer=FDCResCounter)  then begin
    StatusRegister:=$80;
    ResultPhase:=FALSE;
    fillchar(FDCResult[0],7,0);
    fillchar(FDCCommand[0],9,0);
  end;
  FDCGetResult:=ret;
end;

procedure ResetFDC;
begin
    FloppyMotor:=0;
    FDCPointer:=0;
    ExecCmdPhase:=false;
    ResultPhase:=false;
    StatusRegister:=$80;
    fillchar(FDCCommand[0],9,0);
    fillchar(FDCResult[0],7,0);
    SeekTrack:=FALSE;
    mostrar_disco:=false;
    form1.StatusBar1.Refresh;
    st0:=0;
    st1:=0;
    st2:=0;
    st3:=0;
    FDCCmdPointer:=0;
    FDCResPointer:=0;
    FDCResCounter:=0;
    FDCDataPointer:=0;
    FDCDataLength:=0;
    FDCCounter:=0;
    Contador_status:=0;
    contador_read_status:=0;
end;

procedure WriteFDCData(value:byte);
begin
contador_status:=0;
if (not(ExecCmdPhase) or not(ResultPhase)) then begin
  if (FDCPointer=0) then begin
    FDCCommand[0]:=Value;
    FDCPointer:=FDCPointer+1;
    StatusRegister:=StatusRegister or $10;
  end else if (FDCPointer<bytes_in_cmd[FDCCommand[0] and $1f]) then begin
    FDCCommand[FDCPointer]:=Value;
    FDCPointer:=FDCPointer+1;
  end;
  if (FDCPointer=bytes_in_cmd[FDCCommand[0] and $1f])  then begin
    FDCPointer:=0;
    StatusRegister:=StatusRegister or $20;
    FDCExecWriteCommand;
  end;
end else FDCExecWriteCommand;
end;

function ReadFDCData:byte;
begin
  contador_status:=0;
  if ExecCmdPhase then begin
    ReadFDCData:= FDCExecReadCommand;
    exit;
  end;
  if ResultPhase then begin
    ReadFDCData:= FDCGetResult;
    exit;
  end;
  ReadFDCData:=0;
end;

function ReadFDCStatus:byte;
begin
//Aqui controlo un time out, si no quiere mas datos pues corto
//Falta por implementar el reloj!!
contador_status:=contador_status+1;
if contador_status>$10 then begin
  if seektrack then begin
    contador_read_status:=contador_read_status+1;
    if contador_read_status>$20 then begin
      StatusRegister:=$80;
      if contador_read_status>$40 then contador_read_status:=0;
    end else StatusRegister:=$50;
    SeekTrack:=FALSE;
  end else begin
    StatusRegister:=$F0;
    st0:=(st0 and $3f) or $40;
    st1:=st1 or $10;
    seektrack:=true;
  end;
  FDCPointer:=0;
  contador_status:=0;
  mostrar_disco:=false;
  form1.StatusBar1.Refresh;
end;
ReadFDCStatus:=StatusRegister;
end;

function InsertDisk(DrvNum:byte;longi_ini:dword;datos:pbyte):boolean;
var
  puntero,sp3,ptemp,ptemp2,ptemp3:pbyte;
  h:word;
  cadena,cadena2:string;
  longi:dword;
  estandar,hay_multi,sp3_presente:boolean;
  posicion,cont:word;
  cara,track,f:byte;
begin
   if datos=nil then exit;
   clear_disk(drvnum);
   puntero:=datos;
   longi:=0;
   hay_multi:=false;
   dsk[DrvNum].protegido:=false;
   //Disk Header
   for h:=0 to 7 do begin
       cadena:=cadena+char(puntero^);
       inc(puntero);inc(longi);
   end;
   estandar:=(cadena='MV - CPC');
   dsk[DrvNum].extended:=not(estandar);
   if ((cadena='EXTENDED') or estandar) then begin
    inc(puntero,40);inc(longi,40);
    dsk[drvnum].DiskHeader.nbof_tracks:=puntero^;
    inc(puntero);inc(longi);
    dsk[drvnum].DiskHeader.nbof_heads:=puntero^;
    inc(puntero,3);inc(longi,3);
    copymemory(addr(dsk[DrvNum].DiskHeader.track_size_table[0]),puntero,204);
    inc(puntero,204);inc(longi,204);
    //Disk Tracks
    cadena:=char(puntero^);
    inc(puntero);inc(longi);
    cadena2:=char(puntero^);
    if ((cadena<>'T') or (cadena2<>'r')) then exit;
    while longi<longi_ini do begin
      if longi>longi_ini then break;
      cadena:=char(puntero^);
      inc(puntero);inc(longi);
      for h:=0 to 7 do begin
        cadena:=cadena+char(puntero^);
        inc(puntero);inc(longi);
      end;
      if cadena<>'rack-Info' then begin
        clear_disk(drvnum);
        InsertDisk:=false;
        exit;
      end;
      inc(puntero,6);inc(longi,6);
      track:=puntero^;
      inc(puntero);inc(longi);
      cara:=puntero^;
      inc(puntero);inc(longi);
      dsk[DrvNum].Tracks[cara,track].track_number:=track;
      dsk[DrvNum].Tracks[cara,track].side_number:=cara;
      dsk[DrvNum].Tracks[cara,track].data_rate:=puntero^;
      inc(puntero);inc(longi);
      dsk[DrvNum].Tracks[cara,track].recording_mode:=puntero^;
      inc(puntero);inc(longi);
      dsk[DrvNum].Tracks[cara,track].sector_size:=puntero^;
      inc(puntero);inc(longi);
      dsk[DrvNum].Tracks[cara,track].number_sector:=puntero^;
      inc(puntero);inc(longi);
      dsk[DrvNum].Tracks[cara,track].GAP3:=puntero^;
      inc(puntero,2);inc(longi,2);
      posicion:=0;
      if dsk[drvnum].Tracks[cara,track].number_sector<>0 then begin
        for h:=0 to dsk[drvnum].Tracks[cara,track].number_sector-1 do begin
          dsk[drvnum].Tracks[cara,track].sector[h].track:=puntero^;
          inc(puntero);inc(longi);
          dsk[drvnum].Tracks[cara,track].sector[h].head:=puntero^;
          inc(puntero);inc(longi);
          dsk[drvnum].Tracks[cara,track].sector[h].sector:=puntero^;
          inc(puntero);inc(longi);
          dsk[drvnum].Tracks[cara,track].sector[h].sector_size:=puntero^;
          inc(puntero);inc(longi);
          dsk[drvnum].Tracks[cara,track].sector[h].status1:=puntero^;
          inc(puntero);inc(longi);
          dsk[drvnum].Tracks[cara,track].sector[h].status2:=puntero^;
          inc(puntero);inc(longi);
          if not(estandar) then begin
            dsk[drvnum].Tracks[cara,track].sector[h].data_length:=puntero^*256;
            inc(puntero);inc(longi);
            dsk[drvnum].Tracks[cara,track].sector[h].data_length:=dsk[drvnum].Tracks[cara,track].sector[h].data_length+puntero^;
            inc(puntero);inc(longi);
            dsk[drvnum].Tracks[cara,track].sector[h].data_length:=dsk[drvnum].Tracks[cara,track].sector[h].data_length*256;
          end else begin
            dsk[drvnum].Tracks[cara,track].sector[h].data_length:=1 shl (dsk[drvnum].Tracks[cara,track].sector[h].sector_size+7);
            inc(puntero,2);inc(longi,2);
          end;
          //Sectores de 32K
          if dsk[drvnum].Tracks[cara,track].sector[h].sector_size=8 then begin
            dsk[drvnum].Tracks[cara,track].sector[h].data_length:=32767;
          end;
          dsk[drvnum].Tracks[cara,track].sector[h].posicion_data:=posicion;
          inc(posicion,dsk[drvnum].Tracks[cara,track].sector[h].data_length);
          //Weak sectors
          dsk[drvnum].Tracks[cara,track].sector[h].cont_multi:=dsk[drvnum].Tracks[cara,track].sector[h].data_length div (1 shl (dsk[drvnum].Tracks[cara,track].sector[h].sector_size+7));
          if (dsk[drvnum].Tracks[cara,track].sector[h].cont_multi>1) then begin
            dsk[drvnum].Tracks[cara,track].sector[h].multi:=true;
            hay_multi:=true;
            dsk[drvnum].Tracks[cara,track].sector[h].pos_cont_multi:=0;
          end;
        end;
      end;
        inc(puntero,8*(29-dsk[drvnum].Tracks[cara,track].number_sector));
        inc(longi,8*(29-dsk[drvnum].Tracks[cara,track].number_sector));
        if dsk[DrvNum].DiskHeader.track_size_table[cara,track]<>0 then begin
          dsk[drvnum].Tracks[cara,track].track_lenght:=256*(dsk[DrvNum].DiskHeader.track_size_table[cara,track]-1);
        end else begin
          dsk[drvnum].Tracks[cara,track].track_lenght:=0;
          if dsk[drvnum].Tracks[cara,track].number_sector<>0 then begin
            for h:=0 to dsk[drvnum].Tracks[cara,track].number_sector-1 do begin
              dsk[drvnum].Tracks[cara,track].sector[h].posicion_data:=dsk[drvnum].Tracks[cara,track].track_lenght;
              inc(dsk[drvnum].Tracks[cara,track].track_lenght,dsk[drvnum].Tracks[cara,track].sector[h].data_length)
            end;
          end;
        end;
        getmem(dsk[drvnum].Tracks[cara,track].data,dsk[drvnum].Tracks[cara,track].track_lenght);
        copymemory(dsk[drvnum].Tracks[cara,track].data,puntero,dsk[drvnum].Tracks[cara,track].track_lenght);
        inc(puntero,dsk[drvnum].Tracks[cara,track].track_lenght);
        inc(longi,dsk[drvnum].Tracks[cara,track].track_lenght);
        while ((cadena<>'T') or (cadena2<>'r')) do begin
          cadena:=char(puntero^);
          inc(puntero);
          inc(longi);
          cadena2:=char(puntero^);
          if ((cadena='O') and (cadena2='f')) then begin
            longi:=longi_ini;
            break;
          end;
          if longi>longi_ini then begin
            dec(puntero);
            dec(longi);
            break;
          end;
        end;
    end;
   end else begin
       InsertDisk:=false;
       exit;
   end;
   //Comprobar SpeedLock +3
   if (main_vars.tipo_maquina=2) then begin
    sp3:=dsk[drvnum].Tracks[cara,0].data;
    cadena2:='SPEEDLOCK';
    cadena:='';
    for h:=0 to 511 do begin
      cadena:=cadena+char(sp3^);
      inc(sp3);
    end;
    sp3_presente:=pos(cadena2,cadena)<>0;
    if ((sp3_presente) and not(hay_multi)) then begin
      main_vars.mensaje_general:='SpeedLock +3 Simulated';
      dsk[drvnum].Tracks[cara,0].sector[1].multi:=true;
      dsk[drvnum].Tracks[cara,0].sector[1].cont_multi:=3;
      dsk[drvnum].Tracks[cara,0].sector[1].pos_cont_multi:=0;
      //Ahora reago todos los datos
      getmem(ptemp3,dsk[drvnum].Tracks[cara,0].track_lenght);
      ptemp:=ptemp3;
      //Guardo los viejos
      copymemory(ptemp,dsk[drvnum].Tracks[cara,0].data,dsk[drvnum].Tracks[cara,0].track_lenght);
      //Libero los datos antiguos
      freemem(dsk[drvnum].Tracks[cara,0].data);
      dsk[drvnum].Tracks[cara,0].data:=nil;
      //Creo los nuevos
      getmem(dsk[drvnum].Tracks[cara,0].data,dsk[drvnum].Tracks[cara,0].track_lenght+((1 shl (dsk[drvnum].Tracks[cara,0].sector[2].sector_size+7))*2));
      //Muevo el primer sector
      cont:=0;
      ptemp2:=dsk[drvnum].Tracks[cara,0].data;
      copymemory(ptemp2,ptemp,1 shl (dsk[drvnum].Tracks[cara,0].sector[0].sector_size+7));
      inc(ptemp,1 shl (dsk[drvnum].Tracks[cara,0].sector[0].sector_size+7));
      inc(ptemp2,1 shl (dsk[drvnum].Tracks[cara,0].sector[0].sector_size+7));
      inc(cont,1 shl (dsk[drvnum].Tracks[cara,0].sector[0].sector_size+7));
      //Arreglo el segundo...
      copymemory(ptemp2,ptemp,1 shl (dsk[drvnum].Tracks[cara,0].sector[1].sector_size+7));
      inc(ptemp2,1 shl (dsk[drvnum].Tracks[cara,0].sector[1].sector_size+7));
      inc(cont,1 shl (dsk[drvnum].Tracks[cara,0].sector[1].sector_size+7));
      for f:=0 to 1 do begin
        copymemory(ptemp2,ptemp,256);
        inc(ptemp2,256);
        for h:=0 to 255 do begin
          ptemp2^:=random(256);
          inc(ptemp2);
        end;
        inc(cont,1 shl (dsk[drvnum].Tracks[cara,0].sector[1].sector_size+7));
      end;
      inc(ptemp,1 shl (dsk[drvnum].Tracks[cara,0].sector[1].sector_size+7));
      //Y los ultimos sectores arreglando la pos
      for f:=2 to (dsk[drvnum].Tracks[cara,0].number_sector-1) do begin
        dsk[drvnum].Tracks[cara,0].sector[f].posicion_data:=cont;
        copymemory(ptemp2,ptemp,1 shl (dsk[drvnum].Tracks[cara,0].sector[f].sector_size+7));
        inc(ptemp,1 shl (dsk[drvnum].Tracks[cara,0].sector[f].sector_size+7));
        inc(ptemp2,1 shl (dsk[drvnum].Tracks[cara,0].sector[f].sector_size+7));
        inc(cont,dsk[drvnum].Tracks[cara,0].sector[f].sector_size*256);
      end;
      freemem(ptemp3);
    end else main_vars.mensaje_general:='';
   end;
   dsk[drvnum].abierto:=true;
   InsertDisk:=true;
end;

procedure clear_disk(drvnum:byte);
var
  f,h,g:byte;
begin
  main_vars.mensaje_general:='';
  if not(dsk[drvnum].abierto) then exit;
  for g:=0 to 1 do begin
   for f:=0 to dsk[drvnum].DiskHeader.nbof_tracks do begin
    dsk[drvnum].Tracks[g,f].track_number:=0;
    dsk[drvnum].Tracks[g,f].side_number:=0;
    dsk[drvnum].Tracks[g,f].data_rate:=0;
    dsk[drvnum].Tracks[g,f].sector_size:=0;
    dsk[drvnum].Tracks[g,f].GAP3:=0;
    dsk[drvnum].Tracks[g,f].track_lenght:=0;
    if dsk[drvnum].Tracks[g,f].data<>nil then begin
      freemem(dsk[drvnum].Tracks[g,f].data);
      dsk[drvnum].Tracks[g,f].data:=nil;
    end;
    for h:=0 to dsk[drvnum].Tracks[g,f].number_sector do begin
      dsk[drvnum].Tracks[g,f].sector[h].track:=0;
      dsk[drvnum].Tracks[g,f].sector[h].head:=0;
      dsk[drvnum].Tracks[g,f].sector[h].sector_size:=0;
      dsk[drvnum].Tracks[g,f].sector[h].status1:=0;
      dsk[drvnum].Tracks[g,f].sector[h].status2:=0;
      dsk[drvnum].Tracks[g,f].sector[h].data_length:=0;
      dsk[drvnum].Tracks[g,f].sector[h].posicion_data:=0;
      dsk[drvnum].Tracks[g,f].sector[h].sector:=0;
    end;
    dsk[drvnum].Tracks[g,f].number_sector:=0;
   end;
  end;
    dsk[drvnum].abierto:=false;
    dsk[drvnum].DiskHeader.nbof_tracks:=0;
    dsk[drvnum].DiskHeader.nbof_heads:=0;
    dsk[drvnum].track_actual:=0;
    dsk[drvnum].cara_actual:=0;
    dsk[drvnum].sector_actual:=0;
    fillchar(dsk[drvnum].DiskHeader.track_size_table,408,0);
end;

end.


