﻿unit gfx_engine;

{$ifdef fpc}{$asmmode intel}{$endif}

interface
uses sdl,{$IFDEF windows}windows,{$ENDIF}
     pal_engine;

type
  tipo_sprites=record
    pos_planos:array[0..7] of dword;
    bit_pixel:byte;
    long_sprites:dword;
    banks:byte;
  end;
  gfx_tipo=record
    x,y:byte;
    datos:pbyte;
    colores:array[0..max_colores-1] of word;
    trans:array[0..31] of boolean;
    trans_alt:array[0..4,0..31] of boolean;
    buffer:array[0..$7fff] of boolean;
    color_buffer:array[0..$ff] of boolean;
    elements:dword;
  end;
  pgfx=^gfx_tipo;

var
  gfx:array[0..5] of gfx_tipo;
  des_gfx:tipo_sprites;
  buffer_sprites:array[0..$1fff] of byte;
  buffer_sprites_w:array[0..$fff] of word;

//GFX
procedure init_gfx(num,x_size,y_size:byte;num_elements:dword);
procedure convert_gfx(ngfx:pgfx;increment:dword;SpriteRom:pbyte;cx,cy:pdword;rot90,rol90:boolean);
//GFX put
procedure put_gfx(pos_x,pos_y,nchar,color:word;screen,ngfx:byte);
procedure put_gfx_mask(pos_x,pos_y,nchar,color:word;screen,ngfx,trans,mask:byte);
procedure put_gfx_mask_flip(pos_x,pos_y,nchar,color:word;screen,ngfx,trans,mask:byte;flipx,flipy:boolean);
procedure put_gfx_trans(pos_x,pos_y,nchar,color:word;screen,ngfx:byte);
procedure put_gfx_trans_alt(pos_x,pos_y,nchar,color:word;screen,ngfx,index:byte);
procedure put_gfx_block_trans(pos_x,pos_y:word;screen,size_x,size_y:byte);
procedure put_gfx_block(pos_x,pos_y:word;screen,size_x,size_y:byte;color:word);
procedure put_gfx_flip(pos_x,pos_y,nchar,color:word;screen,ngfx:byte;flipx,flipy:boolean);
procedure put_gfx_trans_flip(pos_x,pos_y,nchar:dword;color:word;screen,ngfx:byte;flipx,flipy:boolean);
procedure put_gfx_trans_flip_alt(pos_x,pos_y,nchar:dword;color:word;screen,ngfx:byte;flipx,flipy:boolean;trans_index:byte);
//Sprites put
procedure put_gfx_sprite(nchar:dword;color:word;flipx,flipy:boolean;ngfx:byte);
procedure put_gfx_sprite_diff(nchar,color:word;flipx,flipy:boolean;ngfx:byte;x_diff,y_diff:word);
procedure put_gfx_sprite_mask(nchar,color:word;flipx,flipy:boolean;ngfx:byte;trans,mask:word);
procedure put_gfx_sprite_mask_diff(nchar,color:word;flipx,flipy:boolean;ngfx,trans,mask,x_diff,y_diff:byte);
//Sprites Update
procedure actualiza_gfx_sprite(pos_x,pos_y:word;dest,ngfx:byte);
procedure actualiza_gfx_sprite_over(pos_x,pos_y:word;dest,ngfx,src_over:byte;scr_x,scr_y:word);
procedure actualiza_gfx_sprite_size(pos_x,pos_y:word;dest:byte;x_size,y_size:word);
procedure actualiza_gfx_sprite_size_pos(pos_x,pos_y:word;dest:byte;x_size,y_size,ipos_x,ipos_y:word);
//Scroll
procedure scroll_x_y(porigen,pdestino:byte;scroll_x,scroll_y:word);
procedure scroll__x(porigen,pdestino:byte;scroll_x:word);
procedure scroll__x_part(porigen,pdestino:byte;scroll_x,scroll_y:word;orgy,desty:word);
procedure scroll__y(porigen,pdestino:byte;scroll_y:word);
procedure scroll__y_part(porigen,pdestino:byte;scroll_y,scroll_x:word;orgx,destx:word);
//Basic draw functions
procedure putpixel(x,y:word;cantidad:dword;pixel:pword;sitio:byte);
procedure single_line(x,y,color,longitud:word;pant:byte);
procedure draw_line(x0,y0,x1,y1:integer;color:word;pant:byte);
//Screen functions
procedure fill_full_screen(screen:byte;color:word);
//Misc
procedure fillword(dest:pword;cantidad:cardinal;valor:word);

implementation
uses main_engine;

//GFX
procedure init_gfx(num,x_size,y_size:byte;num_elements:dword);
var
  f:word;
begin
  gfx[num].x:=x_size;
  gfx[num].y:=y_size;
  gfx[num].elements:=num_elements;
  fillchar(gfx[num].buffer,$8000,1);
  fillchar(gfx[num].color_buffer,$100,1);
  fillchar(gfx[num].trans[0],$20,0);
  for f:=0 to 4 do fillchar(gfx[num].trans_alt[f],$20,0);
  for f:=0 to max_colores-1 do gfx[num].colores[f]:=f;
  getmem(gfx[num].datos,num_elements*x_size*y_size);
end;

function GetBit(bit_nbr:dword;buffer:pbyte):byte;inline;
var
  oct_nbr:dword;
  bit_n:byte;
  pos:pbyte;
begin
oct_nbr:=bit_nbr shr 3;
bit_n:=bit_nbr and 7;
pos:=buffer;
inc(pos,oct_nbr);
getbit:=((pos^ shr (7-bit_n)) and 1);
end;

procedure Rotatel(n:word;ngfx:pgfx;increment:dword);inline;
var
  x,y:byte;
  src,t:array[0..1023] of byte;
  pos:pbyte;
  long:word;
begin
long:=ngfx.x*ngfx.y;
pos:=ngfx.datos;
inc(pos,long*n+increment);
copymemory(@src[0],pos,long);
for y:=0 to (ngfx.y-1) do
  for x:=0 to (ngfx.x-1) do T[x*ngfx.x+y]:=src[((ngfx.x-1)-x)+y*ngfx.y];
copymemory(pos,@t[0],long);
end;

procedure Rotater(n:word;ngfx:pgfx;increment:dword);inline;
var
  x,y:byte;
  src,t:array[0..1023] of byte;
  pos:pbyte;
  long:word;
begin
long:=ngfx.x*ngfx.y;
pos:=ngfx.datos;
inc(pos,long*n+increment);
copymemory(@src[0],pos,long);
for y:=0 to (ngfx.y-1) do
  for x:=0 to (ngfx.x-1) do T[((ngfx.x-1)-x)+y*ngfx.y]:=src[x*ngfx.x+y];
copymemory(pos,@t[0],long);
end;

procedure convert_gfx(ngfx:pgfx;increment:dword;SpriteRom:pbyte;cx,cy:pdword;rot90,rol90:boolean);
var
  n,elements:dword;
  oct,b0,o,i,bit_pixel:byte;
  SpriteNbr,ind:dword;
  pos:pbyte;
  temp_cx,temp_cy:pdword;
begin
ind:=0;
temp_cx:=cx;
temp_cy:=cy;
if des_gfx.banks<>0 then elements:=(ngfx.elements div des_gfx.banks)-1
  else elements:=ngfx.elements-1;
for n:=0 to elements do begin
	SpriteNbr:=n*des_gfx.long_sprites;
  cy:=temp_cy;
	for o:=0 to (ngfx.y-1) do begin
    cx:=temp_cx;
		for i:=0 to (ngfx.x-1) do begin
     oct:=0;
     for bit_pixel:=0 to (des_gfx.bit_pixel-1) do begin
      b0:=GetBit(des_gfx.pos_planos[bit_pixel]+Cy^+Cx^+SpriteNbr,SpriteRom);
      oct:=oct or (b0 shl (des_gfx.bit_pixel-1-bit_pixel));
     end;
     pos:=ngfx.datos;
     inc(pos,ind+increment);
     pos^:=oct;
     ind:=ind+1;
     inc(cx);
    end;  //del i
    inc(cy);
  end; //del o
	if rot90 then Rotater(n,ngfx,increment);
  if rol90 then Rotatel(n,ngfx,increment);
end;
end;

//Scroll functions
procedure scroll_x_y(porigen,pdestino:byte;scroll_x,scroll_y:word);
var
  long_x,long_y:word;
begin
scroll_x:=scroll_x and p_final[porigen].scroll.mask_x;
scroll_y:=scroll_y and p_final[porigen].scroll.mask_y;
if ((scroll_x+p_final[porigen].scroll.max_x)>=p_final[porigen].scroll.long_x) then long_x:=p_final[porigen].scroll.max_x-((scroll_x+p_final[porigen].scroll.max_x)-(p_final[porigen].scroll.long_x))
  else long_x:=p_final[porigen].scroll.max_x;
if ((scroll_y+p_final[porigen].scroll.max_y)>=p_final[porigen].scroll.long_y) then long_y:=p_final[porigen].scroll.max_y-((scroll_y+p_final[porigen].scroll.max_y)-(p_final[porigen].scroll.long_y))
  else long_y:=p_final[porigen].scroll.max_y;
actualiza_trozo(scroll_x,scroll_y,long_x,long_y,porigen,0,0,long_x,long_y,pdestino);
if long_x<p_final[porigen].scroll.max_x then actualiza_trozo(0,scroll_y,p_final[porigen].scroll.max_x-long_x,long_y,porigen,long_x,0,p_final[porigen].scroll.max_x-long_x,long_y,pdestino);
if long_y<p_final[porigen].scroll.max_y then actualiza_trozo(scroll_x,0,long_x,p_final[porigen].scroll.max_y-long_y,porigen,0,long_y,long_x,p_final[porigen].scroll.max_y-long_y,pdestino);
if ((long_x<p_final[porigen].scroll.max_x) and (long_y<p_final[porigen].scroll.max_y)) then actualiza_trozo(0,0,p_final[porigen].scroll.max_x-long_x,p_final[porigen].scroll.max_y-long_y,porigen,long_x,long_y,p_final[porigen].scroll.max_x-long_x,p_final[porigen].scroll.max_y-long_y,pdestino);
end;

procedure scroll__x(porigen,pdestino:byte;scroll_x:word);
var
  long_x:word;
begin
scroll_x:=scroll_x and p_final[porigen].scroll.mask_x;
if ((scroll_x+p_final[porigen].scroll.max_x)>=p_final[porigen].scroll.long_x) then long_x:=p_final[porigen].scroll.max_x-((scroll_x+p_final[porigen].scroll.max_x)-(p_final[porigen].scroll.long_x))
  else long_x:=p_final[porigen].scroll.max_x;
actualiza_trozo(scroll_x,0,long_x,256,porigen,0,0,long_x,256,pdestino);
if long_x<p_final[porigen].scroll.max_x then actualiza_trozo(0,0,p_final[porigen].scroll.max_x-long_x,256,porigen,long_x,0,p_final[porigen].scroll.max_x-long_x,256,pdestino);
end;

procedure scroll__x_part(porigen,pdestino:byte;scroll_x,scroll_y:word;orgy,desty:word);
var
  long_x:word;
begin
scroll_x:=scroll_x and p_final[porigen].scroll.mask_x;
if ((scroll_x+p_final[porigen].scroll.max_x)>=p_final[porigen].scroll.long_x) then long_x:=p_final[porigen].scroll.max_x-((scroll_x+p_final[porigen].scroll.max_x)-(p_final[porigen].scroll.long_x))
  else long_x:=p_final[porigen].scroll.max_x;
actualiza_trozo(scroll_x,orgy+scroll_y,long_x,desty,porigen,0,orgy,long_x,desty,pdestino);
if long_x<p_final[porigen].scroll.max_x then actualiza_trozo(0,orgy+scroll_y,p_final[porigen].scroll.max_x-long_x,desty,porigen,long_x,orgy,p_final[porigen].scroll.max_x-long_x,desty,pdestino);
end;

procedure scroll__y(porigen,pdestino:byte;scroll_y:word);
var
  long_y:word;
begin
scroll_y:=scroll_y and p_final[porigen].scroll.mask_y;
if ((scroll_y+p_final[porigen].scroll.max_y)>p_final[porigen].scroll.long_y) then long_y:=p_final[porigen].scroll.max_y-((scroll_y+p_final[porigen].scroll.max_y)-(p_final[porigen].scroll.long_y))
  else long_y:=p_final[porigen].scroll.max_y;
actualiza_trozo(0,scroll_y,256,long_y,porigen,0,0,256,long_y,pdestino);
if long_y<p_final[porigen].scroll.max_y then actualiza_trozo(0,0,256,p_final[porigen].scroll.max_y-long_y,porigen,0,long_y,256,p_final[porigen].scroll.max_y-long_y,pdestino);
end;

procedure scroll__y_part(porigen,pdestino:byte;scroll_y,scroll_x:word;orgx,destx:word);
var
  long_y:word;
begin
scroll_y:=scroll_y and p_final[porigen].scroll.mask_y;
if ((scroll_y+p_final[porigen].scroll.max_y)>p_final[porigen].scroll.long_y) then long_y:=p_final[porigen].scroll.max_y-((scroll_y+p_final[porigen].scroll.max_y)-(p_final[porigen].scroll.long_y))
  else long_y:=p_final[porigen].scroll.max_y;
actualiza_trozo(orgx+scroll_x,scroll_y,destx,long_y,porigen,orgx,0,destx,long_y,pdestino);
if long_y<p_final[porigen].scroll.max_y then actualiza_trozo(orgx+scroll_x,0,destx,p_final[porigen].scroll.max_y-long_y,porigen,orgx,long_y,destx,p_final[porigen].scroll.max_y-long_y,pdestino);
end;

//put pixel especial interno solo para los gfx...
procedure putpixel_gfx_int(x,y,cantidad:word;sitio:byte);inline;
var
   punt:pword;
begin
punt:=pantalla[sitio].pixels;
inc(punt,((y*pantalla[sitio].pitch) shr 1)+x);
copymemory(punt,punbuf,cantidad shl 1);
end;

procedure put_gfx(pos_x,pos_y,nchar,color:word;screen,ngfx:byte);
var
  x,y:byte;
  temp:pword;
  pos:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
for y:=0 to (gfx[ngfx].y-1) do begin
  temp:=punbuf;
  for x:=0 to (gfx[ngfx].x-1) do begin
    temp^:=paleta[gfx[ngfx].colores[pos^+color]];
    inc(pos);
    inc(temp);
  end;
  putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
end;
end;

procedure put_gfx_trans(pos_x,pos_y,nchar,color:word;screen,ngfx:byte);
var
  x,y:byte;
  temp:pword;
  pos:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
for y:=0 to (gfx[ngfx].y-1) do begin
  temp:=punbuf;
  for x:=0 to (gfx[ngfx].x-1) do begin
    if not(gfx[ngfx].trans[pos^]) then temp^:=paleta[gfx[ngfx].colores[pos^+color]]
      else temp^:=paleta[max_colores];
    inc(pos);
    inc(temp);
  end;
  putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
end;
end;

procedure put_gfx_trans_alt(pos_x,pos_y,nchar,color:word;screen,ngfx,index:byte);
var
  x,y:byte;
  temp:pword;
  pos:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
for y:=0 to (gfx[ngfx].y-1) do begin
  temp:=punbuf;
  for x:=0 to (gfx[ngfx].x-1) do begin
    if not(gfx[ngfx].trans_alt[index][pos^]) then temp^:=paleta[gfx[ngfx].colores[pos^+color]]
      else temp^:=paleta[max_colores];
    inc(pos);
    inc(temp);
  end;
  putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
end;
end;

{$IFDEF CPU64}
procedure fillword(dest:pword;cantidad:cardinal;valor:word);
var
  f:cardinal;
  ptemp:pword;
begin
  if cantidad=0 then exit;
  ptemp:=dest;
  for f:=1 to cantidad do begin
      ptemp^:=valor;
      inc(ptemp);
  end;
end;
{$ELSE}
procedure fillword(dest:pword;cantidad:cardinal;valor:word);
asm
    cmp cantidad,0
    je @salir
    push edi
    push eax
    push ecx
    mov edi,eax   //poner destino
    mov ax,valor            // Get the fill word.
    mov ecx,cantidad    // Get the size.
    cld                     // Clear the direction flag.
    rep stosw
    pop ecx
    pop eax
    pop edi
  @salir:
end;
{$ENDIF}

procedure put_gfx_block_trans(pos_x,pos_y:word;screen,size_x,size_y:byte);inline;
var
  y:byte;
begin
fillword(pointer(punbuf),size_x,paleta[max_colores]);
for y:=0 to (size_y-1) do putpixel_gfx_int(pos_x,pos_y+y,size_x,screen);
end;

procedure put_gfx_block(pos_x,pos_y:word;screen,size_x,size_y:byte;color:word);inline;
var
  y:byte;
begin
fillword(punbuf,size_x,paleta[color]);
for y:=0 to (size_y-1) do putpixel_gfx_int(pos_x,pos_y+y,size_x,screen);
end;

procedure put_gfx_mask(pos_x,pos_y,nchar,color:word;screen,ngfx,trans,mask:byte);
var
  x,y:byte;
  temp:pword;
  pos:pbyte;
  punto:word;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
for y:=0 to (gfx[ngfx].y-1) do begin
  temp:=punbuf;
  for x:=0 to (gfx[ngfx].x-1) do begin
    punto:=gfx[ngfx].colores[pos^+color];
    if (punto and mask)<>trans then temp^:=paleta[punto]
      else temp^:=paleta[max_colores];
    inc(pos);
    inc(temp);
  end;
  putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
end;
end;

procedure put_gfx_mask_flip(pos_x,pos_y,nchar,color:word;screen,ngfx,trans,mask:byte;flipx,flipy:boolean);
var
  x,y:byte;
  temp:pword;
  pos,post:pbyte;
  punto,def_y:word;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    post:=pos;
    inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
    temp:=punbuf;
    for x:=0 to (gfx[ngfx].x-1) do begin
      punto:=gfx[ngfx].colores[post^+color];
      if (punto and mask)<>trans then temp^:=paleta[punto]
        else temp^:=paleta[max_colores];
      dec(post);
      inc(temp);
    end;
    if flipy then def_y:=pos_y+(gfx[ngfx].y-1)-y
      else def_y:=pos_y+y;
    putpixel_gfx_int(pos_x,def_y,gfx[ngfx].x,screen);
  end;
end else begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    temp:=punbuf;
    for x:=0 to (gfx[ngfx].x-1) do begin
      punto:=gfx[ngfx].colores[pos^+color];
      if (punto and mask)<>trans then temp^:=paleta[punto]
        else temp^:=paleta[max_colores];
      inc(pos);
      inc(temp);
    end;
    if flipy then def_y:=pos_y+(gfx[ngfx].y-1)-y
      else def_y:=pos_y+y;
    putpixel_gfx_int(pos_x,def_y,gfx[ngfx].x,screen);
  end;
end;
end;

procedure put_gfx_flip(pos_x,pos_y,nchar,color:word;screen,ngfx:byte;flipx,flipy:boolean);
var
  x,y:byte;
  temp:pword;
  pos,post:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  if flipy then begin
    for y:=0 to (gfx[ngfx].y-1) do begin
      post:=pos;
      inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        temp^:=paleta[gfx[ngfx].colores[post^+color]];
        dec(post);
        inc(temp);
      end;
      putpixel(pos_x,pos_y+(gfx[ngfx].y-1)-y,gfx[ngfx].x,punbuf,screen);
    end;
  end else begin
    for y:=0 to (gfx[ngfx].y-1) do begin
      post:=pos;
      inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
      temp:=punbuf;
      for x:=(gfx[ngfx].x-1) downto 0 do begin
        temp^:=paleta[gfx[ngfx].colores[post^+color]];
        dec(post);
        inc(temp);
      end;
      putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
    end;
  end;
end else begin
  if flipy then begin
    for y:=(gfx[ngfx].y-1) downto 0 do begin
       temp:=punbuf;
       for x:=0 to (gfx[ngfx].x-1) do begin
         temp^:=paleta[gfx[ngfx].colores[pos^+color]];
         inc(pos);
         inc(temp);
       end;
       putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
    end;
  end else begin
    for y:=0 to (gfx[ngfx].y-1) do begin
       temp:=punbuf;
       for x:=0 to (gfx[ngfx].x-1) do begin
         temp^:=paleta[gfx[ngfx].colores[pos^+color]];
         inc(pos);
         inc(temp);
       end;
       putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
    end;
  end;
end;
end;

procedure put_gfx_trans_flip(pos_x,pos_y,nchar:dword;color:word;screen,ngfx:byte;flipx,flipy:boolean);
var
  x,y:byte;
  temp:pword;
  pos,post:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  if flipy then begin
    for y:=0 to (gfx[ngfx].y-1) do begin
      post:=pos;
      inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans[post^]) then temp^:=paleta[gfx[ngfx].colores[post^+color]]
          else temp^:=paleta[max_colores];
        dec(post);
        inc(temp);
      end;
      putpixel_gfx_int(pos_x,pos_y+(gfx[ngfx].y-1)-y,gfx[ngfx].x,screen);
    end;
  end else begin
    for y:=0 to (gfx[ngfx].y-1) do begin
      post:=pos;
      inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans[post^]) then temp^:=paleta[gfx[ngfx].colores[post^+color]]
          else temp^:=paleta[max_colores];
        dec(post);
        inc(temp);
      end;
      putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
    end;
  end;
end else begin
  if flipy then begin
    for y:=(gfx[ngfx].y-1) downto 0 do begin
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans[pos^]) then temp^:=paleta[gfx[ngfx].colores[pos^+color]]
          else temp^:=paleta[max_colores];
        inc(pos);
        inc(temp);
      end;
      putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
    end;
  end else begin
    for y:=0 to (gfx[ngfx].y-1) do begin
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans[pos^]) then temp^:=paleta[gfx[ngfx].colores[pos^+color]]
          else temp^:=paleta[max_colores];
        inc(pos);
        inc(temp);
      end;
      putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
    end;
  end;
end;
end;

procedure put_gfx_trans_flip_alt(pos_x,pos_y,nchar:dword;color:word;screen,ngfx:byte;flipx,flipy:boolean;trans_index:byte);
var
  x,y:byte;
  temp:pword;
  pos,post:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  if flipy then begin
    for y:=0 to (gfx[ngfx].y-1) do begin
      post:=pos;
      inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans_alt[trans_index][post^]) then temp^:=paleta[gfx[ngfx].colores[post^+color]]
          else temp^:=paleta[max_colores];
        dec(post);
        inc(temp);
      end;
      putpixel_gfx_int(pos_x,pos_y+(gfx[ngfx].y-1)-y,gfx[ngfx].x,screen);
    end;
  end else begin
    for y:=0 to (gfx[ngfx].y-1) do begin
      post:=pos;
      inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans_alt[trans_index][post^]) then temp^:=paleta[gfx[ngfx].colores[post^+color]]
          else temp^:=paleta[max_colores];
        dec(post);
        inc(temp);
      end;
      putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
    end;
  end;
end else begin
  if flipy then begin
    for y:=(gfx[ngfx].y-1) downto 0 do begin
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans_alt[trans_index][pos^]) then temp^:=paleta[gfx[ngfx].colores[pos^+color]]
          else temp^:=paleta[max_colores];
        inc(pos);
        inc(temp);
      end;
      putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
    end;
  end else begin
    for y:=0 to (gfx[ngfx].y-1) do begin
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans_alt[trans_index][pos^]) then temp^:=paleta[gfx[ngfx].colores[pos^+color]]
          else temp^:=paleta[max_colores];
        inc(pos);
        inc(temp);
      end;
      putpixel_gfx_int(pos_x,pos_y+y,gfx[ngfx].x,screen);
    end;
  end;
end;
end;

procedure put_gfx_sprite(nchar:dword;color:word;flipx,flipy:boolean;ngfx:byte);
var
        x,y:byte;
        temp:pword;
        pos,post:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  if flipy then begin
    for y:=0 to (gfx[ngfx].y-1) do begin
      post:=pos;
      inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans[post^]) then temp^:=paleta[gfx[ngfx].colores[post^+color]]
          else temp^:=paleta[max_colores];
        dec(post);
        inc(temp);
      end;
      putpixel_gfx_int(0,(gfx[ngfx].y-1)-y,gfx[ngfx].x,pant_sprites);
    end;
  end else begin
    for y:=0 to (gfx[ngfx].y-1) do begin
      post:=pos;
      inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans[post^]) then temp^:=paleta[gfx[ngfx].colores[post^+color]]
          else temp^:=paleta[max_colores];
        dec(post);
        inc(temp);
      end;
      putpixel_gfx_int(0,y,gfx[ngfx].x,pant_sprites);
    end;
  end;
end else begin
  if flipy then begin
    for y:=(gfx[ngfx].y-1) downto 0 do begin
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans[pos^]) then temp^:=paleta[gfx[ngfx].colores[pos^+color]]
          else temp^:=paleta[max_colores];
        inc(temp);
        inc(pos);
      end;
      putpixel_gfx_int(0,y,gfx[ngfx].x,pant_sprites);
    end;
  end else begin
    for y:=0 to (gfx[ngfx].y-1) do begin
      temp:=punbuf;
      for x:=0 to (gfx[ngfx].x-1) do begin
        if not(gfx[ngfx].trans[pos^]) then temp^:=paleta[gfx[ngfx].colores[pos^+color]]
          else temp^:=paleta[max_colores];
        inc(temp);
        inc(pos);
      end;
      putpixel_gfx_int(0,y,gfx[ngfx].x,pant_sprites);
    end;
  end;
end;
end;

procedure put_gfx_sprite_diff(nchar,color:word;flipx,flipy:boolean;ngfx:byte;x_diff,y_diff:word);
var
        x,y:byte;
        temp:pword;
        pos,post:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    post:=pos;
    inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
    temp:=punbuf;
    for x:=(gfx[ngfx].x-1) downto 0 do begin
      if not(gfx[ngfx].trans[post^]) then temp^:=paleta[gfx[ngfx].colores[post^+color]]
        else temp^:=paleta[max_colores];
      dec(post);
      inc(temp);
    end;
    if flipy then
      putpixel(0+x_diff,((gfx[ngfx].y-1)-y)+y_diff,gfx[ngfx].x,punbuf,pant_sprites)
      else putpixel(0+x_diff,y+y_diff,gfx[ngfx].x,punbuf,pant_sprites);
  end;
end else begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    temp:=punbuf;
    for x:=0 to (gfx[ngfx].x-1) do begin
      if not(gfx[ngfx].trans[pos^]) then temp^:=paleta[gfx[ngfx].colores[pos^+color]]
        else temp^:=paleta[max_colores];
      inc(temp);
      inc(pos);
    end;
    if flipy then putpixel(0+x_diff,((gfx[ngfx].y-1)-y)+y_diff,gfx[ngfx].x,punbuf,pant_sprites)
      else putpixel(0+x_diff,y+y_diff,gfx[ngfx].x,punbuf,pant_sprites);
  end;
end;
end;

procedure put_gfx_sprite_mask(nchar,color:word;flipx,flipy:boolean;ngfx:byte;trans,mask:word);
var
        x,y,punto:byte;
        temp:pword;
        pos,post:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    post:=pos;
    inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x-1);
    temp:=punbuf;
    for x:=(gfx[ngfx].x-1) downto 0 do begin
      punto:=gfx[ngfx].colores[post^+color];
      if (punto and mask)<>trans then temp^:=paleta[punto]
        else temp^:=paleta[max_colores];
      dec(post);
      inc(temp);
    end;
    if flipy then putpixel(0,((gfx[ngfx].y-1)-y),gfx[ngfx].x,punbuf,pant_sprites)
      else putpixel(0,y,gfx[ngfx].x,punbuf,pant_sprites);
  end;
end else begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    temp:=punbuf;
    for x:=0 to (gfx[ngfx].x-1) do begin
      punto:=gfx[ngfx].colores[pos^+color];
      if (punto and mask)<>trans then temp^:=paleta[punto]
        else temp^:=paleta[max_colores];
      inc(temp);
      inc(pos);
    end;
    if flipy then putpixel(0,((gfx[ngfx].y-1)-y),gfx[ngfx].x,punbuf,pant_sprites)
      else putpixel(0,y,gfx[ngfx].x,punbuf,pant_sprites);
  end;
end;
end;

procedure put_gfx_sprite_mask_diff(nchar,color:word;flipx,flipy:boolean;ngfx,trans,mask,x_diff,y_diff:byte);
var
  x,y,punto:byte;
  temp:pword;
  pos,post:pbyte;
begin
pos:=gfx[ngfx].datos;
inc(pos,nchar*gfx[ngfx].x*gfx[ngfx].y);
if flipx then begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    post:=pos;
    inc(post,(y*gfx[ngfx].x)+gfx[ngfx].x{%H-}-1);
    temp:=punbuf;
    for x:=(gfx[ngfx].x-1) downto 0 do begin
      punto:=gfx[ngfx].colores[post^+color];
      if (punto and mask)<>trans then temp^:=paleta[punto]
        else temp^:=paleta[max_colores];
      dec(post);
      inc(temp);
    end;
    if flipy then putpixel(0+x_diff,((gfx[ngfx].y-1)-y)+y_diff,gfx[ngfx].x,punbuf,pant_sprites)
      else putpixel(0+x_diff,y+y_diff,gfx[ngfx].x,punbuf,pant_sprites);
  end;
end else begin
  for y:=0 to (gfx[ngfx].y-1) do begin
    temp:=punbuf;
    for x:=0 to (gfx[ngfx].x-1) do begin
      punto:=gfx[ngfx].colores[pos^+color];
      if (punto and mask)<>trans then temp^:=paleta[punto]
        else temp^:=paleta[max_colores];
      inc(temp);
      inc(pos);
    end;
    if flipy then putpixel(0+x_diff,((gfx[ngfx].y-1)-y)+y_diff,gfx[ngfx].x,punbuf,pant_sprites)
      else putpixel(0+x_diff,y+y_diff,gfx[ngfx].x,punbuf,pant_sprites);
  end;
end;
end;

procedure actualiza_gfx_sprite_size_pos(pos_x,pos_y:word;dest:byte;x_size,y_size,ipos_x,ipos_y:word);
var
  origen,destino:sdl_rect;
begin
origen.x:=ipos_x;
origen.y:=ipos_y;
origen.w:=x_size;
origen.h:=y_size;
pos_x:=pos_x and p_final[dest].sprite_mask_x;
if pos_x+origen.w>p_final[dest].sprite_end_x then begin
  destino.x:=32-((p_final[dest].sprite_end_x-pos_x));
end else begin
  destino.x:=pos_x+32;
end;
pos_y:=pos_y and p_final[dest].sprite_mask_y;
if pos_y+origen.h>p_final[dest].sprite_end_y then begin
  destino.y:=32-((p_final[dest].sprite_end_y-pos_y));
end else begin
  destino.y:=pos_y+32;
end;
destino.w:=x_size;
destino.h:=y_size;
SDL_BlitSurface(pantalla[pant_sprites],@origen,pantalla[dest],@destino);
end;

procedure actualiza_gfx_sprite_size(pos_x,pos_y:word;dest:byte;x_size,y_size:word);
var
  origen,destino:sdl_rect;
begin
origen.x:=0;
origen.y:=0;
origen.w:=x_size;
origen.h:=y_size;
pos_x:=pos_x and p_final[dest].sprite_mask_x;
if pos_x+origen.w>p_final[dest].sprite_end_x then begin
  destino.x:=32-((p_final[dest].sprite_end_x-pos_x));
end else begin
  destino.x:=pos_x+32;
end;
pos_y:=pos_y and p_final[dest].sprite_mask_y;
if pos_y+origen.h>p_final[dest].sprite_end_y then begin
  destino.y:=32-((p_final[dest].sprite_end_y-pos_y));
end else begin
  destino.y:=pos_y+32;
end;
destino.w:=x_size;
destino.h:=y_size;
SDL_BlitSurface(pantalla[pant_sprites],@origen,pantalla[dest],@destino);
end;

procedure actualiza_gfx_sprite(pos_x,pos_y:word;dest,ngfx:byte);
var
  origen,destino:sdl_rect;
begin
origen.x:=0;
origen.y:=0;
origen.w:=gfx[ngfx].x;
origen.h:=gfx[ngfx].y;
pos_x:=pos_x and p_final[dest].sprite_mask_x;
if pos_x+origen.w>p_final[dest].sprite_end_x then begin
  destino.x:=32-((p_final[dest].sprite_end_x-pos_x));
end else begin
  destino.x:=pos_x+32;
end;
pos_y:=pos_y and p_final[dest].sprite_mask_y;
if pos_y+origen.h>p_final[dest].sprite_end_y then begin
  destino.y:=32-((p_final[dest].sprite_end_y-pos_y));
end else begin
  destino.y:=pos_y+32;
end;
destino.w:=origen.w;
destino.h:=origen.h;
SDL_BlitSurface(pantalla[pant_sprites],@origen,pantalla[dest],@destino);
end;

procedure actualiza_gfx_sprite_over(pos_x,pos_y:word;dest,ngfx,src_over:byte;scr_x,scr_y:word);
var
  origen,destino:sdl_rect;
begin
origen.x:=0;
origen.y:=0;
origen.w:=gfx[ngfx].x;
origen.h:=gfx[ngfx].y;
pos_x:=pos_x and p_final[dest].sprite_mask_x;
if pos_x+origen.w>p_final[dest].sprite_end_x then begin
  destino.x:=32-((p_final[dest].sprite_end_x-pos_x));
end else begin
  destino.x:=pos_x+32;
end;
pos_y:=pos_y and p_final[dest].sprite_mask_y;
if pos_y+origen.h>p_final[dest].sprite_end_y then begin
  destino.y:=32-((p_final[dest].sprite_end_y-pos_y));
end else begin
  destino.y:=pos_y+32;
end;
destino.w:=origen.w;
destino.h:=origen.h;
SDL_BlitSurface(pantalla[pant_sprites],@origen,pantalla[dest],@destino);
origen.x:=(pos_x+scr_x) and p_final[dest].sprite_mask_x;
origen.y:=(pos_y+scr_y) and p_final[dest].sprite_mask_y;
origen.w:=gfx[ngfx].x;
origen.h:=gfx[ngfx].y;
SDL_BlitSurface(pantalla[src_over],@origen,pantalla[dest],@destino);
end;

//Put pixel basics
procedure putpixel(x,y:word;cantidad:dword;pixel:pword;sitio:byte);
var
   punt:pword;
begin
punt:=pantalla[sitio].pixels;
inc(punt,((y*pantalla[sitio].pitch) shr 1)+x);
copymemory(punt,pixel,cantidad shl 1);
end;

//Draw lines
procedure single_line(x,y,color,longitud:word;pant:byte);
var
  punt:pword;
begin
punt:=pantalla[pant].pixels;
inc(punt,((y*pantalla[pant].pitch) shr 1)+x);
fillword(punt,longitud,paleta[color]);
end;

procedure draw_line(x0,y0,x1,y1:integer;color:word;pant:byte);
var
  dy,dx,stepx,stepy:integer;
  fraction:double;
begin
punbuf^:=paleta[color];
//Metodo Bresenham
dy:=y1-y0;
dx:=x1-x0;
if (dy<0) then begin
  dy:=-dy;
  stepy:=-1;
end else stepy:=1;
if (dx<0) then begin
  dx:=-dx;
  stepx:=-1;
end else stepx:=1;
dy:=dy shl 1; // dy is now 2*dy
dx:=dx shl 1; // dx is now 2*dx
putpixel_gfx_int(x0,y0,1,pant);
if (dx>dy) then begin
  fraction:=dy-(dx/2); // same as 2*dy - dx
  while (x0<>x1) do begin
    if (fraction>=0) then begin
      y0:=y0+stepy;
      fraction:=fraction-dx; // same as fraction -= 2*dx
    end;
    x0:=x0+stepx;
    fraction:=fraction+dy;  // same as fraction -= 2*dy
    putpixel_gfx_int(x0,y0,1,pant);
  end;
end else begin
  fraction:=dx-(dy/2);
  while (y0<>y1) do begin
    if (fraction>=0) then begin
      x0:=x0+stepx;
      fraction:=fraction-dy;
    end;
    y0:=y0+stepy;
    fraction:=fraction+dx;
    putpixel_gfx_int(x0,y0,1,pant);
  end;
end;
end;

//Screen functions
procedure fill_full_screen(screen:byte;color:word);inline;
begin
fillword(pantalla[screen].pixels,pantalla[screen].w*pantalla[screen].h,paleta[color]);
end;

end.
